LPARAM lcGroup,lcBaseName

#DEFINE CRLF CHR(13)+CHR(10)

LOCAL lcPath,lcName,lcData,lcID,lcSpec,llHTML,lcAlias,lcOut,lcAXX
LOCAL ARRAY laLang(4,2)
lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

lcAXX=SYS(2015)

lcCollate=SET("COLLATE")
SET COLLATE TO "MACHINE"

laLang(1,1)="cs"
laLang(1,2)=1250
laLang(2,1)="sk"
laLang(2,2)=1250
laLang(3,1)="fr"
laLang(3,2)=1252
laLang(4,1)="de"
laLang(4,2)=1252

lcName=LOWER(lcGroup)+"_"+LOWER(lcBaseName)

lcOut=lcPath+"..\plug-in\"

* Create header files
lcData=FILETOSTR(lcPath+"base.h")
=STRTOFILE(lcData,lcOut+lcName+".h")


* create PRG file
lcData=FILETOSTR(lcPath+"base.prg")
lcData=STRTRAN(lcData,"%name%",lcName)
lcData=STRTRAN(lcData,"%group%",UPPER(lcGroup))

lcSpec=""
IF FILE(lcPath+lcgroup+".prg")
   lcSpec=FILETOSTR(lcPath+lcgroup+".prg")
ENDIF
DO CASE
   CASE UPPER(lcGroup)="PJXEX"
	    lcID="500 +n"
	    llHTML=.T.


   CASE UPPER(lcGroup)="EFRX"
	    lcID="100+n"
	    llHTML=.T.


   CASE UPPER(lcGroup)="DIAP"
	    lcID="20000+n"
	    llHTML=.T.


   CASE UPPER(lcGroup)="DIAMP"
	    lcID="1+n"
	    llHTML=.T.


   CASE UPPER(lcGroup)="DIAF"
	    lcID="1000+n"
	    llHTML=.T.

   CASE UPPER(lcGroup)="DIAC"
	    lcID="2000+n"
	    llHTML=.T.

   CASE UPPER(lcGroup)="CONV"
 	    lcID="30000+n"


   CASE UPPER(lcGroup)="DCOP"
	    lcID="3000+n"

   CASE UPPER(lcGroup)="AC"
	    lcID="4000+n"

   CASE UPPER(lcGroup)="BC"
	    lcID="5000+n"


   CASE UPPER(lcGroup)="CF"
	    lcID="40000+n"
        
   CASE UPPER(lcGroup)="VF"
	    lcID="50000+n"

   OTHERWISE
        lcID="unknown"

ENDCASE

lcData=STRTRAN(lcData,"%id%",lcID)
lcData=STRTRAN(lcData,"%SPECIAL%",lcSpec)
IF llHTML
   lcData=STRTRAN(lcData,"%HTMLO%",FILETOSTR(lcPath+"htmlo.prg"))
   lcData=STRTRAN(lcData,"%HTMLC%",FILETOSTR(lcPath+"htmlc.prg"))
ELSE
   lcData=STRTRAN(lcData,"%HTMLO%","")
   lcData=STRTRAN(lcData,"%HTMLC%","")
ENDIF
      

=STRTOFILE(lcData,lcOut+lcName+".prg")



* create folder for plugin
IF !DIRECTORY(lcOut+lcName)
   MD (lcOut+lcName)
ENDIF

lcAlias=SYS(2015)
CREATE CURSOR (lcAlias) (XX000 I, XX001 M)
INDEX ON XX000 TAG I01 CANDIDATE
INSERT INTO (lcAlias) (XX000, XX001) VALUES (0,"Plugin Caption")
INSERT INTO (lcAlias) (XX000, XX001) VALUES (-1,"Plugin Description")

* create base table for localized string
FOR lii=1 TO ALEN(laLang,1)
    COPY TO (lcOut+lcName+"\"+laLang(lii,1)) AS (laLang(lii,2)) WITH CDX
NEXT
ZAP

* create table for html's localized string
IF llHTML
   FOR lii=1 TO ALEN(laLang,1)
       COPY TO (lcOut+lcName+"\html_"+laLang(lii,1)) AS (laLang(lii,2)) WITH CDX
   NEXT
ENDIF
USE


* create VCX libraries (main and localized)
COPY FILE (lcpath+"base.vcx") TO (lcOut+lcName+"\"+lcName+".vcx")
COPY FILE (lcpath+"base.vct") TO (lcOut+lcName+"\"+lcName+".vct")

USE (lcOut+lcName+"\"+lcName+".vcx") IN 0 ALIAS (lcAXX)
SELE (lcAXX)
LOCATE FOR CLASS="form" AND BASECLASS="form"
REPL OBJNAME WITH STRTRAN(OBJNAME,"%name%",lcName), ;
     PROPERTIES WITH STRTRAN(PROPERTIES,"%name%",lcName)
     
    
LOCATE FOR CLASS#"form" AND BASECLASS="form"
REPL CLASS WITH STRTRAN(CLASS,"%name%",lcName), ;
     CLASSLOC WITH STRTRAN(CLASSLOC,"%name%",lcName), ;
     OBJNAME WITH STRTRAN(OBJNAME,"%name%",lcName), ;
     PROPERTIES WITH STRTRAN(PROPERTIES,"%name%",lcName)
USE

USE (lcpath+"base_xx.vcx") IN 0 ALIAS (lcAlias)

FOR lii=1 TO ALEN(laLang,1)
    SELE (lcAlias)
    COPY TO (lcOut+lcName+"\"+lcName+"_"+laLang(lii,1)+".vcx") AS (laLang(lii,2)) 

    USE (lcOut+lcName+"\"+lcName+"_"+laLang(lii,1)+".vcx") IN 0 ALIAS (lcAXX)
    SELE (lcAXX)

    LOCATE FOR CLASS#"form" AND BASECLASS="form"
    REPL CLASS WITH STRTRAN(CLASS,"%name%",lcName), ;
         CLASSLOC WITH STRTRAN(CLASSLOC,"%name%",lcName), ;
         OBJNAME WITH STRTRAN(STRTRAN(OBJNAME,"%name%",lcName),"%lang%",laLang(lii,1)), ;
         PROPERTIES WITH STRTRAN(STRTRAN(PROPERTIES,"%name%",lcName),"%lang%",laLang(lii,1))
    USE
NEXT
SELE (lcAlias)
USE

SET COLLATE TO (lcCollate)
