#INCLUDE "diap_pdm_ab.h"

DEFINE CLASS _DIAP_PDM_AB AS _PDM_AB OF AB_Bases.fxp
 NAME            = "_DIAP_PDM_AB"

 ID              = 20002    				&& ID of Plug-in
 TYPE            = "DIAP" 					&&

 gcClass_Setting = "_diap_pdm_ab_par"

 gcSyntax        = ''						&& Storage for syntax part between Parse_Sect und Generate_HTML

 DIMENSION gaPropval[1,4]					&& Storage for property value part between Parse_Sect und Generate_HTML

 gnPropval = 0								&& Number of output values of the property to describe.
 gnOutLine = 0								&& counter for gaPopVal(1,4)

*!*	 PROCEDURE Render  &&Render create plug_ins output
*!*	  PARAMETER;
*!*	   toPar,;
*!*	   toSetting

*!*	  IF TYPE("pld")='U' THEN
*!*	   DEBUG
*!*	   SUSPEND
*!*	  ENDIF &&TYPE("pld")='U'

*!*	RETURN DODEFAULT(toPar,   toSetting)
*!*	endproc
 PROCEDURE GetCaption && Return Caption of Plug-in
  RETURN THIS.GetString(PI_Caption)
 ENDPROC &&GetCaption


 PROCEDURE GetDescription && Return Description of Plug-in
  RETURN THIS.GetString(PI_Description)
 ENDPROC &&GetDescription

 PROCEDURE Parse_Sect  &&Parse for sections
  PARAMETERS;
   tcSource,;
   tcSource_C

  LOCAL;
   lcOuterSection,;
   lcTemp1,;
   lcTemp2,;
   lcTemp3,;
   lcTemp4,;
   lnPrefix,;
   lnLoop1,;
   loMatchPDM

  DIMENSION;
   laSections2(1,4)

  STORE 0 TO;
   THIS.gnPropval,;
   THIS.gnOutLine,;
   THIS.oParser.SeeCount

  STORE "" TO;
   THIS.gcSyntax

  LOCAL;
   loRegExp

*store old settings
  loRegExp        = THIS.goRegExp
  loRegExp.STORE()

  loRegExp.IgnoreCase = .T.
  loRegExp.GLOBAL     = .T.
  loRegExp.MultiLine  = .T.

*Get all Syntax
*i.e. anything in THIS.goSettings.gcSyntax Tags, Default: <Syntax>
  FOR lnLoop1 = 1 TO THIS.Get_Tag(tcSource,THIS.goSettings.gcSyntax,@laSections2,.F.)
   THIS.gcSyntax = THIS.gcSyntax+CRLF+;
    laSections2(lnLoop1,1)
  ENDFOR &&lnLoop1
*Get all Property Values
*i.e. anything in THIS.goSettings.gcPropVal Tags, Default: <propval>
  lnPrefix = 0
  FOR lnLoop1 = 1 TO THIS.Get_Tag(tcSource,THIS.goSettings.gcPropVal,@laSections2,.T.)
   lcOuterSection = laSections2(lnLoop1,1)
   DO CASE
    CASE laSections2(lnLoop1,2)='tag'
*tag version, each tag gives a new value with description
*Get Start Tag
     loRegExp.PATTERN      = "<\s*("+THIS.goSettings.gcPropVal+")(\s[^>]*)?>"
     loMatchPDM            = loRegExp.Execute(lcOuterSection)
     lcTemp1               = loMatchPDM.ITEM(0).VALUE
*Get Attribut (Name)
     lcTemp2               = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcPropValName)

     IF EMPTY(lcTemp2) THEN
*without name will be ignored
      LOOP
     ENDIF &&EMPTY(lcTemp2)

     THIS.gnPropval = THIS.gnPropval+1
     DIMENSION;
      THIS.gaPropval(THIS.gnPropval,4)
*Get Attribut (Direction)
     lcTemp3               = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcPropValDir)
*Get Attribut (Type)
     lcTemp4                = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcPropValType)
*Get Value
*Strip tags
     loRegExp.PATTERN       = "<\s*("+THIS.goSettings.gcPropVal+")(\s[^>]*)?>"
     lcOuterSection         = THIS.goRegExp.REPLACE(lcOuterSection,'')
     loRegExp.PATTERN       = "<\s*\/("+THIS.goSettings.gcPropVal+")\s*>"
     lcTemp1                = THIS.goRegExp.REPLACE(lcOuterSection,'')
*Put Value
     DO CASE
      CASE VAL(lcTemp3)=2
*Outs are topmost as they occur
       THIS.gnOutLine = THIS.gnOutLine + 1
       AINS(THIS.gaPropval,THIS.gnOutLine)
       THIS.gaPropval(THIS.gnOutLine,1) = lcTemp2
       THIS.gaPropval(THIS.gnOutLine,2) = CRLF+lcTemp1
       THIS.gaPropval(THIS.gnOutLine,3) = lcTemp4
       THIS.gaPropval(THIS.gnOutLine,4) = VAL(lcTemp3)
      OTHERWISE
*Ins or in/outs as they occur (add to end)
       THIS.gaPropval(THIS.gnPropval,1) = lcTemp2
       THIS.gaPropval(THIS.gnPropval,2) = CRLF+lcTemp1
       THIS.gaPropval(THIS.gnPropval,3) = lcTemp4
       THIS.gaPropval(THIS.gnPropval,4) = VAL(lcTemp3)
     ENDCASE
    CASE EMPTY(lnPrefix)
*prefix version, only one value with description, this is first prefix => Value
*allways to end (no outs possible)
     THIS.gnPropval = THIS.gnPropval+1
     lnPrefix  = THIS.gnPropval
     DIMENSION;
      THIS.gaPropval(THIS.gnPropval,4)
     THIS.gaPropval(lnPrefix,1) = ALLTRIM(lcOuterSection)
     THIS.gaPropval(lnPrefix,2) = ""
     THIS.gaPropval(lnPrefix,3) = ""
     THIS.gaPropval(lnPrefix,4) = 0
    OTHERWISE
*prefix version, only one value with description, this is prefix line >1 => description
     THIS.gaPropval(lnPrefix,2) = THIS.gaPropval(1,2)+CRLF+;
      ALLTRIM(lcOuterSection)
   ENDCASE
  ENDFOR &&lnLoop1

  THIS.gcSyntax    = SUBSTR(THIS.gcSyntax,3)
  FOR lnLoop1 = 1 TO THIS.gnPropval
   THIS.gaPropval(lnLoop1,2) = SUBSTR(THIS.gaPropval(lnLoop1,2),3)
  ENDFOR &&lnLoop1

*Get all remaining information
*that is - all what is not a prefixed line
*          and outside a tag

*Remove all Syntax
*i.e. anything in THIS.goSettings.gcSyntax Tags, Default: <Syntax>
  tcSource =  THIS.Remove_Tag(tcSource,THIS.goSettings.gcSyntax)
*Remove all Property Values
*i.e. anything in THIS.goSettings.gcPropVal Tags, Default: <propval>
  tcSource =  THIS.Remove_Tag(tcSource,THIS.goSettings.gcPropVal)

*restore old settings
  loRegExp.RESTORE()

*Remainig will be parsed in parent
  RETURN DODEFAULT(tcSource,tcSource_C)
 ENDPROC &&Parse_Sect

 PROCEDURE Generate_HTML  &&Generates HTML Output for Render by previously paresd information
  LOCAL;
   lcHTML

  lcHTML = ''

*Description.
  IF LEN(STRTRAN(THIS.gcDescr,CRLF,""))>0 THEN
   lcHTML = THIS.Sect_Description()+lcHTML
  ENDIF &&LEN(STRTRAN(this.gcDescr,CRLF ...

  DO CASE
   CASE THIS.gnPropval>0
    lcHTML = lcHTML+THIS.Sect_PropVal()
   CASE LEN(STRTRAN(THIS.gcSyntax,CRLF,""))>0
*Syntax only if no PropVal, if Propval it will be created from it
    lcHTML = lcHTML+THIS.Sect_Syntax(THIS.gcSyntax)
  ENDCASE

*Remarks
  IF LEN(STRTRAN(THIS.gcRemark,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Remark()
  ENDIF &&LEN(STRTRAN(THIS.gcRemark,CRLF ...

*Example
  IF LEN(STRTRAN(THIS.gcExample,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Example()
  ENDIF &&LEN(STRTRAN(this.gcExample,CRLF ...

*Others
  IF LEN(STRTRAN(THIS.gcOther,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Others()
  ENDIF &&LEN(STRTRAN(this.gcOther,CRLF ...

*see also
  IF THIS.gnSeeAlso+THIS.gnToSeeAlso>0 THEN
   lcHTML = lcHTML+THIS.Sect_SeeAlso()
  ENDIF &&THIS.gnSeeAlso+THIS.gnToSeeAlso>0

*Changes
  IF THIS.gnChange>0 THEN
   lcHTML = lcHTML+THIS.Sect_Change()
  ENDIF &&THIS.gnChange>0

*Copyright
  IF LEN(STRTRAN(THIS.gcCopyRight,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_CopyRight()
  ENDIF &&LEN(STRTRAN(this.gcCopyRight,CRLF ...

*Footer
  THIS.Sect_Footer()

  RETURN lcHTML
 ENDPROC &&Generate_HTML

 PROCEDURE Sect_Syntax		&&create HTML section syntax from Syntax tag
  PARAMETERS;
   tcSyntax

  LOCAL;
   lcReturn,;
   llTemp1

  llTemp1       = THIS.glXHTML
  THIS.glXHTML  = .T.
  lcReturn      =;
   [  <div class=" ]+THIS.goSettings.gcCSS_Syntax_Plain+["><!-- Syntax Begin -->]+CRLF+;
   THIS.Get_SyntaxColor(tcSyntax,2)+CRLF+;
   [  </div><!-- Syntax End -->]+CRLF
*  lcReturn      =;
[  <div class=" ]+THIS.goSettings.gcCSS_Syntax_Plain+["><!-- Syntax Begin -->]+CRLF+;
THIS.ParseText([<]+THIS.goSettings.gcExpr+[>]+tcSyntax+[<\]+THIS.goSettings.gcExpr+[>])+CRLF+;
[  </div><!-- Syntax End -->]+CRLF
  THIS.glXHTML  = llTemp1
  RETURN lcReturn
 ENDPROC &&Sect_Syntax

 PROCEDURE Sect_PropVal		&&create HTML section syntax section from propval
  LOCAL;
   lcTemp1,;
   lcTemp2,;
   lcVal,;
   lcPrefix,;
   lcOut,;
   lcIn,;
   lcValTD,;
   lcAncor,;
   lcReturn,;
   lnWidthIn,;
   lnWidthOut,;
   lnWidth,;
   lnLoop1,;
   llWithOut,;
   llWithIn

  STORE 0 TO;
   lnWidthIn,;
   lnWidthOut

  STORE "" TO;
   lcTemp1,;
   lcTemp2,;
   lcVal

  STORE [  ] TO;		&&Just to format html
  lcOut,;
   lcIn,;
   lcValTD

  lcPrefix = ''
  llWithOut = !EMPTY(THIS.gnOutLine)
  llWithIn  = THIS.gnOutLine<THIS.gnPropval

  lnWidth = IIF(llWithOut AND llWithIn,80,160)

  FOR lnLoop1 = 1 TO THIS.gnPropval
*old Version of anchor could be to long
*    lcAncor = lcLink+THIS.gaPropval(lnLoop1,1)
*we can do the following here, because we never crosslink int
   lcAncor = SYS(2015)
*First Part: Syntax Line
   IF THIS.gaPropval(lnLoop1,4)=2 THEN
* Output Value of Property
    lcTemp1    = lcTemp1+[<a href="#]+lcAncor+[">]+THIS.gaPropval(lnLoop1,1)+[</a>]
    lnWidthOut = lnWidthOut+LEN(THIS.gaPropval(lnLoop1,1))
    IF lnWidthOut>lnWidth THEN
     lcOut      = lcOut+CRLF+lcPrefix	&&+[<br /><!-- Linebreak in Syntax-->]
     lnWidthOut = LEN(THIS.gaPropval(lnLoop1,1))
    ENDIF &&lnWidthOut>lnWidth
    lcOut      = lcOut+lcTemp1
    lcTemp1    = CRLF+lcPrefix+[<wbr />&brvbar;&nbsp;]
    lnWidthOut = lnWidthOut+3
   ELSE &&THIS.gaPropval(lnLoop1,4)
* Input Value of Property
    lcTemp2   = lcTemp2+[<a href="#]+lcAncor+[">]+THIS.gaPropval(lnLoop1,1)+[</a>]
    lnWidthIn = lnWidthIn+LEN(THIS.gaPropval(lnLoop1,1))
    IF lnWidthIn>lnWidth THEN
     lcIn      = lcIn+CRLF+lcPrefix+[<br /><!-- Linebreak in Syntax-->]
     lnWidthIn = LEN(THIS.gaPropval(lnLoop1,1))
    ENDIF &&lnWidthIn>lnWidth
    lcIn      = lcIn+lcTemp2
    lcTemp2   = CRLF+lcPrefix+[<wbr />&brvbar;&nbsp;]
    lnWidthIn = lnWidthIn+3
   ENDIF &&THIS.gaPropval(lnLoop1,4)

*Second Part Propval Section
*First name
   lcVal = lcVal+;
    [   <dt class="]+THIS.goSettings.gcCSS_PropVal_List_dt+[">]+CRLF+;
    [    <a class="]+THIS.goSettings.gcCSS_PropVal_dd_Name+[" id="]+lcAncor+[" name="]+lcAncor+[">]+CRLF+;
    [     ]+THIS.gaPropval(lnLoop1,1)+CRLF+;
    [    </a>]+CRLF+;
    [   </dt>]+CRLF+;
    [   <dd class="]+THIS.goSettings.gcCSS_PropVal_List_dd+[">]+CRLF
*Second Table with Type or we have both in and output
*Uses Subclasses of CSS class diap_pdm_ab_val
   lcVal = lcVal+;
    [    <table class=" ]+THIS.goSettings.gcCSS_PropVal_dd_TInfo+[">]+CRLF+;
    [     <colgroup>]+CRLF+;
    [      <col class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_ColInfo+[" />]+CRLF+;
    [      <col class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_ColDescr+[" />]+CRLF+;
    [     </colgroup>]+CRLF+;
    [     <tbody>]+CRLF
   IF !EMPTY(THIS.gaPropval(lnLoop1,3)) THEN
    lcVal = lcVal+;
     [      <tr>]+CRLF+;
     [       <td class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_CellInfo+[">]+;
     THIS.GetHTMLString(PI_HTML_Type)+[</td>]+CRLF+;
     [       <td class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_CellDescr+[">]+;
     THIS.gaPropval(lnLoop1,3)+[</td>]+CRLF+;
     [      <tr>]+CRLF
   ENDIF &&!EMPTY(THIS.gaPropval(lnLoop1,3))
   lcVal = lcVal+;
    [      <tr>]+CRLF+;
    [       <td class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_CellInfo+[">]+;
    THIS.GetHTMLString(PI_HTML_Direction)+[</td>]+CRLF+;
    [       <td class="]+THIS.goSettings.gcCSS_PropVal_dd_TInfo_CellDescr+[">]+;
    IIF(THIS.gaPropval(lnLoop1,4)=0,;
    THIS.GetHTMLString(PI_HTML_Direction_IO),;
    IIF(THIS.gaPropval(lnLoop1,4)=2,;
    THIS.GetHTMLString(PI_HTML_Direction_Out),;
    THIS.GetHTMLString(PI_HTML_Direction_In)))+[</td>]+CRLF+;
    [      <tr>]+CRLF
   lcVal = lcVal+;
    [     </tbody>]+CRLF+;
    [    </table>]+CRLF
   IF !EMPTY(THIS.gaPropval(lnLoop1,2)) THEN
    lcVal = lcVal+;
     [    <span class="]+THIS.goSettings.gcCSS_PropVal_dd_Detail+[">]+CRLF+;
     THIS.ParseText(THIS.gaPropval(lnLoop1,2))+CRLF+;
     [   </span>]+CRLF
   ENDIF &&!EMPTY(THIS.gaPropval(lnLoop1,2))
   lcVal = lcVal+;
    [   </dd>]+CRLF
  ENDFOR &&lnLoop

  lcReturn = ;
   [ <div class="]+THIS.goSettings.gcCSS_Syntax_PV+["><!-- Syntax Begin --><div class="]+;
   THIS.goSettings.gcCSS_Syntax_PV_SColor+[">]+CRLF
  IF llWithOut THEN
   lcReturn = lcReturn+;
    [  <div class="]+THIS.goSettings.gcCSS_Syntax_PV_OutPut+[">]+CRLF+;
    [   ]+lcOut+[&nbsp;]+CRLF+;
    [  </div><div class="]+THIS.goSettings.gcCSS_Syntax_PV_OutSign+[">=</div>]+;
    [  <div class="]+THIS.goSettings.gcCSS_Syntax_PV_PEM+[">]+CRLF+;
    [   ]
  ELSE &&llWithOut
   lcReturn = lcReturn+;
    [  <div class="]+THIS.goSettings.gcCSS_Syntax_PV_PEM+[">]+CRLF+;
    [   ]
  ENDIF &&llWithOut
  lcReturn = lcReturn+;
   [Object.]+THIS.gcActivePEM
  IF llWithIn THEN
   lcReturn = lcReturn+;
    CRLF+;
    [  </div>]+CRLF+;
    [  <div class="]+THIS.goSettings.gcCSS_Syntax_PV_InSign+[">=</div>]+CRLF+;
    [  <div class="]+THIS.goSettings.gcCSS_Syntax_PV_Input+[">]+CRLF+;
    [   ]+lcIn+CRLF
  ELSE &&llWithIN
   lcReturn = lcReturn+;
    CRLF+;
    [  </div>]+CRLF+;
    [  <div>&nbsp;</div>]+CRLF+;
    [  <div>]+CRLF+;
    [   &nbsp;&nbsp;]
  ENDIF &&llWithIN
  lcReturn = lcReturn+CRLF+;
   [  </div>]+CRLF+;
   [  <div style="clear: both"></div>]+CRLF+;
   [ </div></div><!-- Syntax End -->]+CRLF+CRLF

  lcReturn = lcReturn+;
   [ <div class="]+THIS.goSettings.gcCSS_PropVal+["><!-- Propval Begin -->]+CRLF+;
   [  <span class="]+THIS.goSettings.gcCSS_PropVal_Head+[">]+CRLF+;
   [   ]+THIS.GetHTMLString(PI_HTML_Value)+CRLF+;
   [  </span>]+CRLF+;
   [  <dl class="]+THIS.goSettings.gcCSS_PropVal_List+[">]+CRLF+;
   lcVal+CRLF+;
   [  </dl>]+CRLF+;
   [ </div><!-- Propval End -->]+CRLF+CRLF
  RETURN lcReturn
 ENDPROC &&Sect_PropVal




   PROCEDURE QuickAnalyse(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,lcFile,lcFileX,lcClass,lcPEM,loPDM,lii
      LOCAL ARRAY laProperties(100,3)
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      IF loPDM.CreateAnchorsForAllProperties<>2 && if set 0 or 1 then return
         RETURN
      ENDIF

      SELE (This.Alias)
      STORE loPar.File TO lcFile,lcFileX
      LOCATE FOR UPPER(ALLTRIM(CFILE))==UPPER(lcFileX)
      IF !FOUND()
          lcFileX=ExtractFileFromFile(lcFileX)
          LOCATE FOR UPPER(ALLTRIM(CFILE))==UPPER(lcFileX)
      ENDIF
      lii=0
      * read only properties
      SCAN FOR UPPER(ALLTRIM(CFILE))==UPPER(lcFileX) AND ATC("</propval>",MHTML)>0 REST
           lii=lii+1
           IF MOD(lii,100)=0
              DIMENSION laProperties(lii+100,3)
           ENDIF

           laProperties(lii,1)=lcFile
           IF EMPTY(MPARENT)
              laProperties(lii,2)=""
              laProperties(lii,3)=CPEM
           ELSE
              lcClass=ALLTRIM(MPARENT)+"."+ALLTRIM(CPEM)
              laProperties(lii,3)=SUBS(lcClass,RAT(".",lcClass,1)+1)
              laProperties(lii,2)=LEFT(lcClass,RAT(".",lcClass,1)-1)
           ENDIF

           SELE (This.Alias)
      ENDSCAN
      IF lii>0
         DIMENSION laProperties(lii,3)
         =loPDMs.EnablePAnchors(@laProperties)
      ENDIF

      RETURN .T.
   ENDPROC

*!*	   PROCEDURE QuickAnalyse(loPar,loSetting)
*!*	      * loPar     - Object of parameters
*!*	      * loSetting - Settings's object of plug-in
*!*	      LOCAL loPDMs,lcFile,lcFileX,lcClass,lcPEM,loPDM,liDS
*!*	      loPDMs=EVAL(This.PDMs)
*!*	      loPDM=EVAL(This.PDM)
*!*	      IF loPDM.CreateAnchorsForAllProperties<>2 && if set 0 or 1 then return
*!*	         RETURN
*!*	      ENDIF

*!*	      liDS=This.DataSessionID
*!*	      SELE (This.Alias)
*!*	      STORE UPPER(loPar.File) TO lcFile,lcFileX
*!*	      LOCATE FOR UPPER(ALLTRIM(CFILE))==lcFileX
*!*	      IF !FOUND()
*!*	          lcFileX=ExtractFileFromFile(lcFileX)
*!*	          LOCATE FOR UPPER(ALLTRIM(CFILE))==lcFileX
*!*	      ENDIF
*!*	      * read only properties
*!*	      SCAN FOR UPPER(ALLTRIM(CFILE))==lcFileX AND ATC("</propval>",MHTML)>0 REST
*!*	           IF EMPTY(MPARENT)
*!*	              lcClass=""
*!*	              lcPem=UPPER(CPEM)
*!*	           ELSE
*!*	              lcClass=ALLTRIM(MPARENT)+"."+ALLTRIM(CPEM)
*!*	              lcPem=UPPER(SUBS(lcClass,RAT(".",lcClass,1)+1))
*!*	              lcClass=UPPER(LEFT(lcClass,RAT(".",lcClass,1)-1))
*!*	           ENDIF

*!*	           *_pdms::EnablePAnchor()
*!*	           SET DATASESSION TO (m.loPDMs.DataSessionID)
*!*	           liSele=SELE() && Zapamatuj si oblast
*!*	           SELE (m.loPDMs.Anchors) && Pak jej uzavi
*!*	           SET ORDER TO "I02"
*!*	           SET KEY TO (PADL(SYS(2007,lcFile),6)+PADL(SYS(2007,lcClass),6)+PADL(SYS(2007,lcPEM),6))
*!*	           LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcPEM 
*!*	           IF FOUND()
*!*	              REPL PFLAG WITH .T.
*!*	           ENDIF
*!*	           SET ORDER TO "I01"
*!*	           SELE (liSele) && Sko na pvodn oblast
*!*	           SET DATASESSION TO (liDS)
*!*	           SELE (This.Alias)
*!*	      ENDSCAN
*!*	      RETURN .T.
*!*	   ENDPROC



   PROCEDURE CheckPropertyFlag(loPar,loSetting) && 
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      DEBUGOUT loPar.File+" "+loPar.cParent+" "+loPar.cPEM
      RETURN .T.
   ENDPROC


ENDDEFINE &&_DIAP_PDM_AB

***************************************************************
DEFINE CLASS _DIAP_PDM_AB_par AS _pdm_ab_par OF AB_Bases.fxp && Settings for plug-in
 NAME                       = [_DIAP_PDM_AB_par]

*files
 gcCSS                      = [diap_pdm_ab.css]				&& Relative to plug in

*Properties that are special for this plug_in
*tags that will create a group and their attributes
*newly defined part
 gcSyntax                   = [syntax]						&& plain syntax (old style)
 gcPropVal                  = [propval]						&& variable description of property
 gcPropValName              = [name]						&& Attribute of Propval tag Name of Property Value
 gcPropValDir               = [dir]							&& Attribute of Propval tag Direction of Value 1=IN,2=Out Default Out, not noted both
 gcPropValType              = [type]						&& Attribute of Propval tag Type of Property Value

*css classes
*inherited part

*newly defined part
 gcCSS_Syntax_Plain         = [DIAP_PDM_AB_Syntax]			&& CSS Class to format syntax of PEM from syntax section

 gcCSS_Syntax_PV            = [DIAP_PDM_AB_Syntax]			&& CSS Class to format property value
 gcCSS_Syntax_PV_Head       = [PDM_AB_Head]					&& CSS Class to format property value; Head
 gcCSS_Syntax_PV_SColor     = [SColor]						&& CSS Class to format property syntax; wrapping table
 gcCSS_Syntax_PV_OutPut     = [Output]						&& CSS Class to format syntax column "OutValue"
 gcCSS_Syntax_PV_OutSign    = [OutputEq]					&& CSS Class to format syntax column "PEM"
 gcCSS_Syntax_PV_PEM        = [PEM]							&& CSS Class to format syntax column "InValue"
 gcCSS_Syntax_PV_InSign     = [InputEq]						&& CSS Class to format syntax table cell "OutValue"
 gcCSS_Syntax_PV_Input      = [Input]						&& CSS Class to format syntax table cell "PEM"

 gcCSS_PropVal                    = [DIAP_PDM_AB_PropVal]			&& CSS Class to format syntax of PEM
 gcCSS_PropVal_Head               = [PDM_AB_Head]					&& CSS Class to format property value, header
 gcCSS_PropVal_List               = [DIAP_PDM_AB_PropVal_List]		&& CSS Class to format property value, definition list; expression to define
 gcCSS_PropVal_List_dt            = [dt_]							&& CSS Class to format property value, definition list; definition of expression
 gcCSS_PropVal_List_dd            = [dd_]							&& CSS Class to format property value, definition list
 gcCSS_PropVal_dd_Name            = [DIAP_PDM_AB_PropVal_ValName]	&& CSS Class to format property value, Name of value
 gcCSS_PropVal_dd_TInfo           = [Val_Info]						&& CSS Class to format property value; table extended Information
 gcCSS_PropVal_dd_TInfo_ColInfo   = [ColumnValue]					&& CSS Class to format property value; table extended Information; column Info
 gcCSS_PropVal_dd_TInfo_ColDescr  = [ColumnData]					&& CSS Class to format property value; table extended Information; column description
 gcCSS_PropVal_dd_TInfo_CellInfo  = [CellValue]						&& CSS Class to format property value; table extended Information; column Info
 gcCSS_PropVal_dd_TInfo_CellDescr = [CellData]						&& CSS Class to format property value; table extended Information; column description
 gcCSS_PropVal_dd_Detail          = [Val_Detail]					&& CSS Class to format property syntax;; long description

 PROCEDURE INIT
  PARAMETERS;
   toParent
  DODEFAULT(toParent)
  WITH THIS
   .gcSections = .gcSections+[|]+.gcSyntax+[|]+.gcPropVal
  ENDWITH &&THIS
 ENDPROC &&init

* Nate nastaven
 PROCEDURE File_Load && Load settings
  PARAMETERS;
   tcFile,;
   tcSection
* tcFile     - PDM File
* loSettings - Object of settings

  DODEFAULT(tcFile,tcSection)

  LOCAL;
   lcSection

  WITH THIS
   .gcSyntax                         = .GetINIString(tcSection,[SYNTAX]                        ,.gcSyntax                        ,tcFile)
   .gcPropVal                        = .GetINIString(tcSection,[PROPVAL]                       ,.gcPropVal                       ,tcFile)
   .gcPropValName                    = .GetINIString(tcSection,[PName]                         ,.gcPropValName                   ,tcFile)
   .gcPropValDir                     = .GetINIString(tcSection,[PDir]                          ,.gcPropValDir                    ,tcFile)
   .gcPropValType                    = .GetINIString(tcSection,[PType]                         ,.gcPropValType                   ,tcFile)

   lcSection                         = tcSection+'_CSS'

   .gcCSS_Syntax_Plain               = .GetINIString(lcSection,[CSS_Syntax_Plain]              ,.gcCSS_Syntax_Plain              ,tcFile)
   .gcCSS_Syntax_PV                  = .GetINIString(lcSection,[CSS_Syntax_PV]                 ,.gcCSS_Syntax_PV                 ,tcFile)
   .gcCSS_Syntax_PV_Head             = .GetINIString(lcSection,[CSS_Syntax_PV_Head]            ,.gcCSS_Syntax_PV_Head            ,tcFile)
   .gcCSS_Syntax_PV_SColor           = .GetINIString(lcSection,[CSS_Syntax_PV_OuterTable]      ,.gcCSS_Syntax_PV_SColor          ,tcFile)
   .gcCSS_Syntax_PV_OutPut           = .GetINIString(lcSection,[CSS_Syntax_PV_OutCol]          ,.gcCSS_Syntax_PV_OutPut          ,tcFile)
   .gcCSS_Syntax_PV_OutSign          = .GetINIString(lcSection,[CSS_Syntax_PV_PEMCol]          ,.gcCSS_Syntax_PV_OutSign         ,tcFile)
   .gcCSS_Syntax_PV_PEM              = .GetINIString(lcSection,[CSS_Syntax_PV_InCol]           ,.gcCSS_Syntax_PV_PEM             ,tcFile)
   .gcCSS_Syntax_PV_InSign           = .GetINIString(lcSection,[CSS_Syntax_PV_OutCell]         ,.gcCSS_Syntax_PV_InSign          ,tcFile)
   .gcCSS_Syntax_PV_Input            = .GetINIString(lcSection,[CSS_Syntax_PV_PEMCell]         ,.gcCSS_Syntax_PV_Input           ,tcFile)

   .gcCSS_PropVal                    = .GetINIString(lcSection,[CSS_PropVal]                   ,.gcCSS_PropVal                   ,tcFile)
   .gcCSS_PropVal_Head               = .GetINIString(lcSection,[CSS_PropVal_Head]              ,.gcCSS_PropVal_Head              ,tcFile)
   .gcCSS_PropVal_List               = .GetINIString(lcSection,[CSS_PropVal_List]              ,.gcCSS_PropVal_List              ,tcFile)
   .gcCSS_PropVal_List_dt            = .GetINIString(lcSection,[CSS_PropVal_List_dt]           ,.gcCSS_PropVal_List_dt           ,tcFile)
   .gcCSS_PropVal_List_dd            = .GetINIString(lcSection,[CSS_PropVal_List_dd]           ,.gcCSS_PropVal_List_dd           ,tcFile)
   .gcCSS_PropVal_dd_Name            = .GetINIString(lcSection,[CSS_PropVal_dd_Name]           ,.gcCSS_PropVal_dd_Name           ,tcFile)
   .gcCSS_PropVal_dd_TInfo           = .GetINIString(lcSection,[CSS_PropVal_dd_TInfo]          ,.gcCSS_PropVal_dd_TInfo          ,tcFile)
   .gcCSS_PropVal_dd_TInfo_ColInfo   = .GetINIString(lcSection,[CSS_PropVal_dd_TInfo_ColInfo]  ,.gcCSS_PropVal_dd_TInfo_ColInfo  ,tcFile)
   .gcCSS_PropVal_dd_TInfo_ColDescr  = .GetINIString(lcSection,[CSS_PropVal_dd_TInfo_ColDescr] ,.gcCSS_PropVal_dd_TInfo_ColDescr ,tcFile)
   .gcCSS_PropVal_dd_TInfo_CellInfo  = .GetINIString(lcSection,[CSS_PropVal_dd_TInfo_CellInfo] ,.gcCSS_PropVal_dd_TInfo_CellInfo ,tcFile)
   .gcCSS_PropVal_dd_TInfo_CellDescr = .GetINIString(lcSection,[CSS_PropVal_dd_TInfo_CellDescr],.gcCSS_PropVal_dd_TInfo_CellDescr,tcFile)
   .gcCSS_PropVal_dd_Detail          = .GetINIString(lcSection,[CSS_PropVal_dd_Detail]         ,.gcCSS_PropVal_dd_Detail         ,tcFile)

   .gcSections = .gcSections+[|]+.gcSyntax+[|]+.gcPropVal
  ENDWITH &&THIS
  RETURN _PDM_OK
 ENDPROC &&File_Load

* Ulo nastaven
 PROCEDURE File_Save && Save settings
  PARAMETERS;
   tcFile,;
   tcSection
* tcFile     - PDM File
* loSettings - Object of settings

  DODEFAULT(tcFile,tcSection)

  LOCAL;
   lcSection

  WITH THIS
   = WriteINIString(tcSection,[SYNTAX]                        ,ALLTRIM(.gcSyntax)                        ,@tcFile)
   = WriteINIString(tcSection,[PROPVAL]                       ,ALLTRIM(.gcPropVal)                       ,@tcFile)
   = WriteINIString(tcSection,[PName]                         ,ALLTRIM(.gcPropValName)                   ,@tcFile)
   = WriteINIString(tcSection,[PDir]                          ,ALLTRIM(.gcPropValDir)                    ,@tcFile)
   = WriteINIString(tcSection,[PType]                         ,ALLTRIM(.gcPropValType)                   ,@tcFile)

   lcSection = tcSection+'_CSS'

   = WriteINIString(lcSection,[CSS_Syntax_Plain]              ,ALLTRIM(.gcCSS_Syntax_Plain)              ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV]                 ,ALLTRIM(.gcCSS_Syntax_PV)                 ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_Head]            ,ALLTRIM(.gcCSS_Syntax_PV_Head)            ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_OuterTable]      ,ALLTRIM(.gcCSS_Syntax_PV_SColor)          ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_OutCol]          ,ALLTRIM(.gcCSS_Syntax_PV_OutPut)          ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_PEMCol]          ,ALLTRIM(.gcCSS_Syntax_PV_OutSign)         ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_InCol]           ,ALLTRIM(.gcCSS_Syntax_PV_PEM)             ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_OutCell]         ,ALLTRIM(.gcCSS_Syntax_PV_InSign)          ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_PV_PEMCell]         ,ALLTRIM(.gcCSS_Syntax_PV_Input)            ,@tcFile)

   = WriteINIString(lcSection,[CSS_PropVal]                   ,ALLTRIM(.gcCSS_PropVal)                   ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_Head]              ,ALLTRIM(.gcCSS_PropVal_Head)              ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_List]              ,ALLTRIM(.gcCSS_PropVal_List)              ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_List_dt]           ,ALLTRIM(.gcCSS_PropVal_List_dt)           ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_List_dd]           ,ALLTRIM(.gcCSS_PropVal_List_dd)           ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_Name]           ,ALLTRIM(.gcCSS_PropVal_dd_Name)           ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_TInfo]          ,ALLTRIM(.gcCSS_PropVal_dd_TInfo)          ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_TInfo_ColInfo ] ,ALLTRIM(.gcCSS_PropVal_dd_TInfo_ColInfo)  ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_TInfo_ColDescr] ,ALLTRIM(.gcCSS_PropVal_dd_TInfo_ColDescr) ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_TInfo_CellInfo ],ALLTRIM(.gcCSS_PropVal_dd_TInfo_CellInfo) ,@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_TInfo_CellDescr],ALLTRIM(.gcCSS_PropVal_dd_TInfo_CellDescr),@tcFile)
   = WriteINIString(lcSection,[CSS_PropVal_dd_Detail]         ,ALLTRIM(.gcCSS_PropVal_dd_Detail)         ,@tcFile)
  ENDWITH &&THIS
  RETURN _PDM_OK
 ENDPROC &&File_Save

 PROCEDURE CloneSettings && Clone values properties of settings
  PARAMETERS;
   toSrc,;
   toDst
* toSrc - Source object
* toDst - Destination object

  DODEFAULT(toSrc,toDst)

  WITH toSrc
   toDst.gcSyntax                         = .gcSyntax
   toDst.gcPropVal                        = .gcPropVal
   toDst.gcPropValName                    = .gcPropValName
   toDst.gcPropValDir                     = .gcPropValDir
   toDst.gcPropValType                    = .gcPropValType


   toDst.gcCSS_Syntax_Plain               = .gcCSS_Syntax_Plain
   toDst.gcCSS_Syntax_PV                  = .gcCSS_Syntax_PV
   toDst.gcCSS_Syntax_PV_Head             = .gcCSS_Syntax_PV_Head
   toDst.gcCSS_Syntax_PV_SColor           = .gcCSS_Syntax_PV_SColor
   toDst.gcCSS_Syntax_PV_OutPut           = .gcCSS_Syntax_PV_OutPut
   toDst.gcCSS_Syntax_PV_OutSign          = .gcCSS_Syntax_PV_OutSign
   toDst.gcCSS_Syntax_PV_PEM              = .gcCSS_Syntax_PV_PEM
   toDst.gcCSS_Syntax_PV_InSign           = .gcCSS_Syntax_PV_InSign
   toDst.gcCSS_Syntax_PV_Input            = .gcCSS_Syntax_PV_Input

   toDst.gcCSS_PropVal                    = .gcCSS_PropVal
   toDst.gcCSS_PropVal_Head               = .gcCSS_PropVal_Head
   toDst.gcCSS_PropVal_List               = .gcCSS_PropVal_List
   toDst.gcCSS_PropVal_List_dt            = .gcCSS_PropVal_List_dt
   toDst.gcCSS_PropVal_List_dd            = .gcCSS_PropVal_List_dd
   toDst.gcCSS_PropVal_dd_Name            = .gcCSS_PropVal_dd_Name
   toDst.gcCSS_PropVal_dd_TInfo           = .gcCSS_PropVal_dd_TInfo
   toDst.gcCSS_PropVal_dd_TInfo_ColInfo   = .gcCSS_PropVal_dd_TInfo_ColInfo
   toDst.gcCSS_PropVal_dd_TInfo_ColDescr  = .gcCSS_PropVal_dd_TInfo_ColDescr
   toDst.gcCSS_PropVal_dd_TInfo_CellInfo  = .gcCSS_PropVal_dd_TInfo_CellInfo
   toDst.gcCSS_PropVal_dd_TInfo_CellDescr = .gcCSS_PropVal_dd_TInfo_CellDescr
   toDst.gcCSS_PropVal_dd_Detail          = .gcCSS_PropVal_dd_Detail
  ENDWITH &&toSrc
 ENDPROC &&CloneSettings
ENDDEFINE &&_DIAP_PDM_AB_par
