#INCLUDE "efrx_ereports.h"
#INCLUDE "../prgs/main.h"

*****************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_EFRX_ereports",lcCollate)

*******************************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language
LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_EFRX_EREPORTS_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_EFRX_EREPORTS_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


**********************************************************************
DEFINE CLASS _EFRX_ereports AS _pdm_PlugIn && 
   Name="_EFRX_ereports"

   ID=102         && ID of Plug-in
   Type="EFRX" && 


   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "eReports")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in for processing eReports metadata in column COMMENT report/label.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,lix,;
            lcComment,lcRow,liz,lcOutline,lcReport,lcSP,llExpr,;
            lcURHREF,llExtract,liy,lix,lcAHREF,lcPom

      LOCAL ARRAY laRows(1),laPars(1)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      
      STORE "" TO lcHTML,lcOutline,lcURHREF

      lcComment=loPar.Ram.COMMENT

      * Hyperlink
      ***********

      *-1 Derive the prefix from the link.
      *   Tries to determine if the link needs a "mailto:" or "http://" prefix.
      *   Numeric. (default) 
      * 0 None. Do not add a prefix to the link. Numeric. 
      * 1 Add an "http://" prefix to the link. Numeric. 
      * 2 Add an "mailto:" prefix to the link. Numeric. 
      * 3 Add an "file://" prefix to the link. Numeric. 
      * 4 Add an "https://" prefix to the link. Numeric. 
      * cPrefix Specify a particular web hyperlink prefix to use. Character. 


      *:WWW_LINK ( "www.dbx-tech.com" )
      *:WWW_LINK ( mailto:bgates@microsoft.com" 
      *:WWW_LINK ( cust.email, 2 )
      *:WWW_LINK ( cust.email + "?subject=Response", "mailto:" )
      *:WWW_LINK ( cust.website, -1 ) 


      * Outline
      *************
      *:OUTLINE ( cEvent, cTitleExpr, cName, cParentName, nSort, cSortExpr )
      *
      * cEvent - Name of the event or band that occurs to trigger the outline. cEvent Description 
      *  Start        Occurs at the beginning of each document. Primarily used for creating static outline elements. 
      *  Title        Occurs when the Title band is rendered. 
      *  PageHeader   Occurs when the Page Header band is rendered. 
      *  ColumnHeader Occurs when the Column Header band is rendered. 
      *  GroupHeadern Where n referes to the group number, occurs when the Group Header n band is rendered. 
      *  Detail       Occurs when the Detail band is rendered. 
      *  GroupFootern Where n referes to the group number, occurs when the Group Footer n band is rendered. 
      *  ColumnFooter Occurs when the Column Footer band is rendered. 
      *  PageFooter   Occurs when the Page Footer band is rendered. 
      *  Summary      Occurs when the Summary band is rendered. 
 
      * cTitleExpr - Character expression to evaluate as the outline element's title or caption. 

      * cName - Optional name to assign to this outline event. This is so child elements can reference this element as its parent. 

      * cParentName - Optional name of a parent element to place this elemet under. If these elements are to be placed in the highest level of the outline heirarchy, use the expression "ROOT".  

      * nSort - Optional. Determines if any child elements associated with this element are to be sorted nSort Description 
      *   1 Sort ascending (default) 
      *  -1 Sort descending 
 
      * cSortExpr - Optional expression to use for sorting. If no value is specified, the cTitleExpr determines the sort order.  
  
      * Example: In this example, a root outline element with the caption "Dealers" will be created with a list of dealer name elements as its child elements: 
      * *:OUTLINE ( "Start", "Dealers", "xDealers", "ROOT", 1 )
      * *:OUTLINE ( "GroupHeader1", dlr_nme, "", "xDealers", 1, UPPER(dlr_nme) )

 
     
      liCount=ALINES(laRows,lcComment)
      lcComment=""
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))

          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          llExtract=.F.
          IF UPPER(SUBST(lcRow,liz,10))=="*:WWW_LINK"
             llExtract=.T.
             IF LEN(lcURHREF)=0
                liy=AT_Ex(@lcRow,"(",liz+10) && Najdi (
                lcRow=SUBS(lcRow,liy+1)
                liy=RAT(")",lcRow)
                lcRow=ALLT(IIF(liy>0,LEFT(lcRow,liy-1),lcRow))

                * localize second parameter
                liy=RFindMDSC(@lcRow,",",LEN(lcRow),1)
                IF liy=0
                   * second parametr is default (-1)
                   lcPom=lcRow && Hyperlink
                   lcSP="-1"
                ELSE
                   lcPom=RTRIM(LEFT(lcRow,liy-1)) && Hyperlink
                   lcSP=LTRIM(SUBST(lcRow,liy+1))
                ENDIF

                llExpr=TYPE(lcPom)="U" && Njak pm odkaz
                lcRow=lcPom

                IF !llExpr
                   lcPom=ALLT(EVAL(lcPom))

                   liy=AT(":",lcPom)
                   lcAHREF=UPPER(LEFT(lcRow,liy-1))

                   IF lcSP="-1"
                      IF EMPTY(lcAHREF) && Not defined
                         liy=AT(".",lcPom)
                         liz=AT("@",lcPom)
                         lix=OCCURS(".",lcPom)

                         IF liz=0
                            lcPom="http://"+lcPom
                         ELSE
                            IF lix=1 AND liy>liz OR lix=2 AND liy<liz AND AT(".",lcPom,2)>liz
                               lcPom="mailto:"+lcPom
                            ENDIF
                         ENDIF
                      ENDIF
                   ELSE
                      IF EMPTY(lcAHREF) && Not defined
                         lcPom=IIF(lcSP="0","",;
                               IIF(lcSP="1","http://",;
                               IIF(lcSP="2","mailto://",;
                               IIF(lcSP="3","file://",;
                               IIF(lcSP="4","https://",lcSP)))))+lcPom

                      ENDIF
                   ENDIF
                   lcURHREF=[<a href="]+lcPom+[">]+lcPom+[</a>]
                ELSE
                   lcPom=m.loPDM.Expr2xhtml(@lcPom)+m.loPDM.aSpace(21)

                   lcURHREF=[<table style="margin: 0px 0px 0px 0px"><tbody>]+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(1)+[<tr><td>]+lcPom+[</td><td class="efrx_ereports_td_lp">]+lcSP+[</td></tr>]+m.loPDM.aSpace(21)+;
                            [</tbody></table>]+m.loPDM.aSpace(21)
                ENDIF
             ENDIF
          ELSE
             IF UPPER(SUBST(lcRow,liz,9))=="*:OUTLINE"
                IF LEN(lcOutline)=0
                   liy=AT_Ex(@lcRow,"(",liz+10) && Najdi (
                   lcRow=SUBS(lcRow,liy+1)
                   liy=RAT(")",lcRow)
                   lcRow=STRTRAN(ALLT(IIF(liy>0,LEFT(lcRow,liy-1),lcRow)),",",CRLF)
                   
                   liy=ALINES(laPars,lcRow)

      * *:OUTLINE ( "Start", "Dealers", "xDealers", "ROOT", 1 )
      * *:OUTLINE ( "GroupHeader1", dlr_nme, "", "xDealers", 1, UPPER(dlr_nme) )



                   IF liy>0
                      lcOutline=[<table padding="1" style="margin: 0px 0px 0px 0px;"><tbody>]+m.loPDM.aSpace(21)+;
                                m.loPDM.aSpace(1)+[<tr>]+;
                                [<td>]+laPars(1)+[</td>]
                      IF liy>1
                         lcOutline=lcOutline+[<td>]+;
                                   m.loPDM.Expr2xhtml(laPars(2))+[</td>]
                      ENDIF

                      IF liy>2
                         lcOutline=lcOutline+[<td>]+laPars(3)+[</td>]
                      ENDIF
                      IF liy>3
                         lcOutline=lcOutline+[<td>]+laPars(4)+[</td>]
                      ENDIF
                      IF liy>4
                         lcOutline=lcOutline+[<td>]+laPars(5)+[</td>]
                      ENDIF
                      IF liy>5
                         lcOutline=lcOutline+[<td>]+;
                                   m.loPDM.Expr2xhtml(laPars(6))+[</td>]
                      ENDIF


                      lcOutline=lcOutline+[</tr>]+m.loPDM.aSpace(21)+;
                                [</tbody></table>]+m.loPDM.aSpace(21)
                   ENDIF
                ELSE
                   llExtract=.T.
                ENDIF
             ENDIF
          ENDIF

          IF !llExtract
             lcComment=lcComment+lcRow+CRLF
          ENDIF
      NEXT

      IF LEN(lcURHREF)>0 OR LEN(lcOutline)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[<table><tbody>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURHREF)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_ereports_td_bold">]+This.GetHTMLString(PI_HTML_Hyperlink)+[</td><td>]+lcURHREF+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcOutline)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_ereports_td_bold efrx_ereports_td_top">]+This.GetHTMLString(PI_HTML_Outline)+[</td><td>]+lcOutline+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF


      IF LEN(lcURHREF)>0 OR LEN(lcOutline)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[</tbody></table>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcHTML)>0
         lcHTML=m.loPDM.aSpace(1)+"<hr>"+m.loPDM.aSpace(21)+lcHTML
      ENDIF

      loPar.Ram.COMMENT=lcComment

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_EFRX_ereports_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF

         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Hyperlink, "Hyperlink:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Outline, "Outline:")
            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

******************************************************
DEFINE CLASS _EFRX_ereports_par AS _pdm_PlugIn_Parameter
   Name="_EFRX_ereports_par"
   DIME aCSS(1),aJS(1)
   OK=.F.
 
   CSS="efrx_ereports.css" && Relative to efrx_xfrx.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE
