#INCLUDE "sc_mhhtml.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_sc_mhhtml",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_sc_mhhtml_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_sc_mhhtml_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _sc_mhhtml AS _pdm_PlugIn && 
   Name="_sc_mhhtml"

   ID=40000         && ID of Plug-in
   Type="CF" && Typ of plug-in (group)

   SCByRow=.F. && Syntax Coloring By Row
   AddedEnterByRow=.F. && If plugin added CRLF for each singlerow

   Setting=.NULL.
   Par=.NULL.
   Alias=""
  
   oHTML=.NULL.
   SCCSS="css/sc.css" && Odkaz na definici styl pro Syntax Coloring

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load basic PRG library with mhhtmlcode
      IF ATC(lcFile+".FXP",SET("PROCEDURE"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET PROCEDURE TO (lcPath+lcFile+"\mhhtmlcode.prg") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
            SET PROCEDURE TO (lcPath+lcFile+"\mhhtmlcode.fxp") ADDITIVE
            =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
            IF loPDMs.nErr#0
               RETURN .F.
            ENDIF
        
         ENDIF
      ENDIF


      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "MHHTMLCode for PDM")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, "Syntax Coloring based on MHHTMLCODE by Mike Helland")

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      RETURN ""
   ENDPROC

   PROCEDURE Code2xhtml(lcText,lcMeta,m.XXMI,m.XXMC) && Convert source code to xhtml
      * lcText - Source code
      loPDMs=EVAL(This.PDMs)
      t1=SECONDS()
      lcXHTML=This.oHTML.PRGToHTML(@lcText,@lcMeta,@m.XXMI,@m.XXMC)
      t2=SECONDS()
      DEBUGOUT "Up"+STR(t2-t1,17,6)+" Inner"+STR(This.oHTML.nSeconds,17,6)
      RETURN lcXHTML
*!*	      RETURN This.oHTML.PRGToHTML(@lcText,@lcMeta,@m.XXMI,@m.XXMC)
   ENDPROC

   PROCEDURE Expr2xhtml(lcText) && Convert Expression to HTML
      * lcText  - Source code
      RETURN This.oHTML.PRGToHTML(@m.lcText,"0")
   ENDPROC


   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_sc_mhhtml_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.SyntaxColoring=GetINIInt(lcSection,"SyntaxColoring",loSettings.SyntaxColoring,@lcFile)
      loSettings.SCFile=GetINIString(lcSection,"SCFile",loSettings.SCFile,254,@lcFile)
      loSettings.BaseCSS=GetINIString(lcSection,"BaseCSS",loSettings.BaseCSS,254,@lcFile)
      loSettings.EnhancedKeywordsSC=GetINIInt(lcSection,"EnhancedKeywordsSC",loSettings.EnhancedKeywordsSC,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"SyntaxColoring",STR(loSettings.SyntaxColoring,1),@lcFile)
      =WriteINIString(lcSection,"SCFile",ALLT(loSettings.SCFile),@lcFile)
      =WriteINIString(lcSection,"BaseCSS",SYS(2014,FULLPATH(ALLT(loSettings.BaseCSS),This.MainPath),This.MainPath),@lcFile)
      =WriteINIString(lcSection,"EnhancedKeywordsSC",STR(loSettings.EnhancedKeywordsSC,1),@lcFile)

      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      loDst.SyntaxColoring=loSrc.SyntaxColoring
      loDst.SCFile=loSrc.SCFile
      loDst.BaseCSS=loSrc.BaseCSS
      loDst.EnhancedKeywordsSC=loSrc.EnhancedKeywordsSC
   ENDPROC


   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL lcPath,loPDMs,llRet,loPDM
      loPDMs=EVAL(This.PDMs)
      lcPath=This.MainPath
      * Open table with META Data

      This.Alias=SYS(2015)
      llRet=loPDMs.OpenTable(This.DataSessionID,lcPath+"sc_mhhtml\words.dbf",This.Alias,"NOUPDATE ORDER revword AGAIN")=0
      IF llRet
         IF ISNULL(This.oHTML)
            This.oHTML=CREATEOBJECT("pdm_htmlcode")
         ENDIF

         loPDM=EVAL(This.PDM)
         loSetting=loPDM.PlugIns.GetSetting(This.ID)
         This.oHTML.EnhancedSC=loSetting.EnhancedKeywordsSC

         This.oHTML.AdoptCursor(m.This.Alias) && Pipoj tabulku klovch slov
      ENDIF
      RETURN llRet
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      LOCAL loPDMs
      loPDMs=EVAL(This.PDMs)
      =loPDMs.CloseTable(This.DataSessionID,This.Alias)
      RETURN .T.
   ENDPROC


   PROCEDURE GetTag(lcTag, liType) && Return TAG
      DO CASE
         CASE lcTag=="Comment"
              RETURN IIF(liType=_PDM_SC_BT,"<span class='PDMCom'>","</span>")
 
      ENDCASE
      RETURN ""
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody

      LOCAL lcTag,loRam,loPDMs,loPDM,luCatch
      LOCAL ARRAY laSC(12,2)
      lcTag="span"
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      * Fill global properties on PDMs Object
      loPDMs.SC_Code=[<pre class="PDMCODE PDMNor" ] && Poten tag pro zdrojov kd
      loPDMs.SC_Code_Close=[</pre>] && Ukonujc tag pro zdrojov kd
      loPDMs.SC_Expr=[<div class="PDMEXPR PDMNor" ] && Poten tag pro vraz
      loPDMs.SC_Expr_Close=[</div>] && Ukonujc tag pro vraz
      loPDMs.SC_Expr_1=[<div class="PDMEXPR PDMNor" style="display: inline;" ] && Poten tag pro vraz
      loPDMs.SC_Expr_1_Close=[</div>] && Ukonujc tag pro vraz
      loPDMs.SC_Expr_2=[<span class="PDMEXPR PDMNor" ] && Poten tag pro vraz
      loPDMs.SC_Expr_2_Close=[</span>] && Ukonujc tag pro vraz


      * Create CSS File
      * Vytvo extern soubor CSS pro Syntax Coloring
      IF INLIST(loSetting.SyntaxColoring,PI_SC_PDM,PI_SC_VFP)
         lcFile=loPDM.OutDir+m.This.SCCSS
         lihFile=m.loPDMs.FCreate(lcFile)
      ENDIF
       
      DO CASE
         CASE loSetting.SyntaxColoring=PI_SC_PDM AND lihFile>0
              luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
              lcString=FILETOSTR(IIF(AT("\\",loSetting.BaseCSS)>0 OR AT(":",loSetting.BaseCSS)>0,"",This.MainPath)+loSetting.BaseCSS)
              =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
              IF loPDMs.nErr#0
                 lcString=""
              ENDIF


         CASE loSetting.SyntaxColoring=PI_SC_VFP AND lihFile>0
              lcString=;
                       [.PDMCODE {]+CRLF+;
                       [font-family: "Monospace","Courier New"; font-size:10pt;]+CRLF+;
                       [color:#000000;]+CRLF+;
                       [padding: 0.5em 0.5em 0.5em 0.5em;]+CRLF+;
                       [margin: 0px;]+CRLF+;
                       [}]+CRLF+;
                       CRLF+;
                       [.PDMEXPR {]+CRLF+;
                       [font-family: "Monospace","Courier New"; font-size:10pt;]+CRLF+;
                       [color:#000000;]+CRLF+;
                       [border-color:#000000;]+CRLF+;
                       [border-width:1px;]+CRLF+;
                       [border-style:solid;]+CRLF+;
                       [padding:1px;]+CRLF+;
                       [margin: 0px;]+CRLF+;
                       [}]+CRLF+;
                       CRLF+;
                       [.PDMCnt {font-family:"Monospace","Courier New";font-size:0.9em;font-weight:bold; color:#000000;}]+CRLF+;
                       [.PDMInd {font-family:"Monospace","Courier New";font-size:0.9em;font-weight:bold; color:#000000;}]+CRLF


              laSC(1,1)="Comment"
              laSC(1,2)="PDMCom"
              laSC(2,1)="Keyword"
              laSC(2,2)="PDMRes"
              laSC(3,1)="Keyword"
              laSC(3,2)="PDMResK"
              laSC(4,1)="Keyword"
              laSC(4,2)="PDMResF"
              laSC(5,1)="Keyword"
              laSC(5,2)="PDMResP"
              laSC(6,1)="Keyword"
              laSC(6,2)="PDMResM"
              laSC(7,1)="Keyword"
              laSC(7,2)="PDMResE"
              laSC(8,1)="Variable"
              laSC(8,2)="PDMVar"
              laSC(9,1)="String"
              laSC(9,2)="PDMStr"
              laSC(10,1)="Constant"
              laSC(10,2)="PDMLit"
              laSC(11,1)="Normal"
              laSC(11,2)="PDMNor"
              laSC(12,1)="Operator"
              laSC(12,2)="PDMOper"
              liCount=ALEN(laSC,1)
        
              liHKEY=0
              * Otevi kl v Registry
              IF API_RegOpenKeyEx(HKEY_CURRENT_USER,"Software\Microsoft\VisualFoxPro\"+;
                                  m.loPDMs.VFPVers+".0\Options"+CHR(0),@m.liHKEY)=REGAPI_SUCCESS

                 FOR lii=1 TO liCount
                     liStyle=-1
                     STORE "" TO lcBC,lcFC
                     lcData=SPACE(254)
                     * Nati data hodnoty Editor????????Color
                     IF API_RegQueryValueEx(liHKEY,"Editor"+laSC(lii,1)+"Color"+CHR(0),REG_SZ,@m.lcData,254)=REGAPI_SUCCESS
                        lcData=NullTermined(lcData)
                        =m.loPDMs.ParseSCColor(@m.lcData,@m.lcFC,@m.lcBC) && Zjisti barvy
                     ENDIF

                     lcData=SPACE(254)
                     * Nati data hodnoty Editor???????Style
                     IF API_RegQueryValueEx(liHKEY,"Editor"+laSC(lii,1)+"Style"+CHR(0),REG_SZ,@m.lcData,254)=REGAPI_SUCCESS
                        liStyle=VAL(NullTermined(lcData)) && Styl
                     ENDIF

                     IF liStyle>-1 OR !EMPTY(lcFC)
                        lcString=lcString+;
                                 [.]+laSC(lii,2)+[ {font-family:"Monospace","Courier New";font-size:0.9em;]+;
                                 IIF(liStyle=1 OR liStyle=3,[ font-weight:bold;],'')+;
                                 IIF(liStyle=2 OR liStyle=3,[ font-style:italic;],'')+;
                                 IIF(lcFC#"AUTO",[ color:#]+lcFC+[;],'')+;
                                 IIF(lcBC#"AUTO",[ background-color:#]+lcBC+[;],'')+'}'+CRLF
                     ENDIF
                 NEXT

                 * Uzavi kl
                 =API_RegCloseKey(liHKEY)
              ENDIF

         CASE loSetting.SyntaxColoring=PI_SC_Custom
              * copy user css file to loPDM.OutDir+"css"
              luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
              lcXX200=IIF(AT("\\",loSetting.SCFile)>0 OR AT(":",loSetting.SCFile)>0,"",ExtractPathFromFile(loPDM.PDM_File))+loSetting.SCFile+CHR(0)
              lcXX205=loPDM.OutDir+"css\"+ExtractFileFromFile(loSetting.SCFile)+CHR(0)
              =CopyFile(@lcXX200,@lcXX205,0) && Pekopruj soubor do reposite
              =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
              loSetting.aCSS(1)=loPDM.OutDir+"css\"+ExtractFileFromFile(loSetting.SCFile)

      ENDCASE

      IF INLIST(loSetting.SyntaxColoring,PI_SC_PDM,PI_SC_VFP)
         IF lihFile>0
            loSetting.aCSS(1)=lcFile
            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcFile))
         ENDIF
      ENDIF


      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _sc_mhhtml_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_sc_mhhtml_par"
   OK=.F.
   DIME aCSS(1)
   
   SyntaxColoring=PI_SC_PDM && Pznak SyntaxColoring ()
   SCFile="" && External file for Syntax Coloring
   EnhancedKeywordsSC=0
   BaseCSS="sc_mhhtml\base.css" && Base CSS for Syntax Coloring - PDM
   
 
ENDDEFINE

