#INCLUDE "dbc.h"

**************************************************************************
** Nzev programu: xDFO.PRG
** Verze: 0.0.1
** Datum vytvoen: 2002-06-14
** Popis: Procedury pro nativn pstup k vlastnostem objekt v DBC konteineru
** Author: Martina Jindrov
** E-mail: martin.jindra@egservis.cz


******************************************************************************************
* Vrt hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_GetIDObject(lcAlias,lcType,lcObjName)
* lcAlias   - Alias otevenho DBC konteineru
* lcType    - Typ objektu
* lcObjName - Nzev objektu

SELE (lcAlias) && sko na DBC konteiner
IF INLIST(lcType,_DBC_Field,_DBC_Index)
   LOCAL lcParent,lii,lcObj
   lii=AT(".",m.lcObjName) && najdi teku
   lcParent=PADR(UPPER(LEFT(m.lcObjName,lii-1)),128)
   lcObj=PADR(UPPER(SUBST(m.lcObjName,lii+1)),128)
   * najdi parenta
   LOCATE FOR INLIST(ObjectType,_DBC_Table,_DBC_View) AND UPPER(ObjectName)==m.lcParent  AND ! DELE()
   IF FOUND() && pokud si ho nael
      lii=ObjectID
      * nyn hledej dany objekt
      LOCATE FOR ParentID=m.lii AND ObjectType==m.lcType AND UPPER(ObjectName)==m.lcObj AND ! DELE()
   ENDIF
ELSE
   LOCATE FOR ObjectType==m.lcType AND UPPER(ObjectName)==PADR(UPPER(m.lcObjName),128) AND ! DELE()
ENDIF
RETURN IIF(FOUND(),ObjectID,_DBC_ObjectNotFound)
ENDPROC


******************************************************************************************
* Vrt hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_GetProperty(lcAlias,liIDObject,liIDProp,luValue)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* liIDProp   - ID vlastnosti
* @luValue   - Promnn, do kter se vrt hodnota

LOCAL liStart,liLen,liLenID,llFound
liStart=1 && nastav prvn pozici

SELE (lcAlias) && sko na DBC konteiner
LOCATE FOR ObjectID=m.liIDObject && najdi objekt
IF !FOUND() && pokud nenael
   RETURN _DBC_ObjectNotFound && pak vypadni
ENDIF
DO WHILE liStart<=LEN(Property)
   liLen=C4ToI(SUBS(Property,m.liStart,4)) && zjisti kompletn dlku 
   liLenID=IIF(C2ToI(SUBS(Property,m.liStart+4,2))>256,2,1)

   IF IIF(m.liLenID=1,ASC(SUBS(Property,m.liStart+4+2,m.liLenID)),C2ToI(SUBS(Property,m.liStart+4+2,m.liLenID)))=m.liIDProp
      * prove konverzi vlastnosti na hodnotu
      luValue=DBC_ConvertPropertyToValue(m.liIDProp, SUBS(Property,m.liStart+3+2+m.liLenID+1,m.liLen-(3+2+m.liLenID+1)) )
      llFound=.T. && nastav pznak, e vlastnost nael
      EXIT
   ENDIF
   liStart=m.liStart+m.liLen
ENDDO
IF !llFound && pokud ji nenael
   luValue=DBC_GetDefaultValue(m.liIDProp)
ENDIF

RETURN _DBC_ObjectFound
ENDPROC


******************************************************************************************
* Nastav hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_SetProperty(lcAlias,liIDObject,liIDProp,luValue)
* lcAlias    - Alias otevenho DBC konteineru
* liIDObject - ID objektu
* liIDProp   - ID vlastnosti
* luValue   - hodnota

LOCAL liStart,liLen,liLenID
liStart=1 && Nastav prvn pozici

SELE (lcAlias) && Sko na DBC konteiner
LOCATE FOR ObjectID=liIDObject && Najdi objekt
IF !FOUND() && Pokud nenael
   RETURN _DBC_ObjectNotFound && Pak vypadni
ENDIF

luValue=DBC_ConvertValueToProperty(liIDProp,luValue) && Prove konverzi hodnoty na vlastnost
DO WHILE liStart<=LEN(Property)
   liLen=C4ToI(SUBS(Property,liStart,4)) && Zjisti kompletn dlku
   liLenID=IIF(C2ToI(SUBS(Property,liStart+4,2))>256,2,1) && Toto je dlka ID vlastnosti

   * Je to dan vlastnost ?
   IF IIF(liLenID=1,ASC(SUBS(Property,liStart+4+2,liLenID)),C2ToI(SUBS(Property,liStart+4+2,liLenID)))=liIDProp
      REPL Property WITH STUFF(Property,liStart,liLen,IToC4(4+2+liLenID+LEN(luValue))+IToC2(IIF(liIDProp>256,2,1))+IIF(liIDProp>256,IToC2(liIDProp),CHR(liIDProp))+luValue)
      RETURN _DBC_ObjectFound
   ENDIF
   liStart=liStart+liLen
ENDDO
REPL Property WITH Property+IToC4(4+2+IIF(liIDProp>256,2,1)+LEN(luValue))+IToC2(IIF(liIDProp>256,2,1))+IIF(liIDProp>256,IToC2(liIDProp),CHR(liIDProp))+luValue
RETURN _DBC_ObjectFound
ENDPROC

******************************************************************************************
* provede konverzi hodnoty vlastnosti na hodnotu
******************************************************************************************
PROCEDURE DBC_ConvertPropertyToValue(liIDProp,lcValue)
* liIDProp - ID vlastnosti
* lcValue  - Hodnota vlastnosti

RETURN IIF(INLIST(m.liIDProp,_DBCID_ChildTag,_DBCID_ParentTable,_DBCID_ParentTag,_DBCID_DBCEventFileName,_DBCID_Comment,_DBCID_ConnectName),LEFT(m.lcValue,LEN(m.lcValue)-1),;
       IIF(m.liIDProp=_DBCID_SubType,ASC(m.lcValue),;
       IIF(INLIST(m.liIDProp,_DBCID_DBCEvents,_DBCID_AllowSimultaneousFetch,_DBCID_DisconnectRollback),ASC(m.lcValue)=1,m.lcValue)))

ENDPROC

******************************************************************************************
* provede konverzi hodnoty na hodnotu vlastnosti
******************************************************************************************
PROCEDURE DBC_ConvertValueToProperty(liIDProp,luValue)
* liIDProp - ID vlastnosti
* luValue  - Hodnota

RETURN IIF(INLIST(m.liIDProp,_DBCID_ChildTag,_DBCID_ParentTable,_DBCID_ParentTag,_DBCID_DBCEventFileName,_DBCID_Comment,_DBCID_ConnectName),m.luValue+CHR(0),;
       IIF(m.liIDProp=_DBCID_SubType,CHR(m.luValue),;
       IIF(INLIST(m.liIDProp,_DBCID_DBCEvents,_DBCID_AllowSimultaneousFetch,_DBCID_DisconnectRollback),IIF(m.luValue,CHR(1),CHR(0)),m.luValue)))

ENDPROC


******************************************************************************************
* Vrt defaultn hodnotu 
******************************************************************************************
PROCEDURE DBC_GetDefaultValue(liIDProp)
* liIDProp - ID vlastnosti

RETURN IIF(INLIST(m.liIDProp,_DBCID_ChildTag,_DBCID_ParentTable,_DBCID_ParentTag,_DBCID_DBCEventFileName,_DBCID_Comment,_DBCID_ConnectName),"",;
       IIF(m.liIDProp=_DBCID_SubType,1,;
       IIF(INLIST(m.liIDProp,_DBCID_DBCEvents,_DBCID_AllowSimultaneousFetch,_DBCID_DisconnectRollback),.F.,.NULL.)))
ENDPROC
