**************************************************************************
** Nzev programu: File.PRG
** Verze: 1.0.4
** Datum vytvoen: 2004-09-16
** Popis: Procedury pro prc s nzvy soubor a cest
** Author: Martina Jindrov
** E-mail: martin.jindra@egservis.cz
**

#DEFINE FILE_ATTRIBUTE_READONLY  0x01
#DEFINE FILE_ATTRIBUTE_HIDDEN    0x02
#DEFINE FILE_ATTRIBUTE_SYSTEM    0x04
#DEFINE FILE_ATTRIBUTE_DIRECTORY 0x10
#DEFINE FILE_ATTRIBUTE_ARCHIVE   0x20
#DEFINE FILE_ATTRIBUTE_NORMAL    0x80
#DEFINE FILE_ATTRIBUTE_TEMPORARY 0x0100

******************************************************************************
PROCEDURE File_WINAPIInit()
DECLARE STRING  PathSkipRoot IN shlwapi.dll String @
DECLARE INTEGER RemoveDirectory IN kernel32 String @lpszPath
DECLARE INTEGER DeleteFile      IN kernel32 String @lpszFile
DECLARE INTEGER CopyFile IN KERNEL32 STRING @lpExistingFileName, STRING @lpNewFileName, INTEGER
DECLARE INTEGER SetLastError IN kernel32 Integer fdwError
DECLARE INTEGER GetDriveType IN kernel32 String lpszRootPathName
DECLARE INTEGER GetTempPath  IN kernel32 integer,String @
DECLARE Integer PathRelativePathTo IN Shlwapi.DLL String @ , String @ ,Integer , String @ ,Integer
DECLARE Integer PathCanonicalize IN Shlwapi.DLL String @ , String @
ENDPROC

******************************************************************************
* Vrt cestu z umstn a nzvu souboru
******************************************************************************
PROCEDURE ExtractPathFromFile(lcFile)
* lcFile - cesta+ nzev souboru
LOCAL lii
lii=RAT("\",m.lcFile)
RETURN LEFT(m.lcFile,IIF(m.lii=0,RAT("/",m.lcFile),m.lii))
ENDPROC

******************************************************************************
* Vrt soubor (i s pponou) z umstn a nzvu souboru
******************************************************************************
PROCEDURE ExtractFileFromFile(lcFile)
* lcFile - cesta+ nzev souboru
LOCAL lii
lii=RAT("\",m.lcFile)
RETURN SUBS(m.lcFile,IIF(m.lii=0,RAT("/",m.lcFile),m.lii)+1)
ENDPROC

******************************************************************************
* Vrt soubor (bez ppony) z umstn a nzvu souboru
******************************************************************************
PROCEDURE ExtractShortFileFromFile(lcFile)
* lcFile - cesta+ nzev souboru, nebo jen nzev souboru
LOCAL lii,lcSFile
lii=RAT("\",m.lcFile) && hledej oddlova
lcSFile=IIF(m.lii>0,SUBS(m.lcFile,lii+1),m.lcFile) && pak to ozni
lii=RAT(".",m.lcSFile) && hledej teku
RETURN IIF(m.lii>0,LEFT(m.lcSFile,m.lii-1),m.lcSFile)
ENDPROC

******************************************************************************
* Vymn nzev souboru (bez ppony) za jin v umstn a nzvu souboru
******************************************************************************
PROCEDURE ChangeShortFileFromFile(lcFile,lcNewFile)
* lcFile    - cesta+ nzev souboru, nebo jen nzev souboru
* lcNewFile - nov nzev souboru (bez cesty)
LOCAL lii,lcSFile
lii=RAT("\",m.lcFile) && hledej oddlova
lcSFile=IIF(m.lii>0,SUBS(m.lcFile,m.lii+1),m.lcFile) && pak to ozni
lcFile=IIF(m.lii>0,LEFT(m.lcFile,m.lii),"")  && ponech si zde cestu
lii=RAT(".",m.lcSFile) && hledej teku
RETURN m.lcFile+m.lcNewFile+IIF(m.lii>0,SUBS(m.lcSFile,m.lii),"")
ENDPROC

******************************************************************************
* Pipoj text k nzvu souboru (ped pponu)
******************************************************************************
PROCEDURE AppendShortFileFromFile(lcFile,lcAppend)
* lcFile    - cesta+ nzev souboru, nebo jen nzev souboru
* lcAppend  - text, kter se m pipojit
LOCAL lii,lcSFile
lii=RAT("\",m.lcFile) && hledej oddlova
lcSFile=IIF(m.lii>0,SUBS(m.lcFile,m.lii+1),m.lcFile) && pak to ozni
lcFile=IIF(m.lii>0,LEFT(m.lcFile,m.lii),"")  && ponech si zde cestu
lii=RAT(".",m.lcSFile) && hledej teku
RETURN m.lcFile+IIF(m.lii>0,LEFT(m.lcSFile,m.lii-1)+m.lcAppend+SUBS(m.lcSFile,m.lii),m.lcSFile+m.lcAppend)
ENDPROC

******************************************************************************
* Vrt root z umstn a nzvu souboru
******************************************************************************
PROCEDURE ExtractRootFromFile(lcFile)
* lcFile - cesta nebo cesta+ nzev souboru
LOCAL lii,lcRoot,lcSubPath
lcRoot=AddBackSlashInPath(ALLT(m.lcFile))
lcSubPath=PathSkipRoot((lcRoot+CHR(0))) && vymkni znho sub cestu
lii=LEN(m.lcSubPath) && zjisti dlku subcesty
RETURN LEFT(m.lcRoot,LEN(m.lcRoot)-m.lii-IIF(m.lii=0,0,1))
ENDPROC

******************************************************************************
* Vrt pponu souboru z umstn a nzvu souboru
******************************************************************************
PROCEDURE ExtractExtensionFromFile(lcFile)
* lcFile - cesta+ nzev souboru, nebo jen nzev souboru
LOCAL lii,lcSFile
lii=RAT("\",m.lcFile) && hledej oddlova
lcSFile=IIF(m.lii>0,SUBS(m.lcFile,m.lii+1),m.lcFile) && pak to ozni
lii=RAT(".",m.lcSFile) && hledej teku
RETURN IIF(m.lii>0,SUBS(m.lcSFile,m.lii+1),"")
ENDPROC

******************************************************************************
* Vymn pponu souboru v umstn a nzvu souboru za jinou
******************************************************************************
PROCEDURE ChangeExtensionFromFile(lcFile,lcNewExt)
* lcFile   - cesta+ nzev souboru, nebo jen nzev souboru
* lcNewExt - nov extension
LOCAL lii
lii=RAT(".",m.lcFile) && hledej teku
RETURN IIF(m.lii>0,LEFT(m.lcFile,m.lii)+m.lcNewExt,m.lcFile+'.'+m.lcNewExt)
ENDPROC

******************************************************************************
* Odstran backslash z cesty, pokud je
******************************************************************************
PROCEDURE RemoveBackSlashFromPath(lcPath)
* lcFile - cesta+ nzev souboru
lcPath=ALLT(m.lcPath)
RETURN IIF(RIGHT(m.lcPath,1)="\",LEFT(m.lcPath,LEN(m.lcPath)-1),m.lcPath)
ENDPROC

******************************************************************************
* Pid backslash k cest, pokud nen
******************************************************************************
PROCEDURE AddBackSlashInPath(lcPath)
* lcPath - cesta
RETURN IIF(EMPTY(m.lcPath),m.lcPath,m.lcPath+IIF(RIGHT(m.lcPath,1)#"\","\",""))
ENDPROC


******************************************************************************
* Zalo adres
******************************************************************************
PROCEDURE Mkd(lcPath)
* lcPath -  cesta
LOCAL lcPom,lcDriveRoot,lii,lcErr,liErr

lcPath=ALLT("&lcPath") && preventivn odstra makra

IF DIRECTORY(m.lcPath) && pokud dan cesta existuje
   RETURN 1 && pak se vra 
ENDIF

* patrn nejde o UNC nebo DOS cestu s diskem
IF !(LEFT(m.lcPath,2)="\\" OR SUBS(m.lcPath,2,1)=":")
   lcPom=ALLTRIM(SET("PATH")) && vra nastaven PATH a oe mezery
   IF LEFT(m.lcPath,1)="\" && jde o cestu z rootu, pak musm pidat jen disk (server+sdlen disk)
      IF LEFT(m.lcPom,2)="\\" && jde o UNC cestu
         lii=AT("\",m.lcPom,4) && najdi 4. oddlova
         IF lii>0 && pokud tam je
            lcPom=LEFT(m.lcPom,m.lii-1) && pak nati cestu bez oddlovae
         ENDIF
       ELSE
         * jinak jde o DOS cestu
         lcPom=LEFT(m.lcPom,2)
       ENDIF
   ELSE
      IF RIGHT(m.lcPom,1)#"\" && pokud na konci nen oddlova
         lcPom=m.lcPom+"\" && pak ho tam pidej
      ENDIF
   ENDIF
   lcPath=m.lcPom+m.lcPath && seti novou cestu
ENDIF

IF LEFT(m.lcPath,2)#"\\" && pokud to je DOS cesta
   lcDriveRoot=LEFT(m.lcPath,2)+"\" && vem si disk
   IF INLIST(GetDriveType(m.lcDriveRoot+CHR(0)),0,5) && Disk neexistuje, nebo je to CD-ROM
      RETURN 4  && vra se
   ENDIF
ENDIF

lcErr=ON("ERROR")
liErr=0
ON ERROR liErr=ERROR()
MD (m.lcPath) && zalo cestu
IF !EMPTY(m.lcErr)
   ON ERROR &lcErr.
ELSE
   ON ERROR
ENDIF

* pokud nen chyba, pak vra 0
* pstup zamtnut
* invalid path or name
RETURN IIF(m.liErr=0,0,;
      IIF(m.liErr=1705,2,;
      IIF(m.liErr=202,3,3)))  && vra pznak chyb
ENDPROC


******************************************************************************
* Zkopruje obsah adrese do jinho adrese
******************************************************************************
PROCEDURE CopyDirectory(lcSource,lcDest,llChild,llLower)
* lcSource - Zdrojov adres
* lcDest   - Clov adres
* llChild  - Pznak, koprovn podadres
* llLower  - Pznak, zda se maj nzvy adres a soubor pevst na mal psmena
IF PCOUNT()=2 && pokud nen tet parametr
   llChild=.T. && pak nastav pznak koprovn Child Adres
ENDIF
LOCAL lcSourceN,lcDestN,lic,lierr,lierrx,lii,loDir,lcFSource,lcFDest
LOCAL ARRAY laDir(1)

lcSource=ALLT("&lcSource") && preventivn odstra makra
lcDest=ALLT("&lcDest") && preventivn odstra makra

lcSourceN=m.lcSource+CHR(0) && piti nulov znak
lcDestN=m.lcDest+CHR(0) && piti nulov znak

IF RIGHT(m.lcSource,1)#'\' && pokud na konci nen lomtko
   lcSource=m.lcSource+'\' && pak ho pidej
ENDIF

IF RIGHT(m.lcDest,1)#'\' && pokud na konci nen lomtko
   lcDest=m.lcDest+'\' && pak ho pidej
ENDIF

IF ! INLIST(MKD(IIF(m.llLower,LOWER(m.lcDest),m.lcDest)),0,1) && pokud se vytvoen adrese nepoda
   RETURN .F. && pak se vra
ENDIF

lic=ADIR(laDir,m.lcSource+'*.*','AHRSD')
* pokud nco naet, pak to zpracuj
FOR lii=1 TO lic
    IF !(!laDir(lii,1)=="." AND !laDir(lii,1)=="..") && pokud se jedn o fiktivn adrese
       LOOP && pak sko na dal
    ENDIF
    IF RIGHT(laDir(lii,5),1)='D' && jde o adres a m se koprovat
       * pokud se m koprovat a nejde vytvoit
       IF m.llChild AND !CopyDirectory(m.lcSource+laDir(lii,1),m.lcDest+laDir(lii,1),llChild,llLower)
          RETURN .F. && pak se vra
       ENDIF
    ELSE
       * jinak jde o soubor
       lcFSource=m.lcSource+laDir(lii,1)+CHR(0) && zdroj
       lcFDest=m.lcDest+IIF(m.llLower,LOWER(laDir(lii,1)),laDir(lii,1))+CHR(0) && cl
        =SetLastError(0) && vynuluj chyby
       lierr=CopyFile(@lcFSource,@lcFDest,0) && kopie souboru
       IF m.lierr=0 && pokud dolo k chyb
          RETURN .F. && pak se vra
       ENDIF
   ENDIF
NEXT
RETURN .T.
ENDPROC

******************************************************************************
* Smae obsah adrese
******************************************************************************
PROCEDURE RemoveDirectoryAll(lcSource,llDMain)
IF PCOUNT()<2 && pokud nen parametr
   llDMain=.T.
   IF PCOUNT()=0 && pokud nen parametr
      RETURN .F. && ErrFewArguments pak se vra
   ENDIF
ENDIF
LOCAL lcSourceN,lic,lierr,lierrx,lii,lcFSource,liFA
LOCAL ARRAY laDir(1)

lcSource=ALLT("&lcSource") && preventivn odstra makra
lcSourceN=m.lcSource+CHR(0) && piti nulov znak

IF RIGHT(m.lcSource,1)#'\' && pokud na konci nen lomtko
   lcSource=m.lcSource+'\' && pak ho pidej
ENDIF

lic=ADIR(laDir,m.lcSource+'*.*','AHRSD')
FOR m.lii=1 TO lic
    IF !(!laDir(lii,1)=="." AND !laDir(lii,1)=="..") && pokud se jedn o fiktivn adrese
       LOOP && pak sko na dal
    ENDIF
    IF RIGHT(laDir(lii,5),1)='D' && jde o adres a m se koprovat
       * pokud se m koprovat a nejde vytvoit
       IF ! RemoveDirectoryAll(m.lcSource+laDir(lii,1))
          RETURN .F. && ErrOther pak se vra
       ENDIF
    ELSE
       * jinak jde o soubor
       lcFSource=m.lcSource+laDir(lii,1)+CHR(0) && zdroj

       * Nati atributy souboru
       liFA = GetFileAttributes(@lcFSource)
       IF liFA>-1
          liFA=BITAND(BITAND(BITAND(liFA,;
                      BITNOT(FILE_ATTRIBUTE_READONLY)),;
                      BITNOT(FILE_ATTRIBUTE_HIDDEN)),;
                      BITNOT(FILE_ATTRIBUTE_SYSTEM))
          =SetFileAttributes(@lcFSource,liFA)
       ENDIF

       =SetLastError(0) && vynuluj chyby
       lierr=DeleteFile(@lcFSource) && vmaz souboru
       IF m.lierr=0 && pokud dolo k chyb
          RETURN .F. && ErrOther pak se vra
       ENDIF
   ENDIF
NEXT
IF m.llDMain
   =SetLastError(0) && vynuluj chyby
   liErr=RemoveDirectory(m.lcSourceN) && odstra adres
ELSE
   liErr=1
ENDIF
 
RETURN m.liErr#0 && ErrOK, ErrOther pak se vra .T. pokud nedolo k chyb
ENDPROC



******************************************************************************
* Zjist pracovn cestu
******************************************************************************
PROCEDURE GetTempPathEx()
LOCAL lcTempPath
lcTempPath=SPACE(1024)+CHR(0)
* pokud selhala WINAPI funkce
IF GetTempPath(LEN(m.lcTempPath),@lcTempPath)=0
   lcTempPath=SYS(2023)+"\" && pak to pevezmi z VFP
ELSE
   * jinak odstra CHR(0)
   lcTempPath=NullTermined(m.lcTempPath)
ENDIF
RETURN m.lcTempPath

******************************************************************************
PROCEDURE RelativePathFromTo(lcFrom,liFromType,lcTo,liToType)
* lcFrom     - cesta nebo cesta+ soubor odkud
* liFromType - typ (adres,soubor)
* lcTo       - cesta nebo cesta+ soubor kam
* liToType   - typ (adres,soubor) 
LOCAL lcOut,liErr
lcOut=SPACE(254)+CHR(0)
lcFrom=m.lcFrom+CHR(0)
lcTo=m.lcTo+CHR(0)
liErr=PathRelativePathTo(@lcOut,@lcFrom,m.liFromType,@lcTo,m.liToType)
RETURN IIF(m.liErr=1,NullTermined(m.lcOut),m.lcTo)

******************************************************************************
PROCEDURE VFPPathCanonicalize(lcPath)
*@lcPath  - cesta nebo cesta+ soubor
LOCAL lcOut,liErr
lcOut=SPACE(254)+CHR(0)
lcPath=m.lcPath+CHR(0)
liErr=PathCanonicalize(@lcOut,@lcPath)
RETURN IIF(m.liErr=1,NullTermined(m.lcOut),m.lcPath)
