**************************************************************************
** Program name: PDM_PJX.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for process VFP project
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"

******************************************
** Definice tdy pro vygenerovn strnky projektu
DEFINE CLASS _pdm_PJX AS _pdm_Custom
   Name="_pdm_PJX"
   OutDir="project"

   Version="" && Project version

   GEN_BP=1 && Zda se m seznam zkladnch vlastnost generovat
   GEN_EP=1 && Zda se m seznam vlastnost pro EXE generovat
   GEN_OP=1 && Zda se m seznam ostatnch vlastnost generovat
   GEN_OC=1 && Zda se m seznam OLE PUBLIC classes generovat
   GEN_EX=1 && Zda se m seznam Extended Properties projektu

   OL_OC=1 && Zda se m seznam OLE PUBLIC classes tdit
   HTMLMain="Project.htm"
   HTMLDetail="PJX_Page.htm"
   HTMLList="PJX_List.htm"

   nLI1=1 && Level index
   
   KeyComments="COMMENTS" && Key word for identify filre comments.txt

   PROCEDURE GenerateHTML() && Generovn HTML strnek
      LOCAL lcProjName, lcAuthor, lcCompany, lcAddress, lcCity, lcState, lcPostalCode, lcCountry,;
            lcPom,lcString,lcHookCls,lcIcon,ltTimeStamp,lcHomeDir,llDebug,llEncrypt,;
            lcFile,lcFile_h,lcfile_dcm,lcFile_dbp,lcFile_dep,lcFile_dop,lcFile_doc,lcComment,lcRes2,;
            lii,liy,lcClash,lcClasd,liLen,lcClass,lcFile_doc,;
            m.loPDM,lcName,loPIPar,llAuto,lcPomX,;
            lihFile,liCount,liz,loPDMs,llBP,llEP,llOP,llOC,llEX,llCom,luCatch,lcCSS,lcJS,lcKeyComments,;
            lcPath,lcPathX,lcComments,lcCompanyName,lcFileDescription,lcLegalCopyright,lcLegalTrademarks,;
            lcProductName,lcVersion,lcLanguageID,lcOutFile,llSAVECODE,liCMNTSTYLE,lcPJXEX,lcPJXEXCSS,lcPJXEXJS

            
      LOCAL ARRAY laObj(1),laOC(1)

      loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      loPDMs=EVAL(m.This.PDMs) && Zskej odkaz na PDMs objekt
      lcName=ExtractShortFileFromFile(m.This.HTMLDetail)
      lcFile = lcName+".htm"
      lcFile_h=lcName+"_h.htm"
      lcfile_dcm=lcName+"_f.htm"
      lcFile_dbp=lcName+"_dbp.htm"
      lcFile_dep=lcName+"_dep.htm"
      lcFile_dop=lcName+"_dop.htm"
      lcFile_doc=lcName+"_doc.htm"
      lcFile_dex=lcName+"_dex.htm"
      lcKeyComments=ALLT(m.This.KeyComments)


      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"
      lcPathX=m.This.OutDir+"\"

      m.loPDM.GetGLCSS_JS(m.This.OutDir,m.This,@m.lcCSS,@m.lcJS)

      SELECT (m.loPDM.PDM_Alias)
      LOCATE FOR Type="H"
      STORE "" TO lcComment,lcProjName
      IF FOUND()
         lcRes2=Reserved2 && Informace o OLE public classes
         lcProjName = Key
         ltTimeStamp=TimeStamp
         lcHomeDir=HomeDir
         llDebug=Debug
         llEncrypt=Encrypt
         lcAuthor = StrTranHTMLString(NullTermined(LEFT(DevInfo,46-1)))
         lcCompany = StrTranHTMLString(NullTermined(SUBS(DevInfo,47,46-1)))
         lcAddress = StrTranHTMLString(NullTermined(SUBS(DevInfo,93,46-1)))
         lcCity = StrTranHTMLString(NullTermined(SUBS(DevInfo,139,21-1)))
         lcState = StrTranHTMLString(NullTermined(SUBS(DevInfo,160,6-1)))
         lcPostalCode = StrTranHTMLString(NullTermined(SUBS(DevInfo,166,11-1)))
         lcCountry = StrTranHTMLString(NullTermined(SUBS(DevInfo,177,46-1)))

         lcComments=StrTranHTMLString(NullTermined(SUBS(DevInfo,223,255-1)))
         lcCompanyName=StrTranHTMLString(NullTermined(SUBS(DevInfo,478,255-1)))
         lcFileDescription=StrTranHTMLString(NullTermined(SUBS(DevInfo,733,255-1)))
         lcLegalCopyright=StrTranHTMLString(NullTermined(SUBS(DevInfo,988,255-1)))
         lcLegalTrademarks=StrTranHTMLString(NullTermined(SUBS(DevInfo,1243,255-1)))
         lcProductName=StrTranHTMLString(NullTermined(SUBS(DevInfo,1498,255-1)))

         llAuto=ASC(SUBS(DevInfo,1788,1))=1
         lcPom=SUBS(DevInfo,1753,15-1)
         IF m.llAuto
            lcPomX=NullTermined(LEFT(lcPom,4))
            lcVersion=lcPomX
            lcPomX=NullTermined(SUBS(lcPom,6,4))
            lcVersion=lcVersion+"."+lcPomX
            lcPomX=NullTermined(SUBS(lcPom,11,4))
            lcVersion=lcVersion+"."+LTRIM(STR(VAL(lcPomX)-1,4))
         ELSE
            lcVersion=NullTermined(LEFT(lcPom,4))+"."+NullTermined(SUBS(lcPom,6,4))+"."+NullTermined(SUBS(lcPom,11,4))
         ENDIF

         lcLanguageID=StrTranHTMLString(NullTermined(SUBS(DevInfo,1768,20-1)))
         
         IF VAL(m.This.Version)<3
            lcOutFile=OUTFILE
            llSAVECODE=SAVECODE
            liCMNTSTYLE=CMNTSTYLE
         ENDIF
         

         * Najdi tdu na hookovn
         LOCATE FOR Type=="W"
         lcHookCls=IIF(FOUND(),FULLPATH(NullTermined(Name),m.loPDM.PJXPath)+":"+NullTermined(Reserved1),"")

         * Najdi iconu aplikace
         LOCATE FOR Type=="i"
         lcIcon=IIF(FOUND(),FULLPATH(NullTermined(Name),m.loPDM.PJXPath),"")

         IF LEN(lcKeyComments)>0
            LOCATE FOR Type=="T" AND ALLT(Key)==lcKeyComments
            IF FOUND()
               luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
               lcComment=FILETOSTR(FULLPATH(Name,m.loPDM.PJXPath))
               m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
            ENDIF
         ENDIF
      ENDIF
      llCom=LEN(lcComment)>0 && Koment

      lihFile=IIF(m.This.GEN_BP=1,m.loPDMs.FCreate(lcPath+lcFile_dbp),0)
      IF lihFile>0
         llBP=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00554))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  "<h2>"+m.loPDMs.aStrings(PDM_00554)+"</h2>"+m.loPDM.aSpace(21)+;
                  '<table border="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00400)+'</td><td>'+IIF(EMPTY(lcAuthor),"&nbsp;",lcAuthor)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00403)+"</td><td>"+IIF(EMPTY(lcCompany),"&nbsp;",lcCompany)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00406)+"</td><td>"+IIF(EMPTY(lcAddress),"&nbsp;",lcAddress)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00409)+"</td><td>"+IIF(EMPTY(lcCity),"&nbsp;",lcCity)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00412)+"</td><td>"+IIF(EMPTY(lcState),"&nbsp;",lcState)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00415)+"</td><td>"+IIF(EMPTY(lcPostalCode),"&nbsp;",lcPostalCode)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00418)+"</td><td>"+IIF(EMPTY(lcCountry),"&nbsp;",+lcCountry)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  "</table>"+m.loPDM.aSpace(21)+;
                  "</body></html>"

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,3,0,0,lcPathX+lcFile_dbp,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00554),_PDM_FG_Any+_PDM_FG_PJX)
      ELSE
         =IIF(m.This.GEN_BP=1,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dbp)),.T.)
      ENDIF

      lihFile=IIF(m.This.GEN_EP=1 AND VAL(m.This.Version)>=3,m.loPDMs.FCreate(lcPath+lcFile_dep),0)
      IF lihFile>0
         llEP=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00556))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  "<h2>"+m.loPDMs.aStrings(PDM_00556)+"</h2>"+m.loPDM.aSpace(21)+;
                  '<table border="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00428)+'</td><td>'+IIF(EMPTY(lcComments),"&nbsp;",lcComments)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00431)+'</td><td>'+IIF(EMPTY(lcCompanyName),"&nbsp;",lcCompanyName)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00434)+'</td><td>'+IIF(EMPTY(lcFileDescription),"&nbsp;",lcFileDescription)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00437)+'</td><td>'+IIF(EMPTY(lcLegalCopyright),"&nbsp;",lcLegalCopyright)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00440)+'</td><td>'+IIF(EMPTY(lcLegalTrademarks),"&nbsp;",lcLegalTrademarks)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00443)+'</td><td>'+IIF(EMPTY(lcProductName),"&nbsp;",lcProductName)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00447)+"</td><td>"+IIF(llAuto,"1","0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00446)+"</td><td>"+IIF(EMPTY(lcVersion),"&nbsp;",lcVersion)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00449)+"</td><td>"+IIF(EMPTY(lcLanguageID),"&nbsp;",lcLanguageID)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  "</table>"+m.loPDM.aSpace(21)+;
                  "</body></html>"
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,4,0,0,lcPathX+lcFile_dep,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00556),_PDM_FG_Any+_PDM_FG_PJX)
      ELSE
         =IIF(m.This.GEN_EP=1,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dep)),.T.)
      ENDIF

      lihFile=IIF(m.This.GEN_OP=1,m.loPDMs.FCreate(lcPath+lcFile_dop),0)
      IF lihFile>0
         llOP=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00558))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  "<h2>"+m.loPDMs.aStrings(PDM_00558)+"</h2>"+m.loPDM.aSpace(21)+;
                  '<table border="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00459)+"</td><td>"+NullTermined(lcHomeDir)+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00461)+"</td><td>"+IIF(llDebug,m.loPDMs.aStrings(PDM_00466),m.loPDMs.aStrings(PDM_00467))+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00465)+"</td><td>"+IIF(llEncrypt,m.loPDMs.aStrings(PDM_00466),m.loPDMs.aStrings(PDM_00467))+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00469)+"</td><td>"+IIF(ltTimeStamp<=0,"&nbsp;",TTOC(STAMP2DT(ltTimeStamp)))+"</td></tr>"+m.loPDM.aSpace(21)+;
                  IIF(VAL(m.This.Version)<3,"",;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00472)+"</td><td>"+IIF(EMPTY(lcHookCls),"&nbsp;",lcHookCls)+"</td></tr>"+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00475)+"</td><td>"+IIF(EMPTY(lcIcon),"&nbsp;",lcIcon)+"</td></tr>"+m.loPDM.aSpace(21)

         * DOS properties
         IF VAL(m.This.Version)<3
            lcString=lcString+;
                     m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00530)+"</td><td>"+m.loPDMs.aStrings(IIF(liCMNTSTYLE=0,PDM_00531,PDM_00532))+"</td></tr>"+m.loPDM.aSpace(21)

            lcString=lcString+;
                     m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_00533)+[</td><td><img class="imgYN" src="../imgs/]+IIF(llSAVECODE,"fy.gif","fn.gif")+'" alt="'+IIF(llSAVECODE,m.loPDMs.aStrings(PDM_00542),m.loPDMs.aStrings(PDM_00543))+[" /></td></tr>]+m.loPDM.aSpace(21)

            IF llSAVECODE
               lcPom=NullTermined(lcOUTFILE)
               lcString=lcString+;
                        m.loPDM.aSpace(1)+[<tr><td>&nbsp;</td><td>]+m.loPDMs.aStrings(IIF(m.lcPom=="<Source>",PDM_00534,IIF(m.lcPom=="<Project>",PDM_00535,PDM_00536)))+;
                        IIF(m.lcPom=="<Source>" OR m.lcPom=="<Project>","",;
                            m.loPDM.aSpace(1)+m.lcPom)+[</td></tr>]+m.loPDM.aSpace(21)
               ENDIF

         ENDIF
         
         lcString=lcString+;
                  "</table>"+m.loPDM.aSpace(21)+;
                  "</body></html>"

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,5,0,0,lcPathX+lcFile_dop,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00558),_PDM_FG_Any+_PDM_FG_PJX)
      ELSE
         =IIF(m.This.GEN_OP=1,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dop)),.T.)
      ENDIF


      lihFile=IIF(!EMPTY(lcRes2) AND m.This.GEN_OC=1,m.loPDMs.FCreate(lcPath+lcFile_doc),0)
      IF lihFile>0
         llOC=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00560))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  '<h2>'+m.loPDMs.aStrings(PDM_00560)+'</h2>'+m.loPDM.aSpace(21)+;
                  '<h3>'+m.loPDMs.aStrings(PDM_00487)+'</h3>'+m.loPDM.aSpace(21)+;
                  '<table border="1">'+m.loPDM.aSpace(21)

         STORE "" TO lcClasd
         lcClash='<h3>'+m.loPDMs.aStrings(PDM_00486)+'</h3>'+m.loPDM.aSpace(21)

         liLen=LEN(lcRes2)

         lii=12
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (poet td)
         liCount=VAL(SUBS(lcRes2,lii+4,liy))
         DIME laObj(liCount,2) && Nadimenzuj potebn matice
         DIME laOC(liCount,9)

         ***********
         ** generovn informac o TLB knihovn
         lii=17
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00487)+'</td><td>'+SUBS(lcRes2,lii+4,liy)+'</td></tr>'+m.loPDM.aSpace(21)

         lii=lii+liy+4
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00489)+'</td><td>'+SUBS(lcRes2,lii+4,liy)+'</td></tr>'+m.loPDM.aSpace(21)

         lii=lii+liy+4
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         lcPom=SUBS(lcRes2,lii+4,liy)
         lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00491)+'</td><td>'+IIF(EMPTY(lcPom),"&nbsp;",StrTranHTMLString(lcPom))+'</td></tr>'+m.loPDM.aSpace(21)

         lii=lii+liy+4
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         lcPom=SUBS(lcRes2,lii+4,liy)
         lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00494)+'</td><td>'+IIF(EMPTY(lcPom),"&nbsp;",StrTranHTMLString(lcPom))+'</td></tr>'+m.loPDM.aSpace(21)

         lii=lii+liy+4
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         *lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>Typelib description</td><td>'+SUBS(lcRes2,lii+4,liy)+'</td></tr>'+m.loPDM.aSpace(21)

         lii=lii+liy+4
         liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
         lcString=lcString+m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00497)+'</td><td>'+SUBS(lcRes2,lii+4,liy)+'</td></tr>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)+'<p />'+m.loPDM.aSpace(21)

         ***********
         ** generovn td TLB knihovny
         liz=0
         DO WHILE lii+liy+4<=liLen
            liz=liz+1 && Inkrementuj ta
            laObj(liz,2)=liz && Ul ID dku
            
            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            lcPom=SUBS(lcRes2,lii+4,liy)
            laOC(liz,1)=IIF(EMPTY(lcPom),"&nbsp;",lcPom)

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            lcPom=SUBS(lcRes2,lii+4,liy)
            STORE IIF(EMPTY(lcPom),"&nbsp;",lcPom) TO laOC(liz,2), laObj(liz,1)

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            lcPom=SUBS(lcRes2,lii+4,liy)
            laOC(liz,3)=IIF(EMPTY(lcPom),"&nbsp;",StrTranHTMLString(lcPom))

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            lcPom=SUBS(lcRes2,lii+4,liy)
            laOC(liz,4)=IIF(EMPTY(lcPom),"&nbsp;",lcPom)

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            laOC(liz,5)=SUBS(lcRes2,lii+4,liy)

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            laOC(liz,6)=SUBS(lcRes2,lii+4,liy)

            lii=lii+liy+4
            laOC(liz,7)=VAL(SUBS(lcRes2,lii,5)) && Instancing

            lii=lii+5
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            laOC(liz,8)=SUBS(lcRes2,lii+4,liy)

            lii=lii+liy+4
            liy=VAL(SUBS(lcRes2,lii,4)) && Nati 4 B (dlka textu)
            laOC(liz,9)=SUBS(lcRes2,lii+4,liy)

         ENDDO
         IF m.This.OL_OC=1 && Order ? Yes/No
            =ASORT(laObj)
         ENDIF

         FOR liy=1 TO liCount
             lii=laObj(liy,2)
             lcClasd=lcClasd+;
                     m.loPDM.aSpace(1)+'<hr />'+m.loPDM.aSpace(21)+'<h4><a name="c_'+LTRIM(STR(liy,11))+'">'+laOC(lii,2)+'</a></h4>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<table border="1">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00509)+'</td><td>'+laOC(lii,2)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00511)+'</td><td>'+laOC(lii,3)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00513)+'</td><td>'+laOC(lii,5)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00515)+'</td><td>'+laOC(lii,6)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00517)+'</td><td>'+IIF(laOC(lii,7)=0,"&nbsp;",IIF(laOC(lii,7)=10,m.loPDMs.aStrings(PDM_00519),IIF(laOC(lii,7)=11,m.loPDMs.aStrings(PDM_00520),m.loPDMs.aStrings(PDM_00521))))+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00523)+'</td><td>'+laOC(lii,1)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00525)+'</td><td>'+laOC(lii,4)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00527)+'</td><td>'+laOC(lii,8)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_00529)+'</td><td>'+laOC(lii,9)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</table>'+m.loPDM.aSpace(21)+'<p />'+m.loPDM.aSpace(21)

             lcClash=lcClash+'<a href="#c_'+LTRIM(STR(liy,11))+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05100),"%Class%",laOC(lii,2))+[">]+laOC(lii,2)+'</a> '
         NEXT
         =FWRITE(lihFile,lcString+lcClash+'<p />'+m.loPDM.aSpace(21)+lcClasd+'</table>'+m.loPDM.aSpace(21)+'</body></html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,6,0,0,lcPathX+lcFile_doc,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00560),_PDM_FG_Any+_PDM_FG_PJX)
      ELSE
         =IIF(m.This.GEN_OC=1 AND !EMPTY(lcRes2),m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_doc)),.T.)
      ENDIF

      IF !EMPTY(lcComment)
         lihFile=m.loPDMs.FCreate(lcPath+lcFile_dcm)
         IF lihFile>0
            =FWRITE(lihFile,m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00541))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
            '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
            '<h2>'+m.loPDMs.aStrings(PDM_00541)+'</h2>'+m.loPDM.aSpace(21)+lcComment+m.loPDM.aSpace(21)+;
            '</body></html>')
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,7,0,0,lcPathX+lcFile_dcm,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00541),_PDM_FG_Any+_PDM_FG_PJX)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcfile_dcm))
         ENDIF
      ENDIF

      * Vytvoen Externch vlastnost projektu
      * Vytvoen souboru, plug-in mus vrtit popis
      * PJX Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.Type="PJXEX"
      loPIPar.FileGroup=_PDM_FG_PJX
      loPIPar.oPDMx=This

      lcPJXEX=""
      FOR lii=1 TO m.loPDM.iPJXEX
          lcPJXEX=m.lcPJXEX+m.loPDM.aPJXEX(lii,1).Run(@m.loPIPar,m.loPDM.aPJXEX(lii,2))
      NEXT
      
      IF LEN(m.lcPJXEX)>0 && Ano, nco se vygenerovalo, vytvo pro to soubor

         lihFile=IIF(m.This.GEN_EX=1,m.loPDMs.FCreate(lcPath+lcFile_dex),0)
         IF lihFile>0

            m.loPDM.GetPI_ENV("PJXEX",lcPath,@m.lcPJXEXCSS,@m.lcPJXEXJS)

            llEx=.T.
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00561))+;
                     m.loPDMs.GetStyles("../")+m.lcPJXEXCSS+lcCSS+m.lcPJXEXJS+lcJS+m.loPDM.aSpace(21)+;
                     '</head>'+m.loPDM.aSpace(21)+;
                     '<body>'+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_00561)+"</div>"+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcPJXEX+m.loPDM.aSpace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     "</body></html>"

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,5,0,0,lcPathX+lcFile_dex,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00561),_PDM_FG_Any+_PDM_FG_PJX)
         ELSE
            =IIF(m.This.GEN_EX=1,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dex)),.T.)
         ENDIF
      ENDIF

      lihFile=m.loPDMs.FCreate(lcPath+lcFile_h)
      IF lihFile>0
         lcPom=DTOS(DATE())

         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00549)+' '+ALLT(lcProjName))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<h1>'+m.loPDMs.aStrings(PDM_00549)+' '+ALLT(lcProjName)+"</h1>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%" class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                  IIF(m.llBP,m.loPDM.aSpace(3)+'<a href="'+lcFile_dbp+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00554))+[">]+m.loPDMs.aStrings(PDM_00554)+'</a> '+m.loPDM.aSpace(21),"")+;
                  IIF(m.llEP,m.loPDM.aSpace(3)+'<a href="'+lcFile_dep+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00556))+[">]+m.loPDMs.aStrings(PDM_00556)+'</a><br />'+m.loPDM.aSpace(21),"")+;
                  IIF(m.llOP,m.loPDM.aSpace(3)+'<a href="'+lcFile_dop+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00558))+[">]+m.loPDMs.aStrings(PDM_00558)+'</a> '+m.loPDM.aSpace(21),"")+;
                  IIF(m.llOC,m.loPDM.aSpace(3)+'<a href="'+lcFile_doc+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00560))+[">]+m.loPDMs.aStrings(PDM_00560)+'</a> '+m.loPDM.aSpace(21),"")+'<br />'+;
                  IIF(m.llCom,m.loPDM.aSpace(3)+'<a href="'+lcfile_dcm+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00559))+[">]+m.loPDMs.aStrings(PDM_00559)+'</a> '+m.loPDM.aSpace(21),"")+;
                  IIF(m.llEx,m.loPDM.aSpace(3)+'<a href="'+lcfile_dex+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00561))+[">]+m.loPDMs.aStrings(PDM_00561)+'</a> '+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td colspan="2">'+STRTRAN(STRTRAN(m.loPDMs.aStrings(PDM_00565),'%DATE%',LEFT(lcPom,4)+"-"+SUBST(lcPom,5,2)+"-"+RIGHT(lcPom,2)),'%VERS%',m.loPDMs.Version)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body></html>'
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,2,0,0,lcPathX+lcFile_h,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00549)+' '+ALLT(lcProjName),_PDM_FG_None+_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
      ENDIF

      lihFile=m.loPDMs.FCreate(lcPath+lcFile)
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05103),"%name%",m.loPDM.ProjectName))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+;
                  [<frameset framespacing="0" frameborder="1" rows="120,*" cols="100%" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05103),"%name%",m.loPDM.ProjectName)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F3" src="]+lcFile_h+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05104),"%name%",m.loPDM.ProjectName)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F4" src="]+IIF(!llBP,IIF(!llEP,IIF(!llOP,IIF(!llOC,IIF(!llCom,"about:blank",lcfile_dcm),lcFile_doc),lcFile_dop),lcFile_dep),lcFile_dbp)+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05105),"%name%",m.loPDM.ProjectName)+[">]+m.loPDM.aSpace(21)+;
                  [</frameset>]+m.loPDM.aSpace(21)+;
                  '</html>'
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,1,0,0,lcPathX+lcFile,0,_PDM_EF_Frame,STRTRAN(m.loPDMs.aStrings(PDM_05103),"%name%",m.loPDM.ProjectName),_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile))
      ENDIF
   ENDPROC

   * Nastav zkladn nastaven
   PROCEDURE SetDefSets()
      STORE 1 TO m.This.Generate,m.This.OL_OC,This.GEN_BP,;
                 This.GEN_EP,This.GEN_OP,This.GEN_OC,This.GEN_EX

      STORE "" TO This.GLCSS,This.GLJS
      This.KeyComments="COMMENTS"
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile)
      * lcFile - PDM File
      This.Generate=GetINIInt("PJX","Generate",This.Generate,@m.lcFile)
      This.OL_OC=GetINIInt("PJX","OL_OC",This.OL_OC,@m.lcFile)
      This.GEN_BP=GetINIInt("PJX","GEN_BP",This.GEN_BP,@m.lcFile)
      This.GEN_EP=GetINIInt("PJX","GEN_EP",This.GEN_EP,@m.lcFile)
      This.GEN_OP=GetINIInt("PJX","GEN_OP",This.GEN_OP,@m.lcFile)
      This.GEN_OC=GetINIInt("PJX","GEN_OC",This.GEN_OC,@m.lcFile)
      This.GEN_EX=GetINIInt("PJX","GEN_EX",This.GEN_EX,@m.lcFile)
      This.GLCSS=GetINIString("PJX","GLCSS",This.GLCSS,32000,@m.lcFile)
      This.GLJS=GetINIString("PJX","GLJS",This.GLJS,32000,@m.lcFile)
      This.KeyComments=GetINIString("PJX","KEYCOMMENTS",This.KeyComments,254,@m.lcFile)
      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile)
      * lcFile - PDM File
      LOCAL lcCSS,lcJS,loPDM
      =WriteINIString("PJX","Generate",STR(This.Generate,1),@m.lcFile)
      =WriteINIString("PJX","OL_OC",STR(This.OL_OC,1),@m.lcFile)
      =WriteINIString("PJX","GEN_BP",STR(This.GEN_BP,1),@m.lcFile)
      =WriteINIString("PJX","GEN_EP",STR(This.GEN_EP,1),@m.lcFile)
      =WriteINIString("PJX","GEN_OP",STR(This.GEN_OP,1),@m.lcFile)
      =WriteINIString("PJX","GEN_OC",STR(This.GEN_OC,1),@m.lcFile)
      =WriteINIString("PJX","GEN_EX",STR(This.GEN_EX,1),@m.lcFile)

      loPDM=EVALUATE(This.PDM)
      lcCSS=This.GLCSS
      lcJS=This.GLJS
      =loPDM.FormalyzeGLCSS_JS(ExtractPathFromFile(m.lcFile),@lcCSS,@lcJS)
      =WriteINIString("PJX","GLCSS",m.lcCSS,@m.lcFile)
      =WriteINIString("PJX","GLJS",m.lcJS,@m.lcFile)
      =WriteINIString("PJX","KEYCOMMENTS",This.KeyComments,@m.lcFile)
      RETURN _PDM_OK
   ENDPROC

ENDDEFINE
