**************************************************************************
** Program name: PDM_VCX.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for plugins
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"

****************************************************************
* Basic Plug-ins class - PDMs
****************************************************************
DEFINE CLASS _pdms_PlugIns AS custom
   Name="_pdms_PlugIns"
   DIME aKey(1),aPlugIn(1),aGroup(1),aGroups(12,3)
   iCount = 0 && ta plug-in

   PDMs=.NULL.
   PDM=.NULL.

   iGroups=12
   
   cOrder="10,-,7,-,4,5,11,12,1,2,8,-,3,-,9,-,6," && Order list of group

   cMetaData="1,2,4,5," && list of metadata groups

   aGroups(1,1)="DIAMP" && Type group
   aGroups(1,2)=.T.     && Only One active interface 
   aGroups(1,3)=_pdm_valGPI_DIAMP  && ID of localized caption

   aGroups(2,1)="DIAP" && Type group
   aGroups(2,2)=.T.     && Only One active interface 
   aGroups(2,3)=_pdm_valGPI_DIAP  && ID of localized caption

   aGroups(3,1)="EFRX" && Type group
   aGroups(3,2)=.F.     && Only One active interface 
   aGroups(3,3)=_pdm_valGPI_EFRX  && ID of localized caption

   aGroups(4,1)="DIAF" && Type group
   aGroups(4,2)=.T.     && Only One active interface 
   aGroups(4,3)=_pdm_valGPI_DIAF  && ID of localized caption

   aGroups(5,1)="DIAC" && Type group
   aGroups(5,2)=.T.     && Only One active interface 
   aGroups(5,3)=_pdm_valGPI_DIAC  && ID of localized caption

   aGroups(6,1)="AC" && Type group
   aGroups(6,2)=.F.     && Only One active interface 
   aGroups(6,3)=_pdm_valGPI_AC  && ID of localized caption

   aGroups(7,1)="PJXEX" && Type group
   aGroups(7,2)=.T.     && Only One active interface 
   aGroups(7,3)=_pdm_valGPI_PJXEX  && ID of localized caption

   aGroups(8,1)="DCOP" && Type group
   aGroups(8,2)=.T.     && Only One active interface 
   aGroups(8,3)=_pdm_valGPI_DCOP  && ID of localized caption

   aGroups(9,1)="CONV" && Type group
   aGroups(9,2)=.F.     && Only One active interface 
   aGroups(9,3)=_pdm_valGPI_CONV  && ID of localized caption

   aGroups(10,1)="BC" && Type group
   aGroups(10,2)=.F.     && Only One active interface 
   aGroups(10,3)=_pdm_valGPI_BC  && ID of localized caption

   aGroups(11,1)="CF" && Type group
   aGroups(11,2)=.T.     && Only One active interface 
   aGroups(11,3)=_pdm_valGPI_CF  && ID of localized caption

   aGroups(12,1)="VF" && Type group
   aGroups(12,2)=.T.     && Only One active interface 
   aGroups(12,3)=_pdm_valGPI_VF  && ID of localized caption


   PROCEDURE Requery() && Nate seznam plug-inu z adrese
      LOCAL m.loPDMs,lii,liCount,liy,luCatch,loPlugin
      LOCAL ARRAY laDir(1)
      m.loPDMs=EVAL(m.This.PDMs)
      liy=0 && Resetuj ta

      liCount=ADIR(laDir,m.loPDMs.MainPath+"plug-in\*.fxp","ASHR")
      FOR lii=1 TO m.liCount
          * Pokus se vytvoit instanci plug-inu
          luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
          DO PDM_GetInterface WITH m.loPlugin,m.loPDMs.Collate IN (m.loPDMs.MainPath+"plug-in\"+laDir(m.lii,1))
          =m.loPDMs.SetCatch(m.luCatch) && Vra zachycen chyby

          IF m.loPDMs.nErr#0
             LOOP
          ENDIF

          * Nen to plug-in
          IF !PEMSTATUS(m.loPlugIn,"ID",5) OR !PEMSTATUS(m.loPlugIn,"Initialize",5) OR !PEMSTATUS(m.loPlugIn,"Run",5)
             LOOP
          ENDIF

          * Otestuj, zda ID ji nen pouito
          * pokud ano, pak tento plug-in ignoruj
          IF m.This.TestID(m.loPlugin.ID)
             LOOP
          ENDIF

          loPlugIn.MainPath=m.loPDMs.MainPath+"plug-in\"
          loPlugIn.MainFile=laDir(m.lii,1)
          loPlugin.PDMs=m.This.PDMs
          IF !m.loPlugin.Initialize()
             LOOP
          ENDIF

          liy=m.liy+1 && Inkrementuj ta
          DIME m.This.aKey(m.liy),m.This.aPlugIn(m.liy),m.This.aGroup(m.liy)
          m.This.aGroup(m.liy)=m.loPlugin.Type
          m.This.aKey(m.liy)=m.loPlugin.ID
          m.This.aPlugIn(m.liy)=m.loPlugin
      NEXT
      m.This.iCount=m.liy
   ENDPROC

   PROCEDURE TestID(liID) && Test ID
      * liID - ID plug-inu
      LOCAL lii
      lii=ASCAN(m.This.aKey,m.liID)
      RETURN m.lii>0
   ENDPROC

   PROCEDURE GetPlugIn(liID) && Return Plug-In interface
      * liID - ID plug-inu
      LOCAL lii
      lii=ASCAN(m.This.aKey,m.liID)
      RETURN IIF(m.lii>0,m.This.aPlugIn(m.lii),.NULL.)
   ENDPROC

   PROCEDURE GetPlugInByType(lcType,laPlugIns,llOnlyOne) && Return Plug-In interface by Type
      * lcType    - Type plug-inu
      * laPlugIns - (Out) Array Plug-Ins
      * llOnlyOne - 

      LOCAL liy,llOne,lii
      liy=0
      IF m.llOnlyOne
         FOR lii=1 TO m.This.iGroups
             IF m.This.aGroups(m.lii,1)==m.lcType && Je to ono?
                llOne=m.This.aGroups(m.lii,2)
                EXIT
             ENDIF
         NEXT
      ENDIF

      DIME laPlugIns(MAX(m.This.iCount,1))
      STORE .NULL. TO laPlugIns
      FOR lii=1 TO m.This.iCount
          IF m.This.aGroup(m.lii)==m.lcType OR AT(m.lcType,This.aPlugIn(m.lii).AlterType)>0 && Je to ono?
             liy=m.liy+1
             laPlugIns(m.liy)=m.This.aPlugIn(m.lii)
             IF m.llOne
                EXIT
             ENDIF
          ENDIF
      NEXT
      DIME laPlugIns(IIF(m.liy>0,m.liy,1))
      RETURN m.liy
   ENDPROC


   PROCEDURE GetIDByType(lcType,laPlugIns) && Return Plug-In's ID interface by Type
      * lcType    - Type plug-inu
      * laPlugIns - (Out) Array Plug-Ins

      LOCAL liy,lii
      liy=0
      DIME laPlugIns(MAX(m.This.iCount,1))
      STORE .NULL. TO laPlugIns
      FOR lii=1 TO m.This.iCount
          IF m.This.aGroup(m.lii)==m.lcType OR AT(m.lcType,This.aPlugIn(m.lii).AlterType)>0 && Je to ono?
             liy=m.liy+1
             laPlugIns(m.liy)=m.This.aPlugIn(m.lii).ID
          ENDIF
      NEXT
      DIME m.laPlugIns(IIF(m.liy>0,m.liy,1))
      RETURN m.liy
   ENDPROC

   *AB 28.40.2005
   PROCEDURE GetPlugInBySharedGroup(tnGroup,taPlugIns) && Return all Plug-Ins of same "Shared Group"
      * tnGroup			SharedGroup of plug-in
      * taPlugIns		Array to Return plug ins
      *       		Col 1		plug in 
      *	  		    Col 2		ID
      * ReturnValue		Number of plug ins found
      EXTERNAL ARRAY  taPlugIns
      LOCAL lnLoop, lnCount
      lnCount = 0
      DIMENSION taPlugIns(m.This.iCount,2)
      STORE .NULL. TO taPlugIns
      FOR lnLoop = 1 TO m.This.iCount
          IF THIS.aPlugIn(lnLoop).ShareGroup=m.tnGroup THEN
             lnCount = m.lnCount+1
             taPlugIns(m.lnCount,1) = THIS.aPlugIn(m.lnLoop)
             taPlugIns(m.lnCount,2) = THIS.aPlugIn(m.lnLoop).ID
          ENDIF &&THIS.aPlugIn(lnLoop).ShareGroup=tnGroup
      NEXT &&lnLoop
      IF lnCount>0
         DIMENSION taPlugIns(lnCount,2)
      ELSE
         DIMENSION taPlugIns(1)
      ENDIF
      RETURN lnCount
   ENDPROC &&_pdms_PlugIns.GetPlugInSharedGroup
   */AB 28.40.2005


   PROCEDURE ShowGUI(liID,loSetting,lcLang) && Show GUI for settings
      * liID       - ID plug-inu
      * loSettings - Object settings
      * lcLang     - Language
      LOCAL loPI,loForm,luCatch,m.loPDMs
      loPI=m.This.GetPlugIn(m.liID)
      IF !ISNULL(m.loPI)
         m.loPDMs=EVAL(m.This.PDMs)
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         DO PDM_GetGUI WITH m.loForm,m.loPI,m.loSetting,m.lcLang  IN (m.loPI.MainPath+m.loPI.MainFile) && Get GUI
         =m.loPDMs.SetCatch(m.luCatch) && Vra zachycen chyby
         =IIF(m.loPDMs.nErr=0,m.loForm.Show(1),.T.)
         IF PEMSTATUS(m.loSetting,"oPI",5)
            m.loSetting.oPI=.NULL.
         ENDIF
      ENDIF
   ENDPROC

   PROCEDURE SetPDMRef(lcPDM) && Set PDM Reference to child objects
      * lcPDM - PUBLIC reference to PDM object
      m.This.PDM=m.lcPDM
      LOCAL lii
      FOR lii=1 TO m.This.iCount
          m.This.aPlugIn(m.lii).PDM=m.lcPDM
      NEXT
   ENDPROC

ENDDEFINE

****************************************************************
* Basic Plug-ins class - PDM
****************************************************************
DEFINE CLASS _pdm_PlugIns AS _pdm_custom
   Name="_pdm_PlugIns"

   iPlugIn=0
   DIME aPlugIn(1),aSetting(1)
   
   iShared=0
   DIME aShared(1),aSharedS(1) && ID/Object settings

   iAlterShared=0
   DIME aAlterSharedM(1),aAlterSharedA(1) && Main ID, Altered ID

   PROCEDURE TestID(liID) && Test ID
      * liID - ID plug-inu
      LOCAL lii
      lii=ASCAN(m.This.aPlugIn,m.liID)
      RETURN m.lii>0
   ENDPROC


   PROCEDURE SetDefSets() && Set deafult settings
      STORE 0 TO This.iPlugIn,This.iShared,This.iAlterShared
      DIME This.aPlugIn[1],This.aSetting[1],;
           This.aShared(1),This.aSharedS(1),;
           This.aAlterSharedM(1),This.aAlterSharedA(1)

      STORE .NULL. TO This.aPlugIn,This.aSetting,;
                      This.aAlterSharedM,This.aAlterSharedA,;
                      This.aShared,This.aSharedS
   ENDPROC


   PROCEDURE ShowGUI(liID,loSetting,lcLang) && Show GUI for settings
      * liID       - ID plug-inu
      * loSettings - Object settings
      * lcLang     - Language
      LOCAL loPI,m.loPDMs,m.loPDM,lnLoop,loSettingX
      LOCAL ARRAY laPlugIn(1,2)

      m.loPDMs=EVAL(m.This.PDMs)
      m.loPDM=EVAL(m.This.PDM)

      loPI=m.loPDMs.PlugIns.GetPlugIn(m.liID)
      IF ISNULL(m.loPI)
         RETURN
      ENDIF   

      IF m.loPI.ShareMode=_PDM_SM_Synchronize AND m.loPI.ShareGroup>0 AND !m.This.IsAlternativePlugin(m.liID)
         loPI.SynchronizeSettings(m.This.GetShareSetting(m.loPI.ShareGroup),;
                                  m.loSetting,m.loPDM.PDM_File,_PDM_SM_S_View) && Synchronize setting with groups settings
      ENDIF
      *AB 28.4.2005
      *Synchronize settings from altered settings
      IF  m.loPI.ShareMode=_PDM_SM_PlugIn AND m.loPI.ShareGroup#0 THEN
          loPI.SynchronizeSettings(.NULL.,;
                                    m.loSetting,m.loPDM.PDM_File,_PDM_SM_S_View)
      ENDIF
      */AB 28.4.2005


      * Run GUI
      =loPDMs.PlugIns.ShowGUI(liID,@loSetting,lcLang)

      IF !loSetting.OK && Dialog 
         RETURN
      ENDIF

      *AB 28.4.2005
      IF m.loPI.ShareMode=_PDM_SM_PlugIn AND m.loPI.ShareGroup#0 THEN
         * Synchronize settings from altered settings
         loPI.SynchronizeSettings(.NULL.,;
                                  m.loSetting,m.loPDM.PDM_File,_PDM_SM_S_Changed_A)
         *Synchronize settings to settings of other plugins of the same group
         FOR lnLoop = 1 TO loPDMs.PlugIns.GetPlugInBySharedGroup(loPi.ShareGroup,@laPlugIn)
             IF laPlugIn(lnLoop,2)#loPi.ID THEN
                * This is the problem zone: We need the settings of the calling form
                loSettingX = This.GetSetting(laPlugIn(lnLoop,2)) 
                *Start re - sync             	
                IF !ISNULL(loSettingX) THEN
                   laPlugIn(lnLoop,1).SynchronizeSettings(.NULL.,;
                                       m.loSettingX,m.loPDM.PDM_File,_PDM_SM_S_Changed_B)
                ENDIF &&!ISNULL(loSetting) 
             ENDIF &&laPlugIn(lnLoop,2)#loPi.ID
         ENDFOR
      ENDIF &&m.loPI.ShareMode=_PDM_SM_PlugIn AND m.loPI.ShareGroup#0
      */AB 28.4.2005
   ENDPROC


   PROCEDURE Open(lcFile,lcSection) && Read settings for all plugins
      * lcFile    - PDM File
      * lcSection - Sekce ze kter se to m nast
      LOCAL lii,m.loPDMs,loPI,lcData,liy,loPISh
      LOCAL ARRAY laPom(1)
      m.loPDMs=EVAL(m.This.PDMs)

      * A te nati celou sekci jako data
      lcData=GetINISection(m.lcSection+"_PlugIns",32000,@m.lcFile) && Cel sekce
      IF !EMPTY(m.lcData) && Pokud to nen przdn
         lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
         m.This.iPlugIn=ALINES(laPom,m.lcData) && Nati dky
      ENDIF
      IF m.This.iPlugIn>0
         DIME m.This.aPlugIn(m.This.iPlugIn)
         DIME m.This.aSetting(m.This.iPlugIn)
         STORE .NULL. TO m.This.aSetting

         * processed only simply and main shared plugin
         FOR lii=1 TO m.This.iPlugIn
             m.This.aPlugIn(m.lii)=VAL(SUBST(laPom(m.lii),2))
             loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn[m.lii])

             *AB 28.4.2005 ignore self sync plug-ins
             IF ISNULL(m.loPI) OR ;
                !INLIST(m.loPI.ShareMode,_PDM_SM_None,_PDM_SM_PlugIn) AND m.loPI.ShareGroup>0 AND m.loPI.ShareGroup#loPI.ID
             */AB 28.4.2005
                LOOP
             ENDIF
             
             m.This.aSetting[m.lii]=m.loPI.CreateSetting(This)
             =m.loPI.Open(m.lcFile,m.This.aSetting[m.lii])
         NEXT

         * processed only shared
         FOR lii=1 TO m.This.iPlugIn
             loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn[m.lii])

             *AB 28.4.2005 ignore self sync plug-ins
             IF ISNULL(m.loPI) OR;
                INLIST(m.loPI.ShareMode,_PDM_SM_None,_PDM_SM_PlugIn) OR m.loPI.ShareMode#_PDM_SM_None AND m.loPI.ShareGroup=loPI.ID
                */AB 28.4.2005
                LOOP
             ENDIF

             m.This.aSetting[m.lii]=m.loPI.CreateSetting(This)

             DO CASE
                * Share plugin as Alter, you must call Open()
                CASE m.loPI.ShareMode=_PDM_SM_Share AND m.loPI.ShareGroup>0 AND m.This.IsAlternativePlugin(m.This.aPlugIn[m.lii])
                     =m.loPI.Open(m.lcFile,m.This.aSetting[m.lii])

                CASE m.loPI.ShareMode=_PDM_SM_Synchronize AND m.loPI.ShareGroup>0
                     =m.loPI.Open(m.lcFile,m.This.aSetting[m.lii])
                     * for non alter plugin, you must call SynchronizeSettings()
                     IF !m.This.IsAlternativePlugin(m.This.aPlugIn[m.lii])
                        loPI.SynchronizeSettings(m.This.AddShareGroup(m.loPI.ShareGroup,m.This.aPlugIn[m.lii]),;
                                                 m.This.aSetting[m.lii],m.lcFile,_PDM_SM_S_Open) && Synchronize setting with groups settings
                     ENDIF              
             ENDCASE
         NEXT
      ENDIF

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,lcSection) && Write settings
      * lcFile    - PDM File
      * lcSection - Sekce ze kter se to m nast
      LOCAL lii,m.loPDMs,loPI,lcData,lcPath
      m.loPDMs=EVAL(m.This.PDMs)

      lcPath=ExtractPathFromFile(m.lcFile)
      lcData="" && Vyisti buffer

      * Save non shared or main shared
      FOR lii=1 TO m.This.iPlugIn
          loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn[m.lii])
          lcData=m.lcData+"="+LTRIM(STR(m.This.aPlugIn(m.lii),11))+CHR(0)

          *AB 28.4.2005 ignore self sync plug-ins
          IF ISNULL(m.loPI) OR;
             !INLIST(m.loPI.ShareMode,_PDM_SM_None,_PDM_SM_PlugIn) AND m.loPI.ShareGroup>0 AND m.loPI.ShareGroup#loPI.ID
          */AB 28.4.2005 ignore self sync plug-ins
             LOOP
          ENDIF

          =m.loPI.Save(m.lcFile,m.This.aSetting[m.lii])
      NEXT


      FOR lii=1 TO m.This.iPlugIn
          loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn[m.lii])

          *AB 28.4.2005 ignore self sync plug-ins
          IF ISNULL(m.loPI) OR;
             !INLIST(m.loPI.ShareMode,_PDM_SM_None,_PDM_SM_PlugIn) AND m.loPI.ShareGroup>0 AND m.loPI.ShareGroup#loPI.ID
          */AB 28.4.2005 ignore self sync plug-ins
             LOOP
          ENDIF

          DO CASE
                  * Share plugin as Alter, you must call Save()
             CASE m.loPI.ShareMode=_PDM_SM_Share AND m.loPI.ShareGroup>0 AND m.This.IsAlternativePlugin(m.This.aPlugIn[m.lii])
                  =m.loPI.Save(m.lcFile,m.This.aSetting[m.lii])

             CASE m.loPI.ShareMode=_PDM_SM_Synchronize AND m.loPI.ShareGroup>0
                  * for non alter plugin, you must call SynchronizeSettings()
                  IF !m.This.IsAlternativePlugin(m.This.aPlugIn[m.lii])
                     loPI.SynchronizeSettings(m.This.AddShareGroup(m.loPI.ShareGroup,m.This.aPlugIn[m.lii]),;
                                              m.This.aSetting[m.lii],m.lcFile,_PDM_SM_S_Save) && Synchronize setting with groups settings
                  ENDIF              
                  =m.loPI.Save(m.lcFile,m.This.aSetting[m.lii])

          ENDCASE
      NEXT
      =WriteINISection(m.lcSection+"_PlugIns",@m.lcData,@m.lcFile) && Zapi poet
      RETURN _PDM_OK
   ENDPROC
   
   PROCEDURE GetSetting(liID) && Return Setting interface
      * liID - ID plug-inu
      LOCAL lii,loSet,loPDMs
      m.loPDMs=EVAL(m.This.PDMs)

      lii=ASCAN(m.This.aPlugIn,m.liID)
      IF m.lii>0
         loSet=m.This.aSetting(m.lii)
      ELSE
         loPI=m.loPDMs.Plugins.GetPlugin(m.liID)
         loSet=m.This.GetShareSetting(m.loPI.ShareGroup)
      ENDIF
      RETURN loSet
   ENDPROC

   PROCEDURE GetPlugInByType(lcType,laPlugIns) && Return Plug-In interface by Type
      * lcType    - Type plug-inu
      * laPlugIns - (Out) Array Plug-Ins
      LOCAL m.loPDMs,liCount,lii,liy,liz
      LOCAL ARRAY laPI(1)
      m.loPDMs=EVAL(m.This.PDMs)
      liCount=m.loPDMs.PlugIns.GetPlugInByType(m.lcType,@m.laPI)

      IF m.liCount>0
         DIME laPlugIns(m.liCount,2)
      ENDIF

      liy=0
      FOR lii=1 TO m.liCount
          liz=ASCAN(m.This.aPlugIn,laPI(m.lii).ID)
          IF m.liz>0
             liy=m.liy+1
             laPlugIns(m.liy,1)=laPI(m.lii)
             laPlugIns(m.liy,2)=m.This.aSetting(m.liz)
          ENDIF
      NEXT

      IF m.liy>0
         DIME laPlugIns(m.liy,2)
      ENDIF
      RETURN m.liy
   ENDPROC

   PROCEDURE OpenSources(llShort) && Open sources and initialize resources
      LOCAL lii,m.loPDMs,loPI
      m.loPDMs=EVAL(m.This.PDMs)
      FOR lii=1 TO m.This.iPlugIn
          loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn(m.lii))

*!*	          IF ISNULL(m.loPI) OR (m.loPI.ShareMode=_PDM_SM_Share AND m.loPI.ShareGroup>0 AND m.loPI.ShareGroup#m.loPI.ID)
*!*	             LOOP
*!*	          ENDIF

          IF !m.loPI.OpenSources(m.This.aSetting(m.lii))
             This.WriteToLogFile(STRTRAN(STRTRAN(m.loPDMs.GetString(_PDM_msgPI_CNOS),"%ID%",LTRIM(STR(loPI.ID,11))),"%Caption%",loPI.GetCaption()),_PDM_DbgLog)
             RETURN .F.
          ENDIF
         
          IF !m.llShort AND !m.loPI.InitResources(m.This.aSetting(m.lii))
             This.WriteToLogFile(STRTRAN(STRTRAN(m.loPDMs.GetString(_PDM_msgPI_CIRS),"%ID%",LTRIM(STR(loPI.ID,11))),"%Caption%",loPI.GetCaption()),_PDM_DbgLog)
             RETURN .F.
          ENDIF
      NEXT
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources(llShort) && Close sources
      LOCAL lii,m.loPDMs,loPI
      m.loPDMs=EVAL(m.This.PDMs)
      FOR lii=1 TO m.This.iPlugIn
          loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn(m.lii))
*!*	          IF ISNULL(m.loPI) OR (m.loPI.ShareMode=_PDM_SM_Share AND m.loPI.ShareGroup>0 AND m.loPI.ShareGroup#m.loPI.ID)
*!*	             LOOP
*!*	          ENDIF
          =m.loPI.CloseSources()
      NEXT
   ENDPROC


   PROCEDURE AddShareGroup(liGroup,liAGroup) && Add Share group to internaly list
      * liGroup - ID of shared group ( main plugin )

      * najdi zda nen 
      * inkrementuj ta sdlench 
      LOCAL liy,loPI,loPDMs
      m.loPDMs=EVAL(m.This.PDMs)
      liy=ASCAN(m.This.aShared,liGroup)
      IF liy=0
         loPI=m.This.GetShareGroup(liGroup,liAGroup)
         STORE m.This.iShared+1 TO m.This.iShared,liy
         DIME m.This.aShared[m.liy],m.This.aSharedS[m.liy]
         m.This.aShared[m.liy]=liGroup
         m.This.aSharedS[m.liy]=m.loPI.GetSetting()
      ENDIF
      RETURN m.This.aSharedS[m.liy] && Return shared settings
   ENDPROC

   PROCEDURE GetShareSetting(liGroup) && Return share/synchronize setting 
      * liGroup - ID of shared group ( main plugin )
      LOCAL liy
      liy=ASCAN(m.This.aShared,liGroup)
      RETURN IIF(liy=0,.NULL.,m.This.aSharedS[m.liy]) && Return shared settings
   ENDPROC


   PROCEDURE GetSharePlugin(liGroup) && Return share/synchronize plugin
      * liGroup - ID of shared group ( main plugin )
      LOCAL liy,loPI,lii,loPDMs
      liy=ASCAN(m.This.aShared,liGroup)
      IF liy>0
         loPDMs=EVAL(m.This.PDMs)
         lii=ASCAN(m.This.aAlterSharedM,liGroup)
         IF lii>0 AND m.This.aAlterSharedA(m.lii)#m.liGroup
            loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aAlterSharedA(m.lii)) && Zstupn plugin
         ELSE
            loPI=m.loPDMs.PlugIns.GetPlugIn(liGroup) && Hlavn sdlen plugin
         ENDIF
      ENDIF
      RETURN IIF(liy=0,.NULL.,m.loPI) && Return shared settings
   ENDPROC

   PROCEDURE IsAlternativePlugin(liID) && Return if is plugin signed as alternative
      * liID - ID of plugin 
      RETURN ASCAN(m.This.aAlterSharedA,liID)>0
   ENDPROC

   PROCEDURE GetShareGroup(liGroup,liAGroup) && Return Main Share Plugin
      * liGroup - ID of shared group ( main plugin )
      * liAGroup - ID of Alter shared group

      * najdi zda nen 
      * inkrementuj ta sdlench 
      LOCAL liy,loPI,loPDMs
      m.loPDMs=EVAL(m.This.PDMs)
      loPI=m.loPDMs.PlugIns.GetPlugIn(liGroup) && Hlavn sdlen plugin

      * Plugin is not loaded!
      * or  
      IF ISNULL(m.loPI) OR loPI.ShareMode=_PDM_SM_Synchronize AND liGroup#liAGroup
         * sign current plugin as main plugin
         liy=ASCAN(m.This.aAlterSharedM,liGroup)
         IF liy=0
            STORE m.This.iAlterShared+1 TO m.This.iAlterShared,liy
            DIME m.This.aAlterSharedM[m.liy],m.This.aAlterSharedA[m.liy]

            loPI=m.loPDMs.PlugIns.GetPlugIn(liAGroup)

            m.This.aAlterSharedM[m.liy]=liGroup
            m.This.aAlterSharedA[m.liy]=liAGroup
         ELSE
            loPI=m.loPDMs.PlugIns.GetPlugIn(m.liAGroup) && Alternativn plugin - tj. ten aktuln zpracovvan
         ENDIF
      ENDIF
      RETURN loPI && Return plugin
   ENDPROC


   PROCEDURE RemovePlugin(liID) && Remove Plugin from internal arrays
      * liID - ID of plugin

      * najdi zda nen 
      * inkrementuj ta sdlench 
      LOCAL lii,llShareMain,llShareAlter,loPDMs,loPI,liy
      loPDMs=EVAL(m.This.PDMs)

      lii=ASCAN(m.This.aAlterSharedA,m.liID)
      IF lii>0
         llShareAlter=.T.

         m.liMID=m.This.aAlterSharedM(m.lii)

         =ADEL(m.This.aAlterSharedM,m.lii)
         =ADEL(m.This.aAlterSharedA,m.lii)
         STORE m.This.iAlterShared-1 TO m.This.iAlterShared,lii
         IF m.lii>0
            DIME This.aAlterSharedM(m.lii),This.aAlterSharedA(m.lii)
         ELSE
            STORE .NULL. TO This.aAlterSharedM,This.aAlterSharedA
         ENDIF
      ELSE
         m.liMID=m.liID
      ENDIF

      lii=ASCAN(m.This.aShared,m.liMID)
      IF m.lii>0
         =ADEL(m.This.aShared,m.lii)
         =ADEL(m.This.aSharedS,m.lii)
         STORE m.This.iShared-1 TO m.This.iShared,lii
         llShareMain=.T.
         IF m.lii>0
            DIME This.aShared(m.lii),This.aSharedS(m.lii)
         ELSE
            STORE .NULL. TO This.aShared,This.aSharedS
         ENDIF
      ENDIF


      lii=ASCAN(m.This.aPlugIn,m.liID)
      IF m.lii>0
         =ADEL(m.This.aPlugIn,lii)
         =ADEL(m.This.aSetting,lii)
         STORE m.This.iPlugIn-1 TO m.This.iPlugIn,lii
         IF m.lii>0
            DIME This.aPlugIn(m.lii),This.aSetting(m.lii)
         ELSE
            STORE .NULL. TO This.aPlugIn,This.aSetting
         ENDIF
      ENDIF

      * odstraovan skupina je hlavn - sdlen
      IF m.llShareMain OR m.llShareAlter
         loPI=m.loPDMs.PlugIns.GetPlugIn(liID)

         * Nyn projdi prvn plugin odpovdajc odstrann
         FOR lii=1 TO m.This.iPlugIn
             loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn(m.lii))
             IF !m.loPI.ShareGroup==m.liID
                LOOP
             ENDIF

             liy=ASCAN(This.aShared,m.liID)
             IF liy=0
                STORE m.This.iShared+1 TO m.This.iShared,liy
                DIME This.aShared(liy),This.aSharedS(m.liy)
                This.aShared(liy)=m.liID
             ENDIF
             This.aSharedS(liy)=m.This.aSetting(m.lii)
    
             IF m.loPI.ShareGroup#m.loPI.ID
                liy=ASCAN(m.This.aAlterSharedM,m.liID)
                IF liy=0
                   STORE m.This.iAlterShared+1 TO m.This.iAlterShared,liy
                   DIME m.This.aAlterSharedM[m.liy],m.This.aAlterSharedA[m.liy]
                   This.aAlterSharedM[m.liy]=m.liID
                ENDIF
                This.aAlterSharedA[m.liy]=m.This.aPlugIn(m.lii)
             ENDIF

             EXIT
         NEXT
      ENDIF
   ENDPROC


   PROCEDURE CloneTo(loDest,llDirectly) && Clone object's properties to destination object
      * loDest - Destination PDM plugins object
      LOCAL loPI,lii,loPDMs
      loPDMs=EVAL(m.This.PDMs)

      IF ISNULL(loDest.PDMs)
         loDest.PDMs=This.PDMs
      ENDIF

      IF ISNULL(loDest.PDM)
         loDest.PDM=This.PDM
      ENDIF

      loDest.iPlugIn=This.iPlugIn
      IF This.iPlugIn>0
         DIME loDest.aPlugIn(This.iPlugIn),loDest.aSetting(This.iPlugIn)
         =ACOPY(This.aPlugIn,loDest.aPlugIn)
         IF llDirectly
            =ACOPY(This.aSetting,loDest.aSetting)
         ELSE
            FOR lii=1 TO This.iPlugIn
                loPI=m.loPDMs.PlugIns.GetPlugIn(m.This.aPlugIn(m.lii))
                IF !ISNULL(m.loPI)
                   loDest.aSetting[m.lii]=m.loPI.GetSetting()
                   loPI.CloneTo(loDest.aSetting[m.lii])
                ENDIF
            NEXT
         ENDIF
      ELSE
         DIME loDest.aPlugIn(1),loDest.aSetting(1)
         STORE .NULL. TO loDest.aPlugIn,loDest.aSetting
      ENDIF
      
      loDest.iShared=This.iShared
      IF This.iShared>0
         DIME loDest.aShared(This.iShared),loDest.aSharedS(This.iShared)
         =ACOPY(This.aShared,loDest.aShared)
         IF llDirectly
            =ACOPY(This.aSharedS,loDest.aSharedS)
         ELSE
            FOR lii=1 TO This.iShared
                loPI=m.This.GetSharePlugin(m.This.aShared(m.lii))
                loDest.aSharedS[m.lii]=m.loPI.GetSetting()
                loPI.CloneTo(loDest.aSharedS[m.lii])
            NEXT
         ENDIF
      ELSE
         DIME loDest.aShared(1),loDest.aSharedS(1)
         STORE .NULL. TO loDest.aShared,loDest.aSharedS
      ENDIF

      loDest.iAlterShared=This.iAlterShared
      IF This.iAlterShared>0
         DIME loDest.aAlterSharedM(This.iAlterShared),loDest.aAlterSharedA(This.iAlterShared)
         =ACOPY(This.aAlterSharedM,loDest.aAlterSharedM)
         =ACOPY(This.aAlterSharedA,loDest.aAlterSharedA)
      ELSE
         DIME loDest.aAlterSharedM(1),loDest.aAlterSharedA(1)
         STORE .NULL. TO loDest.aAlterSharedM,loDest.aAlterSharedA
      ENDIF
   ENDPROC

   PROCEDURE AddPlugin(liID,loSet,llSynchronize) && Add plug in to 
      * liID - ID of plugin
      LOCAL loPI,loPDMs
      loPDMs=EVAL(m.This.PDMs)
      loPI=.NULL.

      IF !This.TestID(liID)
         This.iPlugIn=This.iPlugIn+1
         DIME This.aPlugIn(This.iPlugIn),This.aSetting(This.iPlugIn)
         This.aPlugIn(This.iPlugIn)=liID
         loPI=m.loPDMs.PlugIns.GetPlugIn(m.liID)
         This.aSetting(This.iPlugIn)=IIF(ISNULL(loPI),.NULL.,IIF(!ISNULL(loSet),loSet,loPI.CreateSetting(This,llSynchronize)))
      ENDIF
      RETURN loPI
   ENDPROC

ENDDEFINE
****************************************************************
* Basic Plug-in class
****************************************************************
DEFINE CLASS _pdm_PlugIn AS _pdm_Session
   Name="_pdm_PlugIn"

   ID=0         && ID of Plug-in
   Type=""      && Typ of Plug-in
   AlterType="" && Alternative Typ of Plug-in

   ALTab="" && Alias for table with localized string
   AHTML="" && Alias for table with HTML string

   DIME aCLang(1) && Array of languages
   DIME aCaptions(1) && Array of localized captions
   
   MainPath=""
   MainFile=""

   ShareMode=_PDM_SM_None
   ShareGroup=0

   PROCEDURE Init(lcCollate)
      =DODEFAULT(lcCollate)
      m.This.ALTab=SYS(2015)
      m.This.AHTML=SYS(2015)
   ENDPROC

   PROCEDURE Destroy() && 
      IF USED(m.This.ALTab)
         USE IN (m.This.ALTab)
      ENDIF
      IF USED(m.This.AHTML)
         USE IN (m.This.AHTML)
      ENDIF
   ENDPROC

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN ""
   ENDPROC


   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN ""
   ENDPROC

   PROCEDURE GetString(liID) && Vrt string z lokalizan tabulky
      * liID - ID lokalizovanho stringu
      RETURN IIF(SEEK(m.liID,m.This.ALTab),LTRIM(EVAL(m.This.ALTab+".XX001")),"Unknown string's ID ("+STR(liID)+")")
   ENDPROC

   PROCEDURE GetHTMLString(liID) && Vrt string z lokalizan tabulky
      * liID - ID lokalizovanho stringu
      RETURN IIF(SEEK(m.liID,m.This.AHTML),StrTranHTMLString(LTRIM(EVAL(m.This.AHTML+".XX001"))),"Unknown string's ID ("+STR(liID)+")")
   ENDPROC

   PROCEDURE Initialize()
      RETURN .T.
   ENDPROC

   PROCEDURE Run(loPar,loSetting) && Obsolete method
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      RETURN This.Render(loPar,loSetting)  && lcHTML
   ENDPROC


   PROCEDURE Render(loPar,loSetting) && Obsolete method
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      RETURN ""  && lcHTML
   ENDPROC


   PROCEDURE QuickAnalyse(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in

      RETURN .T.
   ENDPROC

   PROCEDURE CheckPropertyFlag(loPar,loSetting) && 
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      RETURN .F.
   ENDPROC

   PROCEDURE GetScript()
      RETURN ""
   ENDPROC

   PROCEDURE Open(lcFile,loSettings) && Read settings
      * lcFile     - PDM File
      * loSettings - Object of settings

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Write settings
      * lcFile    - PDM File
      * loSettings - Object of settings

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE CreateSetting(loPlugIns,llSynchronize) && Create settings object
      LOCAL loPDM,loSet
      loPDM=EVAL(m.This.PDM)


      DO CASE
         CASE m.This.ShareMode=_PDM_SM_Share AND m.This.ShareGroup>0 AND !m.loPlugIns.IsAlternativePlugin(m.This.ID)
              RETURN loPlugIns.AddShareGroup(m.This.ShareGroup,m.This.ID)

         CASE m.This.ShareMode=_PDM_SM_Synchronize AND m.This.ShareGroup>0 AND m.This.ShareGroup#m.This.ID
              * Get any setting object
              loSet=m.loPlugIns.AddShareGroup(m.This.ShareGroup,m.This.ID)

              IF !m.loPlugIns.IsAlternativePlugin(m.This.ID) && This shared plugin is non-alter
                 loSet=This.GetSetting() 

                 IF llSynchronize && Synchronize setting with groups settings
                    =This.SynchronizeSettings(m.loPlugIns.AddShareGroup(m.This.ShareGroup,m.This.ID),;
                                          loSet,m.loPDM.PDM_File,_PDM_SM_S_New)
                 ENDIF
              ENDIF
              RETURN loSet

         CASE m.This.ShareMode=_PDM_SM_Synchronize AND m.This.ShareGroup>0 AND m.This.ShareGroup=m.This.ID
              RETURN m.loPlugIns.AddShareGroup(m.This.ShareGroup,m.This.ID)

         OTHERWISE     
              RETURN This.GetSetting()
      ENDCASE
   ENDPROC

   PROCEDURE GetSetting() && Retun settings object
      RETURN .NULL.
   ENDPROC

   PROCEDURE CreateDefaultSettings(loSettings) &&  Create default settings
      * loSettings - Settigns of current plugin
      RETURN .T.
   ENDPROC

   PROCEDURE SynchronizeSettings(loSHSetting,loSetting,lcFile,liMode) && Synchronize setting with groups settings
      * loSHSetting - Settings of shared group
      * loSetting   - Settigns of current plugin
      * lcFile      - PDM file
      * liMode      - Synchronize Mode ( Open, New)

   ENDPROC

   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      RETURN .T.
   ENDPROC

   PROCEDURE CloneTo(loDst)
      * loDst - Destination object
      LOCAL loPDM,loSrc
      m.loPDM=EVAL(m.This.PDM)
      loSrc=loPDM.PlugIns.GetSetting(This.ID)
      RETURN This.Clone(m.loSrc,m.loDst)
   ENDPROC

   PROCEDURE OpenSources(loSetting)
      * loSetting - Object of settings
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      LOCAL lcOut,m.loPDM,lii,liCount
      m.loPDM=EVAL(m.This.PDM)
      IF PEMSTATUS(m.loSetting,"aCSS",5) AND PEMSTATUS(m.loSetting,"CSS",5) AND !EMPTY(m.loSetting.CSS)
         liCount=ALINES(m.loSetting.aCSS,STRTRAN(STRTRAN(m.loSetting.CSS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.loPDM.AddFileToRepository(IIF(AT("\\",m.loSetting.aCSS(m.lii))>0 OR AT(":",m.loSetting.aCSS(m.lii))>0,"",m.This.MainPath)+m.loSetting.aCSS(m.lii),"","",@m.lcOut)
	         m.loSetting.aCSS(m.lii)=m.lcOut
         NEXT
      ENDIF
      IF PEMSTATUS(m.loSetting,"aJS",5) AND PEMSTATUS(m.loSetting,"JS",5) AND !EMPTY(m.loSetting.JS)
         liCount=ALINES(m.loSetting.aJS,STRTRAN(STRTRAN(m.loSetting.JS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.loPDM.AddFileToRepository(IIF(AT("\\",m.loSetting.aJS(m.lii))>0 OR AT(":",m.loSetting.aJS(m.lii))>0,"",m.This.MainPath)+m.loSetting.aJS(m.lii),"","",@m.lcOut)
	         m.loSetting.aJS(m.lii)=m.lcOut
         NEXT
      ENDIF
      RETURN .T.
   ENDPROC

ENDDEFINE


****************************************************************
* Basic Plug-in class
****************************************************************
DEFINE CLASS _pdm_PlugIn_Par AS custom
   Name="_pdm_PlugIn_Par"
   Ram=.NULL. && Ram Object of Method/Procedure/Property/class/object
   File=""
   HTMLFile=""

   cParent=""
   cPEM=""
   cValue=""
   lDBC=.F.
   lDBF=.F.
   lNative=.F.
   DIMENSION laMember(3)
   iLevel=0
   lPicture=.F.
   lData=.F.
   lMember=.F.
   lLNK=.F.
   cRecnoX=""
   cPath=""
   cDir=""
   cDBC=""
   cPomRel=""
   cScript=""
   
   RamPJX=.NULL. && Ram object from PJX file
   RamFile=.NULL. && Ram object from file (Main record) FRX/LBX/VCX/SCX/DBC(?)/MNX(?)

   oPDMx=.NULL.
   oASC=.NULL.
   DIME aExVal(1)
   FileGroup=_PDM_FG_None
   Type=""

   * Output properties
   lLNK=.F. && Pznak pouit tabulky LNK (Multi links)
   xhtmlFooter=""
   
   PROCEDURE Reset() && 
      STORE .NULL. TO This.Ram,This.oPDMx,This.RamFile,This.oASC
      STORE "" TO This.File,This.HTMLFile,This.Type,This.cParent,This.cPEM,This.xhtmlFooter,This.laMember,This.cValue
      This.FileGroup=_PDM_FG_None
      STORE .F. TO This.lLNK,This.lDBC,This.lDBF,This.lNative

   ENDPROC
ENDDEFINE


****************************************************************
* Basic Plug-in class parameter
****************************************************************
DEFINE CLASS _pdm_PlugIn_Parameter AS custom
   Name="_pdm_PlugIn_Parameter"
   PDMs=.NULL.
   PDM=.NULL.
   OK=.F.
ENDDEFINE

