**************************************************************************
** Program name: PDM_PRG.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for process VFP program
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"


******************************************
** Definice tdy pro vygenerovn strnek program
DEFINE CLASS _pdm_PRG AS _pdm_Custom
   Name="_pdm_PRG"
   OutDir="code"

   nLI1=5 && Level index

   hFile=0 && Handle na oteven soubor

   OL_Classes=1 && Zda se m seznam td setdit
   OL_Objects=1 && Zda se m seznam objekt setdit
   OL_Methods=1 && Zda se m seznam metod setdit
   OL_Properties=1 && Zda se m seznam vlastnost setdit
   OL_Procedures=1 && Zda se m seznam procedur setdit

   GEN_PRG=1 && Zda se m generovat seznam program
   GEN_FLL=1 && Zda se m generovat FLL knihoven
   GEN_APP=1 && Zda se m generovat VFP aplikac a EXE


   HTMLPage=_GSC_Single && Pznak, zda se m generovat jedna strnka pro celou VCX knihovnu, ;
                        && nebo co tda, to strnka

   EC_Main=_SC_Collapse
   EC_Procedure=_SC_Collapse
   EC_Method=_SC_Collapse
   EC_Cls=_SC_Collapse
   EC_Expr=_SC_Collapse

   IncludeSC=_SC_Include
   IncludeDD=_DD_Include

   HTMLMain="Code.htm"
   HTMLDetail="PRG_Page.htm"
   HTMLList="PRG_List.htm"

   FPL=.NULL.

   DIME aTF(3)
   aTF(1)="P"
   aTF(2)="L"
   aTF(3)="Z"

   DIME aPF(3)
   aPF(1)=""
   aPF(2)=""
   aPF(3)=""

   PROCEDURE Init() && Inicializace objektu
      m.This.FPL=CREATEOBJECT("_FileProcessList")
      m.This.FPL.Name="PRG_FPL"
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile)
      * lcGroup - group file
      * lcFile  - base file name
      FOR lii=1 TO ALEN(This.aTF)
          IF This.aTF(m.lii)==lcGroup
             RETURN LOWER(This.OutDir)+"/"+IIF(EMPTY(This.aPF(m.lii)),"",This.aPF(m.lii)+"/")+LOWER(lcFile)
          ENDIF
      NEXT
      RETURN lcFile
   ENDPROC


   PROCEDURE GenerateHTML()
      LOCAL ARRAY laXXXs(1)
      LOCAL prCount, lii,lcPom,lcPath,lcString,m.loPDM,lihFile,loRam,lcFile_h,;
            lcFile_dPRG,lcFile_dAPP,lcFile_dFLL,lcFile_d,lcFile,;
            llAPP,llFLL,llPRG,lcCom,llProcess,lcAnchor,m.loPDMs,lcPathX,;
            lcFileX,llChange,llOne,lcCSS,lcJS,lcSF,loFileLevel,;
            lcStringFL,lcStringFLD

      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      llOne=m.loPDM.One

      lcFile=m.This.HTMLDetail
      lcFile_h=AppendShortFileFromFile(lcFile,"_h")
      lcFile_dPRG=AppendShortFileFromFile(lcFile,"_dPRG")
      lcFile_dAPP=AppendShortFileFromFile(lcFile,"_dAPP")
      lcFile_dFLL=AppendShortFileFromFile(lcFile,"_dFLL")
      lcFile_d=AppendShortFileFromFile(lcFile,"_d")

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"
      lcPathX=m.This.OutDir+"\"

      m.loPDM.GetGLCSS_JS(lcPath,This,@m.lcCSS,@m.lcJS)
      
      STORE CREATEOBJECT("_pdm_FileLevel") TO This.oFileLevel,loFileLevel

      m.This.aEC(_EC_Main,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Main=_SC_Expand
      m.This.aEC(_EC_Main,2)=IIF(m.This.aEC(_EC_Main,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Main,3)=IIF(m.This.aEC(_EC_Main,1),'',' style="display: none;"')

      m.This.aEC(_EC_Procedure,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Procedure=_SC_Expand
      m.This.aEC(_EC_Procedure,2)=IIF(m.This.aEC(_EC_Procedure,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Procedure,3)=IIF(m.This.aEC(_EC_Procedure,1),'',' style="display: none;"')

      m.This.aEC(_EC_Method,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Method=_SC_Expand
      m.This.aEC(_EC_Method,2)=IIF(m.This.aEC(_EC_Method,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Method,3)=IIF(m.This.aEC(_EC_Method,1),'',' style="display: none;"')

      m.This.aEC(_EC_Cls,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Cls=_SC_Expand
      m.This.aEC(_EC_Cls,2)=IIF(m.This.aEC(_EC_Cls,1),"uptab.gif","dotab.gif")
      m.This.aEC(_EC_Cls,3)=IIF(m.This.aEC(_EC_Cls,1),'',' style="display: none;"')

      m.This.aEC(_EC_Expr,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Expr=_SC_Expand
      m.This.aEC(_EC_Expr,2)=IIF(m.This.aEC(_EC_Expr,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Expr,3)=IIF(m.This.aEC(_EC_Expr,1),'',' style="display: none;"')

      lcStringFL=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05141))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                 '</head>'+m.loPDM.aSpace(21)+'<body class="quickfilelist">'+m.loPDM.aSpace(21)+;
                 '<table border="0" cellspacing="0">'+m.loPDM.aSpace(21)+;
                 m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)


      * Definice seznamu program
      prCount=m.loPDM.GetListOfObject(m.This.aTF(1),@laXXXs) && Vrt seznam PRG soubor
      STORE IIF(m.This.GEN_PRG=1 AND prCount>0,IIF(llOne,1,m.loPDMs.FCreate(lcPath+lcFile_dPRG)),0) TO lihFile
      IF lihFile>0 AND prCount>0
         llPRG=.T.
         lcString=IIF(llOne,"",m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02084))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     '<h2>'+m.loPDMs.aStrings(PDM_02084)+'</h2>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21))


         lcStringFLD=""

         ** seznam program
         =IIF(m.This.OL_Files=1,ASORT(laXXXs,1),.T.) && Order ? Yes/No
         FOR lii = 1 TO prCount
             IF m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                llProcess=!(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(NullTermined(loRam.Name)))
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laXXXs(lii,4)
                laXXXs(lii,3)=FILE(lcPom) && Test, if file exists
*!*	                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,LOWER(ExtractFileFromFile(lcPom))+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,loRam.GUID+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcCom=NullTermined(loRam.Comments)
                lcSF=ExtractFileFromFile(lcPom)
                lcString=IIF(llOne,"",lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!laXXXs(lii,3),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="'+IIF(loRam.Exclude,m.loPDMs.aStrings(PDM_05170),m.loPDMs.aStrings(PDM_05171))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05162),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)))

                IF llProcess
                   lcStringFLD=lcStringFLD+;
                               m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05162),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF
                         
             ENDIF
         ENDFOR
         lcString=IIF(llOne,"",lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))

         IF LEN(lcStringFLD)>0
            lcStringFL=lcStringFL+;
                       m.loPDM.aSpace(2)+'<tr><td colspan="2">'+m.loPDMs.aStrings(PDM_02084)+'</td></tr>'+m.loPDM.aSpace(21)+lcStringFLD
         ENDIF


         IF !llOne
            =FWRITE(lihFile,lcString+'</body>'+m.loPDM.aSpace(21)+'</html>')
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,3,0,0,lcPathX+lcFile_dPRG,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02084),1)
         ENDIF

         m.This.nLI2=3 && PRG files
         loFileLevel.I1=This.nLI1
         loFileLevel.I2=This.nLI2
         loFileLevel.nLevel=5

         FOR lii = 1 TO prCount
             m.This.File="" && Reset name of file
             IF laXXXs(lii,3) AND m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                This.RamPJX=m.loRam
                IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))
                   STORE laXXXs(lii,4) TO m.This.File,lcFileX
                   llChange=m.loPDM.ICL_TestFile(lcFileX)
                   IF m.loPDM.Incremental=1 AND !llChange && Pokud je inkrementln generovn a nen zmna na souboru
                      LOOP && Pak sko na dal
                   ENDIF
*!*	                   m.This.FileName=LOWER(ExtractFileFromFile(lcFileX))
                   m.This.FileName=loRam.GUID
                   IF !INLIST(m.loPDMs.MKD(m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName),0,1) && Zalo podadres pro program
                      m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName))
                      LOOP
                   ELSE
                      m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))
                      STORE 3 TO m.This.nLI4 && Reset counter
                      STORE m.This.nLI3+1 TO m.This.nLI3,loFileLevel.I3  && Increment counter
                      loFileLevel.Reset(5)
                      =m.This.GenerateHTML_PRG(lcFileX, "Main.htm", ALLT(loRam.KEY))
                   ENDIF
                ENDIF
             ENDIF
         ENDFOR
      ELSE
         =IIF(m.This.GEN_PRG=1 AND prCount>0 AND !llOne,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dPRG)),.T.)
      ENDIF


      * Definice seznamu FLL knihoven
      prCount=m.loPDM.GetListOfObject(m.This.aTF(2),@laXXXs) && Vrt seznam PRG soubor
      STORE IIF(m.This.GEN_FLL=1 AND (llOne AND prCount=1 OR prCount>0),m.loPDMs.FCreate(lcPath+lcFile_dFLL),0) TO lihFile
      IF lihFile>0
         m.This.HTMLOMMain=IIF(llOne,lcPath+lcFile_dFLL,"")
         llFLL=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02086))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+'</head>'+m.loPDM.aSpace(21)+;
                  '<body '+IIF(llPRG,'style="'+loPDMs.s_pbf+'"','')+'>'+m.loPDM.aSpace(21)+;
                  '<h2>'+m.loPDMs.aStrings(PDM_02086)+'</h2>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)


         lcStringFLD=""
         ** seznam FLL knihoven
         =IIF(m.This.OL_Files=1,ASORT(laXXXs,1),.T.) && Order ? Yes/No
         FOR lii = 1 TO prCount
             IF m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laXXXs(lii,4)
                laXXXs(lii,3)=FILE(lcPom) && Test, if file exists
                lcCom=NullTermined(loRam.Comments)
*!*	                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,LOWER(ExtractFileFromFile(lcPom))+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,loRam.GUID+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcSF=ExtractFileFromFile(lcPom)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!FILE(lcPom),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05257),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))

                IF llProcess
                   lcStringFLD=lcStringFLD+;
                              m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05257),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF

             ENDIF
         ENDFOR
         lcString=lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)

         IF LEN(lcStringFLD)>0
            lcStringFL=lcStringFL+;
                       m.loPDM.aSpace(2)+'<tr><td colspan="2">'+m.loPDMs.aStrings(PDM_02086)+'</td></tr>'+m.loPDM.aSpace(21)+lcStringFLD
         ENDIF

         =FWRITE(lihFile,lcString+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,4,0,0,lcPathX+lcFile_dFLL,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02086),1)


         m.This.nLI2=4 && PRG files
         loFileLevel.I1=This.nLI1
         loFileLevel.I2=This.nLI2
         loFileLevel.nLevel=5

         FOR lii = 1 TO prCount
             m.This.File="" && Reset name of file
             IF laXXXs(lii,3) AND m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                This.RamPJX=m.loRam
                IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))
                   STORE laXXXs(lii,4) TO m.This.File,lcFileX
                   llChange=m.loPDM.ICL_TestFile(lcFileX)
                   IF m.loPDM.Incremental=1 AND !llChange && Pokud je inkrementln generovn a nen zmna na souboru
                      LOOP && Pak sko na dal
                   ENDIF
*!*	                   m.This.FileName=LOWER(ExtractFileFromFile(lcFileX))
                   m.This.FileName=loRam.GUID
                   IF !INLIST(m.loPDMs.MKD(m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName),0,1) && Zalo podadres pro program
                      m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName))
                      LOOP
                   ELSE
                      m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))
                      STORE 3 TO m.This.nLI4 && Reset counter
                      STORE m.This.nLI3+1 TO m.This.nLI3,loFileLevel.I3  && Increment counter
                      loFileLevel.Reset(5)
                      =m.This.GenerateHTML_FLL(lcFileX, "Main.htm", ALLT(loRam.KEY))
                   ENDIF
                ENDIF
             ENDIF
         ENDFOR

      ELSE
         =IIF(m.This.GEN_FLL=1 AND (llOne AND prCount=1 OR prCount>0),m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dFLL)),.T.)
      ENDIF


      * Definice seznamu APP soubor
      prCount=m.loPDM.GetListOfObject(m.This.aTF(3),@laXXXs) && Vrt seznam APP soubor
      STORE IIF(m.This.GEN_APP=1 AND (llOne AND prCount=1 OR prCount>0),m.loPDMs.FCreate(lcPath+lcFile_dAPP),0) TO lihFile
      IF lihFile>0
         llAPP=.T.
         m.This.HTMLOMMain=IIF(llOne,lcPath+lcFile_dAPP,"")
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02088))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body '+IIF(llPRG OR llFLL,'style="'+loPDMs.s_pbf+'"','')+'>'+m.loPDM.aSpace(21)+;
                  '<h2>'+m.loPDMs.aStrings(PDM_02088)+'</h2>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

         ** seznam APP/EXE aplikac
         =IIF(m.This.OL_Files=1,ASORT(laXXXs,1),.T.) && Order ? Yes/No

         FOR lii = 1 TO prCount
             IF m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom
                lcCom=NullTermined(loRam.Comments)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!FILE(lcPom),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractFileFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))

             ENDIF
         ENDFOR
         lcString=lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,5,0,0,lcPathX+lcFile_dAPP,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02088),1)
      ELSE
         =IIF(m.This.GEN_PRG=1 AND (llOne AND prCount=1 OR prCount>0),m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dAPP)),.T.)
      ENDIF


      * Vygenerovn istho detailu
      IF !llOne AND !llPRG AND !llFLL AND !llAPP
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_04607))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     m.loPDMs.aStrings(PDM_04607)+'<br />'+m.loPDM.aSpace(21)+;
                     '</body>'+m.loPDM.aSpace(21)+'</html>'
            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,5,0,0,lcPathX+lcFile_d,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_04607),_PDM_FG_None)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
         ENDIF
      ENDIF

      * Definice frames
      STORE IIF(llOne,0,m.loPDMs.FCreate(lcPath+lcFile)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02065))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+m.loPDM.aSpace(21)+'</head>'+m.loPDM.aSpace(21)+;
                  [<frameset framespacing="0" frameborder="1" rows="80,*" cols="100%" title="]+m.loPDMs.aStrings(PDM_02065)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F3" src="]+lcFile_h+[" title="]+m.loPDMs.aStrings(PDM_05141)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F4" src="]+IIF(!llPRG,IIF(!llFLL,IIF(!llAPP,lcFile_d,lcFile_dAPP),lcFile_dFLL),lcFile_dPRG)+[" title="]+m.loPDMs.aStrings(PDM_05117)+[">]+m.loPDM.aSpace(21)+;
                  [</frameset>]+m.loPDM.aSpace(21)+;
                  [</html>]
         =FWRITE(lihFile,lcString)
         m.loPDM.AddFile(m.This.nLI1,1,0,0,lcPathX+lcFile,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_02065),_PDM_FG_None)
         =m.loPDMs.FClose(lihFile)
      ELSE
         =IIF(llOne,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile)))
      ENDIF


      * Definice hlaviky
      STORE IIF(llOne,0,m.loPDMs.FCreate(lcPath+lcFile_h)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05141))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="70%">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<h1>'+m.loPDMs.aStrings(PDM_02065)+'</h1>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="30%" class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                  IIF(llPRG,m.loPDM.aSpace(3)+IIF(!llFLL AND !llAPP,m.loPDMs.aStrings(PDM_02084)+" ",'<a href="'+lcFile_dPRG+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_02084))+[">]+m.loPDMs.aStrings(PDM_02084)+'</a> ')+m.loPDM.aSpace(21),"")+;
                  IIF(llFLL,m.loPDM.aSpace(3)+IIF(!llPRG AND !llAPP,m.loPDMs.aStrings(PDM_02086)+" ",'<a href="'+lcFile_dFLL+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_02086))+[">]+m.loPDMs.aStrings(PDM_02086)+'</a><br />')+m.loPDM.aSpace(21),"")+;
                  IIF(llAPP,m.loPDM.aSpace(3)+IIF(!llPRG AND !llFLL,m.loPDMs.aStrings(PDM_02088)+" ",'<a href="'+lcFile_dAPP+[" target="F4" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_02088))+[">]+m.loPDMs.aStrings(PDM_02088)+'</a> ')+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'
               
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,2,0,0,lcPathX+lcFile_h,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_05141),_PDM_FG_None)
      ELSE
         =IIF(llOne,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h)))
      ENDIF
      

      * Generovn PRG_List - jen uloen
      STORE m.loPDMs.FCreate(lcPath+This.HTMLList) TO lihFile
      IF lihFile>0
         =FWRITE(lihFile,lcStringFL+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+This.HTMLList))
      ENDIF
      
      
      
      This.oFileLevel=.NULL.
   ENDPROC

   PROCEDURE GenerateHTML_PRG(lcFile, lcHTMLName, lcPRGName) && Vygeneruje strnku pro PRG soubor
      * lcFile     - Umstn a nzev PRG souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      * lcPRGName  - Jen nzev PRG souboru

      LOCAL lcString,lcAPRC,lcAOBJ,lcCode,lcPom,liy,liz,liCnt,lcAPROPS,lii,lcLine,;
            m.XX101,liPRC,liCLS,lcPath,lcPathX,;
            lcMethods,lcMethodsH,;
            lcProc,lcClass,lcClassX,lcLOBJNAME,llLNKS,;
            m.loPDM,lihFile,lcFile_d,lcFile_h,lcFile_f,lcFile_t,lcFile,loAPRG,llPRC,lcRecno,m.loPDMs,;
            lcScript,lcHTML,llHead,luCatch,llOne,lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS,;
            lcDIAFCSS,lcDIAFJS,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,lcDIACCSS,lcDIACJS,loFileLevel

      LOCAL ARRAY laObj(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      llOne=m.loPDM.One

      loAPRG=m.loPDM.oAPRG
      loAPRG.Reset()

      lcFile_h=AppendShortFileFromFile(lcHTMLName,"_h")
      lcFile_d=AppendShortFileFromFile(lcHTMLName,"_d")
      lcFile_t=AppendShortFileFromFile(lcHTMLName,"_t")
      lcFile_f=AppendShortFileFromFile(lcHTMLName,"_f")
      lcFile_dex=AppendShortFileFromFile(lcHTMLName,"_dEx")

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
      m.This.HTMLOMMain=IIF(llOne,lcPathX+lcHTMLName,"")

      m.loPDM.GetGLCSS_JS(lcPath,This,@m.lcCSS,@m.lcJS)

      m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)
      m.loPDM.GetPI_ENV("DIAC",lcPath,@m.lcDIACCSS,@m.lcDIACJS)

      STORE 0 TO liPRC,liCLS
      STORE "" TO lcProc,lcClass,lcString,lcClassX,lcScript,lcPom


      luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
      lcCode=FILETOSTR(lcFile)
      m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby

      lcAPRC=loAPRG.APRC
      lcAOBJ=loAPRG.AOBJ
      lcAPROPS=loAPRG.APROPS
      loFileLevel=This.oFileLevel


      IF m.This.HTMLPage=_GSC_Single
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,m.This.hFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05184),"%name%",lcPRGName))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+;
                     m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+;
                     m.lcDIAMPJS+m.lcDIACJS+m.lcJS+'</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(lihFile,lcString)
         ENDIF
      ENDIF
      
      IF !EMPTY(lcCode)

         =loAPRG.Analyse(This,@m.lcCode) && prove analzu
         =loAPRG.RepairObjectHierarchy(This) && Oprav objektovou hierarchii

         SELE (lcAPRC)
         COUNT TO liPRC FOR (BINTOC(XX101P)==BINTOC(-1) OR BINTOC(XX101P)==BINTOC(-2)) AND !EMPTY(XXSC) && Spotej poet volnch procedur/funkc

         SELE (lcAOBJ)
         COUNT TO liCLS FOR BINTOC(XX101P)==BINTOC(0) && Spotej poet td

         ****************************************************
         * Nyn budu generovat obsah procedur a funkc   
         ****************************************************
         IF liPRC>0

            lcMethods=''
            lcMethodsH ='<h4><a name="Procedures">'+m.loPDMs.aStrings(PDM_02662)+'</a></h4>'+m.loPDM.aSpace(21)+;
                        '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04933)+'</td><td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
            loFileLevel.I4=4
            loFileLevel.I5=0

            =loAPRG.GenerateProcedures(This,@m.lcMethods,@m.lcMethodsH,@m.lcProc,liPRC=1)
            lcMethodsH=lcMethodsH+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)+'<br />'+m.loPDM.aSpace(21)

            DO CASE
               CASE liPRC=1
                    lcProc=m.loPDM.aSpace(2)+'<td>'+m.loPDMs.aStrings(PDM_02651)+'</td>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                           m.lcProc+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
                       
               CASE liPRC>1
                    lcProc=m.loPDM.aSpace(2)+'<td><label class="FP_List" for="SEL_P">'+m.loPDMs.aStrings(PDM_02657)+'</label></td>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(3)+'<select class="FP_List" id="SEL_P">'+m.loPDM.aSpace(21)+;
                           m.lcProc+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
            ENDCASE
         ENDIF

         ****************************************************
         * Nyn budu natat seznam td
         ****************************************************
         IF liCLS>0
            ***************************************************************
            * Zpracovn objektov hierarchie
            ***************************************************************

            loAPRG.hFile=lihFile
            loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
            loFileLevel.I4=5
            loFileLevel.I5=0
            =loAPRG.GenerateObject(This,0,0,"","",@m.lcClassX,RECC(lcAOBJ)=1)

            IF RECC(lcAOBJ)>0
               lcClass=m.loPDM.aSpace(2)+'<td><label class="OC_Tree" for="SEL_O">'+m.loPDMs.aStrings(PDM_02739)+'</label></td>'+m.loPDM.aSpace(21)
            ENDIF
            lcClass=lcClass+;
                    m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                    IIF(RECC(lcAOBJ)>1,m.loPDM.aSpace(3)+'<select class="OC_Tree" id="SEL_O">'+m.loPDM.aSpace(21)+lcClassX+m.loPDM.aSpace(21)+m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(3)+m.loPDM.StartS+;
                                       m.loPDM.aSpace(4)+'LoadForm("SEL_O")'+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(3)+m.loPDM.StopS,lcClassX)+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)

            lcScript=""
            lcHTML=loAPRG.GenerateClassTree(This,@m.llHead,@m.lcScript)
         ENDIF

         IF m.This.HTMLPage=_GSC_Single
            =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,3,lcPathX+lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05184),"%name%",lcPRGName),_PDM_FG_Any)
         ENDIF
      ELSE
         IF m.This.HTMLPage=_GSC_Single
            IF !EMPTY(lcCode)
               m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
            ELSE
               =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
               =m.loPDMs.FClose(lihFile)
               m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNO),"%File%",lcPath+lcFile))
            ENDIF
         ENDIF
      ENDIF

      IF liPRC>1
         STORE m.loPDMs.FCreate(lcPath+lcFile_f) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05064),"%name%",lcPRGName))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+;
                     m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+;
                     m.lcDIAMPJS+m.lcDIACJS+m.lcJS+'</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(lihFile,lcString)

            =FWRITE(lihFile,lcMethodsH+lcMethods+m.loPDM.aSpace(21))
            =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))

            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,4,lcPathX+lcFile_f,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05064),"%name%",lcPRGName),_PDM_FG_Any)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_f))
         ENDIF
      ELSE
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,4,"",0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05064),"%name%",lcPRGName),_PDM_FG_Any)
      ENDIF


      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_PRG
      loPIPar.RamPJX=This.RamPJX
      loPIPar.RamFile=.NULL.
      loPIPar.oPDMx=This

      STORE "" TO lcDIAF,lcDIAXF
      FOR lii=1 TO m.loPDM.iDIAF
          lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
          lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
      NEXT
      IF LEN(m.lcDIAF)>0 && Yes, DIAF for file exist
         lihFile=m.loPDMs.FCreate(lcPath+lcFile_dex)
         IF lihFile>0
            m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

            llEx=.T.
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcPRGName))+;
                     m.loPDMs.GetStyles("../../")+m.lcDIAFCSS+m.lcCSS+m.lcDIAFJS+m.lcJS+m.loPDM.aSpace(21)+;
                     IIF(m.loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                     '</head>'+m.loPDM.aSpace(21)+;
                     '<body>'+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAF+m.loPDM.aSpace(21)+;
                     m.loPDMs.GenerateBackReferenceHTML(m.This.File,"","","../../")+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAXF+m.loPDM.aSPace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     "</body></html>"

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,2,lcPathX+lcFile_dex,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcPRGName),_PDM_FG_Any+_PDM_FG_DIAX)
         ELSE
            =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%name%",lcPath+lcFile_dex))
         ENDIF
      ENDIF

      IF liCLS>1
         STORE m.loPDMs.FCreate(lcPath+lcFile_t) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02790))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+lcJS+;
                     m.loPDM.StartS+;
                     m.loPDMs.AddScript("ResetE_Tab")+;
                     m.loPDM.StopS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+'<h4 style="'+loPDMs.s_pbf+'">'+m.loPDMs.aStrings(PDM_02790)+'</h4>'+m.loPDM.aSpace(21)+;
                     [<div id="DIVX_0" ondblclick="window.E_Tab='.';">]+m.loPDM.aSpace(21)+;
                     IIF(!llHead,'',;
                         m.loPDM.aSpace(1)+[<div class="TreeRowH" ondblclick="ExpandAllDIV('0',4);">]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+[<img class="imgEC" src="../../imgs/]+m.This.aEC(_EC_Cls,2)+[" id="IMGX_0" alt="]+m.loPDMs.aStrings(PDM_02797)+[" />]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'<span class="TreeRow">'+m.loPDMs.aStrings(PDM_02797)+'</span>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(1)+'</div>'+m.loPDM.aSpace(21))+;
                     lcHTML+;
                     '</div>'+m.loPDM.aSpace(21)+;
                     IIF(!llHead,'',;
                         m.loPDM.StartS+;
                         STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.loPDM.RME,"%ID%","DIVX_0"),"%XType%","Main"),"%Value%",IIF(m.This.aEC(_EC_Procedure,1),"true","false")),"%Dir%","../../imgs/")+;
                         lcScript+;
                         m.loPDM.StopS)+m.loPDM.aSpace(21)+;
                     '</body>'+m.loPDM.aSpace(21)+;
                     '</html>'+m.loPDM.aSpace(21)

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,5,lcPathX+lcFile_t,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02790),_PDM_FG_Any)
         ELSE
           m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_t))
         ENDIF
      ELSE
         =IIF(liCLS=0,.T.,m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,5,"",0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02790),_PDM_FG_Any))
      ENDIF

      STORE m.loPDMs.FCreate(lcPath+lcFile_h) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcPRGName))+m.loPDMs.GetStyles('../../')+lcCSS+;
                  IIF(liPRC>0 OR RECC(lcAOBJ)>1,m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS),'')+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%" rowspan="2"><h3>'+m.loPDMs.aStrings(PDM_02215)+' '+lcPRGName+"</h3></td>"+m.loPDM.aSpace(21)+;
                  IIF(liPRC=0,m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>',lcProc)+;
                  IIF(liPRC>1,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+[ onclick="go_proc('F3',']+lcFile_d+[','SEL_P')" alt="]+m.loPDMs.aStrings(PDM_02659)+[" /></td>],m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  IIF(EMPTY(lcClass),m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>',lcClass)+m.loPDM.aSpace(21)+;
                  IIF(RECC(lcAOBJ)>1,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+' onclick="'+IIF(m.This.HTMLPage=_GSC_Multi,[go_class_m('F3','SEL_O')],[go_class('F3',']+lcFile_d+[','SEL_O')])+[" alt="]+m.loPDMs.aStrings(PDM_02658)+[" /></td>],m.loPDM.aSpace(2)+'<td>&nbsp;</td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  IIF(liCls=0 AND !m.llEx,'',;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td class="a_right">'+m.loPDM.aSpace(21)+;
                  IIF(liPRC<=1,'',;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_f+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05063),"%name%",lcPRGName)+'">'+m.loPDMs.aStrings(PDM_05065)+'</a>'+m.loPDM.aSpace(21))+;
                  IIF(liCls<=1,'',;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_t+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05181),"%name%",lcPRGName)+'">'+m.loPDMs.aStrings(PDM_02790)+'</a>'+m.loPDM.aSpace(21))+;
                  IIF(liCls=>1 AND m.loPDM.iGOBJ>0 AND m.loPDM.GCT.Generate=1,m.loPDM.aSpace(3)+'<a href="../../GCT.htm" target="F3" title="'+m.loPDMs.aStrings(PDM_05182)+'">'+m.loPDMs.aStrings(PDM_02791)+'</a>'+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>'+IIF(m.llEx,m.loPDM.aSpace(3)+'<a href="'+lcFile_dex+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcPRGName)+[">]+m.loPDMs.aStrings(PDM_05046)+'</a> '+m.loPDM.aSpace(21),"")+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td colspan="4">('+lcFile+')</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,1,lcPathX+lcFile_h,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcPRGName),_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
      ENDIF

      STORE m.loPDMs.FCreate(lcPath+lcHTMLName) TO lihFile,m.This.hFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcPRGName))+m.loPDMs.GetStyles('../../')+lcCSS+lcJS+m.loPDM.aSpace(21)+'</head>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",'<frameset framespacing="0" frameborder="1" rows="100%" cols="333,*" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcPRGName)+'">'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'<frame name="F1" src="../../MainMenu.htm?QUICKLIST='+This.OutDir+'/'+This.HTMLList+'" noresize="true" title="'+m.loPDMs.aStrings(PDM_05102)+'">'+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+'<frameset framespacing="0" frameborder="1" rows="'+IIF(RECC(lcAOBJ)>1,'120','100')+',*" cols="100%" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcPRGName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F2" src="'+lcFile_h+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcPRGName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F3" src="'+;
                          IIF(LEN(m.lcDIAF)>0,lcFile_dex+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcPRGName),;
                          IIF(liPRC>1,lcFile_f+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05064),"%name%",lcPRGName),;
                          IIF(liCLS>1 AND liPRC=0,lcFile_t+'" title="'+m.loPDMs.aStrings(PDM_02790),loAPRG.FirstHTML+'" title="'+loAPRG.FirstHTMLTitle)))+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</frameset>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",'</frameset>'+m.loPDM.aSpace(21))+;
                  '</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,0,lcPathX+lcHTMLName,0,_PDM_EF_Frame,m.This.FileName,_PDM_FG_Any+_PDM_FG_PRG)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTMLName))
      ENDIF
   ENDPROC


   PROCEDURE GenerateHTML_FLL(lcFile, lcHTMLName, lcFLLName) && Vygeneruje strnku pro FLL soubor
      * lcFile     - Umstn a nzev FLL souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      * lcPRGName  - Jen nzev FLL souboru

      LOCAL lcString,lcAPRC,lcPom,liy,lii,liz,;
            liPRC,lcPath,lcPathX,llEx,;
            lcProc,loIT,lcString,;
            loPDM,lihFile,lcFile_h,loAPRG,llPRC,m.loPDMs,loDump,loObj,;
            lcFile_ifh,lcFile_ioh,lcFile_idd,lcFile_ish,lcFile_ied,lcFile_iid,lcFile_ft,;
            lcHTML,llHead,luCatch,llOne,lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS,;
            lcDIAFCSS,lcDIAFJS,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,lcDIACCSS,lcDIACJS,loFileLevel

      LOCAL ARRAY laObj(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      llOne=m.loPDM.One

      loAPRG=m.loPDM.oAPRG
      loAPRG.Reset()
      lcAPRC=loAPRG.APRC

      lcFile_h=AppendShortFileFromFile(lcHTMLName,"_h")
      lcFile_dex=AppendShortFileFromFile(lcHTMLName,"_dEx")

      lcFile_ifh=AppendShortFileFromFile(lcHTMLName,"_ifh")
      lcFile_ioh=AppendShortFileFromFile(lcHTMLName,"_ioh")
      lcFile_idd=AppendShortFileFromFile(lcHTMLName,"_idd")
      lcFile_ish=AppendShortFileFromFile(lcHTMLName,"_ish")
      lcFile_ied=AppendShortFileFromFile(lcHTMLName,"_ied")
      lcFile_iid=AppendShortFileFromFile(lcHTMLName,"_iid")
      lcFile_ft=AppendShortFileFromFile(lcHTMLName,"_ft")


      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
      m.This.HTMLOMMain=IIF(llOne,lcPathX+lcHTMLName,"")

      m.loPDM.GetGLCSS_JS(lcPath,This,@m.lcCSS,@m.lcJS)

      m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)
      m.loPDM.GetPI_ENV("DIAC",lcPath,@m.lcDIACCSS,@m.lcDIACJS)

      STORE 0 TO liPRC
      STORE "" TO lcProc,lcPom

      loFileLevel=This.oFileLevel

      loDump=.NULL.
      DO DumpFLL WITH lcFile,loDump
      IF ISNULL(loDump) OR loDump.nDumpError#0
         RETURN
      ENDIF
     
      * _Image_File_Header
      STORE m.loPDMs.FCreate(lcPath+lcFile_ifh) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05250),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05300)+'</h4>'+m.loPDM.aSpace(21)+;
                  '<table border="0" cellpadding="1" cellspacing="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05301)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMachine,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05302)+"</td><td class='hexa'>"+TRANSFORM(loDump.iNumberOfSections,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05303)+"</td><td class='hexa'>"+TRANSFORM(loDump.iTimeDateStamp,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05304)+"</td><td class='hexa'>"+TRANSFORM(loDump.iPointerToSymbolTable,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05305)+"</td><td class='hexa'>"+TRANSFORM(loDump.iNumberOfSymbols,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05306)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfOptionalHeader,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05307)+"</td><td class='hexa'>"+TRANSFORM(loDump.iCharacteristics,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,4,lcPathX+lcFile_ifh,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05250),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_ifh))
      ENDIF
 

      * _Image_Optional_Header
      STORE m.loPDMs.FCreate(lcPath+lcFile_ioh) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05251),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05308)+'</h4>'+m.loPDM.aSpace(21)+;
                  '<table border="0" cellpadding="1" cellspacing="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05309)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMagic,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05310)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMajorLinkerVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05311)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMinorLinkerVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05312)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfCode,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05313)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfInitializedData,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05314)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfUninitializedData,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05315)+"</td><td class='hexa'>"+TRANSFORM(loDump.iAddressOfEntryPoint,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05316)+"</td><td class='hexa'>"+TRANSFORM(loDump.iBaseOfCode,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05317)+"</td><td class='hexa'>"+TRANSFORM(loDump.iBaseOfData,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05318)+"</td><td class='hexa'>"+TRANSFORM(loDump.iImageBase,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05319)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSectionAlignment,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05320)+"</td><td class='hexa'>"+TRANSFORM(loDump.iFileAlignment,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05321)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMajorOperatingSystemVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05322)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMinorOperatingSystemVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05323)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMajorImageVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05324)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMinorImageVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05325)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMajorSubsystemVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05326)+"</td><td class='hexa'>"+TRANSFORM(loDump.iMinorSubsystemVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05327)+"</td><td class='hexa'>"+TRANSFORM(loDump.iWin32VersionValue,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05328)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfImage,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05329)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfHeaders,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05330)+"</td><td class='hexa'>"+TRANSFORM(loDump.iCheckSum,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05331)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSubsystem,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05332)+"</td><td class='hexa'>"+TRANSFORM(loDump.iDllCharacteristics,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05333)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfStackReserve,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05334)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfStackCommit,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05335)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfHeapReserve,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05336)+"</td><td class='hexa'>"+TRANSFORM(loDump.iSizeOfHeapCommit,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05337)+"</td><td class='hexa'>"+TRANSFORM(loDump.iLoaderFlags,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05338)+"</td><td class='hexa'>"+TRANSFORM(loDump.iNumberOfRvaAndSizes,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,5,lcPathX+lcFile_ioh,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05251),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_ioh))
      ENDIF
 

      * _Image_Data_Directory
      STORE IIF(loDump.iNumberOfRvaAndSizes<1,0,m.loPDMs.FCreate(lcPath+lcFile_idd)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05252),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05340)+'</h4>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05341)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05342)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05343)+"</td>"+;
                  m.loPDM.aSpace(2)+"</tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         lcString=""
         FOR lii=1 TO loDump.iNumberOfRvaAndSizes
             loObj=loDump.aDataDirectory(lii)
             lcString=lcString+;
                      m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<td>]+loObj.cName+[</td><td class="hexa">]+TRANSFORM(loObj.iVirtualAddress,"@0")+[</td><td class="hexa">]+TRANSFORM(loObj.iSize,"@0")+[</td>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
         NEXT

         lcString=lcString+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+;
                  '</body>'+m.loPDM.aSpace(21)+;
                  '</html>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,6,lcPathX+lcFile_idd,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05252),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         =IIF(loDump.iNumberOfRvaAndSizes<1,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_idd)))
      ENDIF

      * _Image_Section_Header
      STORE m.loPDMs.FCreate(lcPath+lcFile_ish) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05253),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05360)+'</h4>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)


         lcString=""
         FOR lii=1 TO loDump.iNumberOfSections
             loObj=loDump.aSectionHeader(lii)
             lcString=lcString+;
             [<div class="block"><span>]+loObj.cName+[</span>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[<div>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<table border="0" cellpadding="1" cellspacing="1">]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05366)+[</td><td class="hexa">]+TRANSFORM(loObj.iVirtualSize,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05367)+[</td><td class="hexa">]+TRANSFORM(loObj.iVirtualAddress,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05368)+[</td><td class="hexa">]+TRANSFORM(loObj.iSizeOfRawData,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05369)+[</td><td class="hexa">]+TRANSFORM(loObj.iPointerToRawData,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05370)+[</td><td class="hexa">]+TRANSFORM(loObj.iPointerToRelocations,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05371)+[</td><td class="hexa">]+TRANSFORM(loObj.iPointerToLinenumbers,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05372)+[</td><td class="hexa">]+TRANSFORM(loObj.iNumberOfRelocations,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05373)+[</td><td class="hexa">]+TRANSFORM(loObj.iNumberOfLinenumbers,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05374)+[</td><td class="hexa">]+TRANSFORM(loObj.iCharacteristics,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[</table>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[</div>]+m.loPDM.aSpace(21)+;
             [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
         NEXT

         lcString=lcString+;
                  '</body>'+m.loPDM.aSpace(21)+;
                  '</html>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,7,lcPathX+lcFile_ish,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05253),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_ish))
      ENDIF

      * _Image_Export_Directory
      STORE m.loPDMs.FCreate(lcPath+lcFile_ied) TO lihFile
      IF lihFile>0
         loObj=loDump.ExportDirectory
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05254),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05375)+'</h4>'+m.loPDM.aSpace(21)+;
                  '<table border="0" cellpadding="1" cellspacing="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05376)+"</td><td class='hexa'>"+TRANSFORM(loObj.iCharacteristics,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05377)+"</td><td class='hexa'>"+TRANSFORM(loObj.iTimeDateStamp,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05378)+"</td><td class='hexa'>"+TRANSFORM(loObj.iMajorVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05379)+"</td><td class='hexa'>"+TRANSFORM(loObj.iMinorVersion,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05380)+"</td><td>"+loObj.cName+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05381)+"</td><td class='hexa'>"+TRANSFORM(loObj.iBase,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05382)+"</td><td class='hexa'>"+TRANSFORM(loObj.iNumberOfFunctions,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05383)+"</td><td class='hexa'>"+TRANSFORM(loObj.iNumberOfNames,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         lcString='<table border="1" cellspacing="0" style="margin-top:1em;">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05384)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05385)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05386)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05387)+"</td>"+;
                  m.loPDM.aSpace(2)+"</tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         lcString=""
         FOR lii=1 TO loObj.iNumberOfFunctions
             liz=ASCAN(loObj.aNameOrdinals,lii-1)
             lcString=lcString+m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)

             IF liz>0 && funkce m jmno
                lcString=lcString+;
                         m.loPDM.aSpace(3)+[<td class="a_right">]+LTRIM(STR(liz-1,6))+[</td><td>]+loObj.aNames(liz)+[</td><td class="hexa">]+TRANSFORM(loObj.aFunctions(loObj.aNameOrdinals(lii)+1),"@0")+[</td><td class="a_right">]+LTRIM(STR(lii-1+loObj.iBase,11))+[</td>]+m.loPDM.aSpace(21)
             ELSE
                lcString=lcString+;
                         m.loPDM.aSpace(3)+[<td class="a_right">&nbsp;</td><td>&nbsp;</td><td class="hexa">]+TRANSFORM(loObj.aFunctions(loObj.aNameOrdinals(lii)+1),"@0")+[</td><td class="a_right">]+LTRIM(STR(lii-1+loObj.iBase,11))+[</td>]+m.loPDM.aSpace(21)
             ENDIF
             lcString=lcString+m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
         NEXT

 
         lcString=lcString+;
                  m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+;
                  '</body>'+m.loPDM.aSpace(21)+;
                  '</html>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,8,lcPathX+lcFile_ied,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05254),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_ied))
      ENDIF

      * _Image_Import_Descriptor
      STORE IIF(ALEN(loDump.aImportDescriptor,1)<1,0,m.loPDMs.FCreate(lcPath+lcFile_iid)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05255),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05388)+'</h4>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         FOR lii=1 TO ALEN(loDump.aImportDescriptor,1)
             loObj=loDump.aImportDescriptor(lii)

             lcString=[<div class="block"><span>]+m.loPDMs.aStrings(PDM_05389)+[</span>]+" "+loObj.cName+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(1)+[<div>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(2)+[<table border="0" cellpadding="1" cellspacing="1">]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05390)+[</td><td class="hexa">]+TRANSFORM(loObj.iOriginalFirstThunk,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05391)+[</td><td class="hexa">]+TRANSFORM(loObj.iTimeDateStamp,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05392)+[</td><td class="hexa">]+TRANSFORM(loObj.iForwarderChain,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<tr><td>]+m.loPDMs.aStrings(PDM_05393)+[</td><td class="hexa">]+TRANSFORM(loObj.iFirstThunk,"@0")+[</td></tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(2)+[</table>]+m.loPDM.aSpace(21)


             IF loObj.iImportByName>0
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<table border="1" cellspacing="0" style="margin-top:1em;">'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<thead>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(4)+'<tr class="Head">'+;
                         '<td>'+m.loPDMs.aStrings(PDM_05384)+"</td><td>"+;
                         m.loPDMs.aStrings(PDM_05385)+"</td><td>"+;
                         m.loPDMs.aStrings(PDM_05386)+"</td>"+;
                         m.loPDM.aSpace(4)+"</tr>"+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'</thead>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'<tbody>'+m.loPDM.aSpace(21)

             ENDIF   
             =FWRITE(lihFile,lcString)

             lcString=""
             FOR liy=1 TO loObj.iImportByName
                 loIT=loObj.aImportByName(liy)
                 lcString=lcString+;
                      m.loPDM.aSpace(3)+[<tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(4)+[<td class="a_right">]+LTRIM(STR(loIT.iHint,5))+;
                      [</td><td><a href="]+STRTRAN(STRTRAN(m.loPDM.APISearcher,"%name%",m.loIT.cName),"%File%",m.loObj.cName)+[" target="blank">]+m.loIT.cName+[</a>]+;
                      [</td><td class="hexa">]+TRANSFORM(loIT.iPointer,"@0")+[</td>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[</tr>]+m.loPDM.aSpace(21)
             NEXT

             IF loObj.iImportByName>0
                lcString=lcString+;
                     m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                     '</table>'+m.loPDM.aSpace(21)
             ENDIF
                  
             lcString=lcString+;
                  m.loPDM.aSpace(1)+[</div>]+m.loPDM.aSpace(21)+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)

             =FWRITE(lihFile,lcString)
         NEXT

         lcString='</body>'+m.loPDM.aSpace(21)+;
                  '</html>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)

         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,9,lcPathX+lcFile_iid,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05255),"%name%",lcFLLName),_PDM_FG_Any)
      ELSE
         =IIF(ALEN(loDump.aImportDescriptor,1)<1,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_iid)))
      ENDIF


      * FoxTable
      liPRC=IIF(loDump.iFoxTable>0 AND loDump.aFoxTable(_aFT_Count)>0,loDump.aFoxTable(_aFT_Count),0)
      STORE IIF(liPRC=0,0,m.loPDMs.FCreate(lcPath+lcFile_ft)) TO lihFile
      IF lihFile>0
         loAPRG.HTMLName=lcFile_ft && Zkladn nzev pro jednotliv HTML strnky
         loFileLevel.I4=10
         loFileLevel.I5=0

         =loAPRG.Analyse_FLL(This,@loDump) && prove analzu
         =loAPRG.GenerateProcedures(This,"","",@m.lcProc,liPRC=1)

         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05256),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<h4>'+m.loPDMs.aStrings(PDM_05394)+'</h4>'+m.loPDM.aSpace(21)+;
                  '<table border="0" cellpadding="1" cellspacing="1">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05401)+"</td><td class='hexa'>"+TRANSFORM(loDump.iFoxTable,"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05395)+"</td><td class='hexa'>"+TRANSFORM(loDump.aFoxTable(_aFT_Reserved),"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05396)+"</td><td class='hexa'>"+TRANSFORM(loDump.aFoxTable(_aFT_Count),"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+;
                  '<td>'+m.loPDMs.aStrings(PDM_05397)+"</td><td class='hexa'>"+TRANSFORM(loDump.aFoxTable(_aFT_FoxInfo),"@0")+"</td></tr>"+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         lcString='<table border="1" cellspacing="0" style="margin-top:1em;">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_05385)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05398)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05399)+"</td><td>"+;
                  m.loPDMs.aStrings(PDM_05400)+"</td>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+"</tr>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

         =FWRITE(lihFile,lcString)

         SELE (lcAPRC)
         lcString=""
         FOR lii=1 TO liPRC
             loObj=loDump.aFoxInfo(lii)

             LOCATE FOR UPPER(OBJNAME)==UPPER(loObj.cFuncName)
             lcFile_dx=AppendShortFileFromFile(lcFile_ft,"."+LOWER(loObj.cFuncName))
             lcString=lcString+;
                      m.loPDM.aSpace(2)+[<tr>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<td>]+IIF(EMPTY(XXDesc) AND EMPTY(XXSC),loObj.cFuncName,'<a href="'+m.lcFile_dx+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",loObj.cFuncName)+'">'+loObj.cFuncName+'</a>')+;
                      [</td><td class="hexa">]+TRANSFORM(loObj.FPFI,"@0")+;
                      [</td><td class="a_right">]+LTRIM(STR(loObj.iParmCount,10))+[</td>]+;
                      [</td><td>]+loObj.cParmTypes+[</td>]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
         NEXT

         lcString=lcString+;
                  m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+;
                  '</body>'+m.loPDM.aSpace(21)+;
                  '</html>'+m.loPDM.aSpace(21)
    
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,10,lcPathX+lcFile_ft,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05256),"%name%",lcFLLName),_PDM_FG_Any)

         DO CASE
            CASE liPRC=1 AND LEN(lcProc)>0
                 lcProc=m.loPDM.aSpace(2)+'<td>'+m.loPDMs.aStrings(PDM_05265)+'</td>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                        lcProc+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
                       
            CASE liPRC>1 AND LEN(lcProc)>0
                 lcProc=m.loPDM.aSpace(2)+'<td><label class="FP_List" for="SEL_P">'+m.loPDMs.aStrings(PDM_05266)+'</label></td>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(3)+'<select class="FP_List" id="SEL_P">'+m.loPDM.aSpace(21)+;
                        lcProc+;
                        m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
         ENDCASE
      ELSE
         =IIF(liPRC=0,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_ft)))
      ENDIF

      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_FLL
      loPIPar.RamPJX=This.RamPJX
      loPIPar.RamFile=.NULL.
      loPIPar.oPDMx=This

      STORE "" TO lcDIAF,lcDIAXF
      FOR lii=1 TO m.loPDM.iDIAF
          lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
          lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
      NEXT
      IF LEN(m.lcDIAF)>0 && Yes, DIAF for file exist
         lihFile=m.loPDMs.FCreate(lcPath+lcFile_dex)
         IF lihFile>0
            m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

            llEx=.T.
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcFLLName))+;
                     m.loPDMs.GetStyles("../../")+m.lcDIAFCSS+m.lcCSS+m.lcDIAFJS+m.lcJS+m.loPDM.aSpace(21)+;
                     IIF(m.loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                     '</head>'+m.loPDM.aSpace(21)+;
                     '<body>'+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAF+m.loPDM.aSpace(21)+;
                     m.loPDMs.GenerateBackReferenceHTML(m.This.File,"","","../../")+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAXF+m.loPDM.aSPace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     "</body></html>"

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,2,lcPathX+lcFile_dex,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcFLLName),_PDM_FG_Any+_PDM_FG_DIAX)
         ELSE
            =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%name%",lcPath+lcFile_dex))
         ENDIF
      ENDIF


      STORE m.loPDMs.FCreate(lcPath+lcFile_h) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcFLLName))+m.loPDMs.GetStyles('../../')+lcCSS+;
                  IIF(liPRC>0,m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS),'')+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"><h3>'+m.loPDMs.aStrings(PDM_02215)+' '+lcFLLName+"</h3></td>"+m.loPDM.aSpace(21)+;
                  IIF(liPRC=0,m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>',lcProc)+;
                  IIF(liPRC>1 AND LEN(lcProc)>0,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+[ onclick="go_proc('F3',']+lcFile_ft+[','SEL_P')" alt="]+m.loPDMs.aStrings(PDM_02659)+[" /></td>],m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td class="a_right" colspan="3">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_ifh+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05258),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05300)+'</a> '+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_ioh+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05259),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05308)+'</a> '+m.loPDM.aSpace(21)+;
                  IIF(loDump.iNumberOfRvaAndSizes<1,"",;
                      m.loPDM.aSpace(3)+'<a href="'+lcFile_idd+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05260),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05340)+'</a> '+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_ish+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05261),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05360)+'</a> '+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_ied+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05262),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05375)+'</a> '+m.loPDM.aSpace(21)+;
                  IIF(ALEN(loDump.aImportDescriptor,1)<1,"",;
                      m.loPDM.aSpace(3)+'<a href="'+lcFile_iid+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05263),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05388)+'</a> '+m.loPDM.aSpace(21))+;
                  IIF(liPRC<=1,'',;
                      m.loPDM.aSpace(3)+'<a href="'+lcFile_ft+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05264),"%name%",lcFLLName)+'">'+m.loPDMs.aStrings(PDM_05394)+'</a> '+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td class="a_top">'+IIF(m.llEx,'<a href="'+lcFile_dex+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcFLLName)+[">]+m.loPDMs.aStrings(PDM_05046)+'</a>',"")+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td colspan="4">('+lcFile+')</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,1,lcPathX+lcFile_h,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcFLLName),_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
      ENDIF

      STORE m.loPDMs.FCreate(lcPath+lcHTMLName) TO lihFile,m.This.hFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcFLLName))+;
                  m.loPDMs.GetStyles('../../')+lcCSS+lcJS+m.loPDM.aSpace(21)+'</head>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",'<frameset framespacing="0" frameborder="1" rows="100%" cols="333,*" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcFLLName)+'">'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'<frame name="F1" src="../../MainMenu.htm?QUICKLIST='+This.OutDir+'/'+This.HTMLList+'" noresize="true" title="'+m.loPDMs.aStrings(PDM_05102)+'">'+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+'<frameset framespacing="0" frameborder="1" rows="120,*" cols="100%" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05185),"%name%",lcFLLName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F2" src="'+lcFile_h+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05183),"%name%",lcFLLName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F3" src="'+;
                          IIF(LEN(m.lcDIAF)>0,lcFile_dex+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcFLLName),;
                          IIF(liPRC>1,lcFile_ft+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05064),"%name%",lcFLLName),;
                          lcFile_ifh+'" title="'+""))+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</frameset>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",'</frameset>'+m.loPDM.aSpace(21))+;
                  '</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,0,lcPathX+lcHTMLName,0,_PDM_EF_Frame,m.This.FileName,_PDM_FG_Any+_PDM_FG_FLL)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTMLName))
      ENDIF
   ENDPROC


   PROCEDURE QuickAnalyse(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev PRG souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      
      LOCAL luSC,luCatch,loPDMs,loAPRG
      loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loAPRG=EVAL(m.This.PDM+".oAPRG")

      * Analyze PRG file
      lcSC=""
      luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
      lcSC=FILETOSTR(lcFile)
      m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
      IF !EMPTY(lcSC)
         loAPRG.Reset()
         loAPRG.HTMLName=lcHTMLName
         loAPRG.iSource=_ASC_PRG
         loAPRG.QuickAnalyse(This,@m.lcSC)
         loAPRG.GenerateAnchors(This)
      ENDIF

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE QuickAnalyseFLL(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev FLL souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      
      LOCAL loPDMs,loAPRG,loDump
      loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loAPRG=EVAL(m.This.PDM+".oAPRG")

      * Analyze FLL file
      loDump=.NULL.
      DO DumpFLL WITH lcFile,loDump
      IF ISNULL(loDump)
         RETURN _PDM_OK
      ENDIF

      loAPRG.Reset()
      loAPRG.HTMLName=lcHTMLName
      loAPRG.iSource=_ASC_PRG
      loAPRG.QuickAnalyse_FLL(This,@loDump)
      loAPRG.GenerateAnchors(This)

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE PI_QuickAnalyse(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev PRG souboru
      * lcHTMLName - Zkladn nzev HTML souboru

      LOCAL lii,m.loPDM,m.loPDMs,loPIPar

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.FileGroup=_PDM_FG_PRG
      loPIPar.RamPJX=This.RamPJX
      loPIPar.RamFile=.NULL.
      loPIPar.oPDMx=This


      loPIPar.Type="DIAF"
      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(lii,2))
      NEXT

      loPIPar.Type="DIAC"
      FOR lii=1 TO m.loPDM.iDIAC
          =m.loPDM.aDIAC(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAC(lii,2))
      NEXT

      loPIPar.Type="DIAP"
      FOR lii=1 TO m.loPDM.iDIAP
          =m.loPDM.aDIAP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAP(lii,2))
      NEXT

      loPIPar.Type="DIAMP"
      FOR lii=1 TO m.loPDM.iDIAMP
          =m.loPDM.aDIAMP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAMP(lii,2))
      NEXT
   ENDPROC

   PROCEDURE PI_QuickAnalyseFLL(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev FLL souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      LOCAL loPDM,m.loPDMs,loPIPar

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.FileGroup=_PDM_FG_FLL
      loPIPar.RamPJX=This.RamPJX
      loPIPar.RamFile=.NULL.
      loPIPar.oPDMx=This

      loPIPar.Type="DIAF"
      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(lii,2))
      NEXT

      loPIPar.Type="DIAMP"
      FOR lii=1 TO m.loPDM.iDIAMP
          =m.loPDM.aDIAMP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAMP(lii,2))
      NEXT
   ENDPROC


   * Nastav zkladn nastaven
   PROCEDURE SetDefSets()
      STORE 1 TO m.This.Generate,m.This.OL_Files,;
                 m.This.OL_Classes,m.This.OL_Objects,;
                 m.This.OL_Properties,m.This.OL_Methods,;
                 m.This.OL_Procedures,m.This.GEN_PRG,;
                 m.This.GEN_FLL,m.This.GEN_APP

      m.This.HTMLPage=_GSC_Multi
      STORE _SC_Collapse TO m.This.EC_Main,m.This.EC_Method,m.This.EC_Procedure,m.This.EC_Cls,m.This.EC_Expr
      m.This.IncludeSC=_SC_Include
      m.This.IncludeDD=_DD_Include
      m.This.GLCSS=""
      m.This.GLJS=""
      m.This.FPL.SetDefSets()
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile)
      * lcFile - PDM File
      m.This.Generate=GetINIInt("PRG","Generate",m.This.Generate,@m.lcFile)
      m.This.OL_Files=GetINIInt("PRG","OL_Files",m.This.OL_Files,@m.lcFile)
      m.This.OL_Classes=GetINIInt("PRG","OL_Classes",m.This.OL_Classes,@m.lcFile)
      m.This.OL_Objects=GetINIInt("PRG","OL_Objects",m.This.OL_Objects,@m.lcFile)
      m.This.OL_Properties=GetINIInt("PRG","OL_Properties",m.This.OL_Properties,@m.lcFile)
      m.This.OL_Methods=GetINIInt("PRG","OL_Methods",m.This.OL_Methods,@m.lcFile)
      m.This.OL_Procedures=GetINIInt("PRG","OL_Procedures",m.This.OL_Procedures,@m.lcFile)
      m.This.GEN_PRG=GetINIInt("PRG","GEN_PRG",m.This.GEN_PRG,@m.lcFile)
      m.This.GEN_FLL=GetINIInt("PRG","GEN_FLL",m.This.GEN_FLL,@m.lcFile)
      m.This.GEN_APP=GetINIInt("PRG","GEN_APP",m.This.GEN_APP,@m.lcFile)
      m.This.EC_Main=GetINIInt("PRG","EC_Main",m.This.EC_Main,@m.lcFile)
      m.This.EC_Procedure=GetINIInt("PRG","EC_Procedure",m.This.EC_Procedure,@m.lcFile)
      m.This.EC_Method=GetINIInt("PRG","EC_Method",m.This.EC_Method,@m.lcFile)
      m.This.EC_Cls=GetINIInt("PRG","EC_Cls",m.This.EC_Cls,@m.lcFile)
      m.This.EC_Expr=GetINIInt("PRG","EC_Expr",m.This.EC_Expr,@m.lcFile)
      m.This.HTMLPage=GetINIInt("PRG","HTMLPage",m.This.HTMLPage,@m.lcFile)
      m.This.IncludeSC=GetINIInt("PRG","IncludeSC",m.This.IncludeSC,@m.lcFile)
      m.This.IncludeDD=GetINIInt("PRG","IncludeDD",m.This.IncludeDD,@m.lcFile)
      m.This.GLCSS=GetINIString("PRG","GLCSS",m.This.GLCSS,32000,@m.lcFile)
      m.This.GLJS=GetINIString("PRG","GLJS",m.This.GLJS,32000,@m.lcFile)
      m.This.FPL.Open(lcFile,"PRG")
      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile)
      * lcFile - PDM File
      LOCAL loPDM,lcCSS,lcJS
      =WriteINIString("PRG","Generate",STR(m.This.Generate,1),@m.lcFile)
      =WriteINIString("PRG","OL_Files",STR(m.This.OL_Files,1),@m.lcFile)
      =WriteINIString("PRG","OL_Classes",STR(m.This.OL_Classes,1),@m.lcFile)
      =WriteINIString("PRG","OL_Objects",STR(m.This.OL_Objects,1),@m.lcFile)
      =WriteINIString("PRG","OL_Properties",STR(m.This.OL_Properties,1),@m.lcFile)
      =WriteINIString("PRG","OL_Methods",STR(m.This.OL_Methods,1),@m.lcFile)
      =WriteINIString("PRG","OL_Procedures",STR(m.This.OL_Procedures,1),@m.lcFile)
      =WriteINIString("PRG","GEN_PRG",STR(m.This.GEN_PRG,1),@m.lcFile)
      =WriteINIString("PRG","GEN_FLL",STR(m.This.GEN_FLL,1),@m.lcFile)
      =WriteINIString("PRG","GEN_APP",STR(m.This.GEN_APP,1),@m.lcFile)
      =WriteINIString("PRG","EC_Main",STR(m.This.EC_Main,1),@m.lcFile)
      =WriteINIString("PRG","EC_Procedure",STR(m.This.EC_Procedure,1),@m.lcFile)
      =WriteINIString("PRG","EC_Method",STR(m.This.EC_Method,1),@m.lcFile)
      =WriteINIString("PRG","EC_Cls",STR(m.This.EC_Cls,1),@m.lcFile)
      =WriteINIString("PRG","EC_Expr",STR(m.This.EC_Expr,1),@m.lcFile)
      =WriteINIString("PRG","HTMLPage",STR(m.This.HTMLPage,1),@m.lcFile)
      =WriteINIString("PRG","IncludeSC",STR(m.This.IncludeSC,1),@m.lcFile)
      =WriteINIString("PRG","IncludeDD",STR(m.This.IncludeDD,1),@m.lcFile)

      loPDM=EVALUATE(This.PDM)
      lcCSS=This.GLCSS
      lcJS=This.GLJS
      =loPDM.FormalyzeGLCSS_JS(ExtractPathFromFile(m.lcFile),@lcCSS,@lcJS)
      =WriteINIString("PRG","GLCSS",m.lcCSS,@m.lcFile)
      =WriteINIString("PRG","GLJS",m.lcJS,@m.lcFile)

      m.This.FPL.Save(lcFile,"PRG")
      RETURN _PDM_OK
   ENDPROC

ENDDEFINE
