**************************************************************************
** Program name: PDM_VCX.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for process VFP Visual Classlibrary
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"

******************************************
** Definice tdy pro vygenerovn strnek VCX knihoven
DEFINE CLASS _pdm_VCX AS _pdm_Custom
   Name="_pdm_VCX"
   OutDir="classes"

   nLI1=2 && Level index

   OL_Classes=1 && Zda se m seznam td setdit
   OL_Objects=1 && Zda se m seznam objekt setdit
   OL_Methods=1 && Zda se m seznam metod setdit
   OL_Properties=1 && Zda se m seznam vlastnost setdit

   hFile=0 && Handle na oteven soubor

   HTMLPage=_GSC_Multi && Pznak, zda se m generovat jedna strnka pro celou VCX knihovnu, ;
                        && nebo co tda, to strnka

   HTMLMain="Class.htm"
   HTMLDetail="VCX_Page.htm"
   HTMLList="VCX_List.htm"

   EC_Method=_SC_Collapse
   EC_Cls=_SC_Collapse
   EC_Expr=_SC_Collapse

   IncludeSC=_SC_Include
   IncludeDD=_DD_Include

   FPL=.NULL.

   DIME aTF(1)
   aTF(1)="V"

   DIME aPF(1)
   aPF(1)=""

   PROCEDURE Init() && Inicializace objektu
      This.FPL=CREATEOBJECT("_FileProcessList")
      This.FPL.Name="VCX_FPL"
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile)
      * lcGroup - group file
      * lcFile  - base file name
      FOR lii=1 TO ALEN(This.aTF)
          IF This.aTF(m.lii)==lcGroup
             RETURN LOWER(This.OutDir)+"/"+IIF(EMPTY(This.aPF(m.lii)),"",This.aPF(m.lii)+"/")+LOWER(lcFile)
          ENDIF
      NEXT
      RETURN lcFile
   ENDPROC

   PROCEDURE GenerateHTML()
      LOCAL ARRAY laXXXs(1)
      LOCAL prCount, lii,lcPom,lcPath,lcPathX,lcString,lihFile,m.loPDM,loRam,lcCom,llProcess,;
            lcAnchor,m.loPDMs,lcFile,lcSF,lcStringFL,;
            lcFileX,llChange,llOne,lcCSS,lcJS

      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      lcFile=m.This.HTMLDetail
      llOne=m.loPDM.One
      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"
      lcPathX=m.This.OutDir+"\"

      m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)

      m.This.aEC(_EC_Method,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Method=_SC_Expand
      This.aEC(_EC_Method,2)=IIF(m.This.aEC(_EC_Method,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      This.aEC(_EC_Method,3)=IIF(m.This.aEC(_EC_Method,1),'',' style="display: none;"')

      This.aEC(_EC_Cls,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Cls=_SC_Expand
      This.aEC(_EC_Cls,2)=IIF(m.This.aEC(_EC_Cls,1),"uptab.gif","dotab.gif")
      This.aEC(_EC_Cls,3)=IIF(m.This.aEC(_EC_Cls,1),'',' style="display: none;"')

      m.This.aEC(_EC_Expr,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Expr=_SC_Expand
      m.This.aEC(_EC_Expr,2)=IIF(m.This.aEC(_EC_Expr,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Expr,3)=IIF(m.This.aEC(_EC_Expr,1),'',' style="display: none;"')

      STORE CREATEOBJECT("_pdm_FileLevel") TO This.oFileLevel

      prCount=m.loPDM.GetListOfObject(m.This.aTF(1),@laXXXs) && Vrt seznam VCX knihoven
      STORE IIF(llOne,1,m.loPDMs.FCreate(lcPath+lcFile)) TO lihFile
      IF lihFile>0
         lcString=IIF(llOne,"",m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01571))+m.loPDMs.GetStyles("../")+lcCSS+lcJS+;
                      '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                      '<h1>'+m.loPDMs.aStrings(PDM_01571)+'</h1>'+m.loPDM.aSpace(21))
      ELSE
         =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile))
      ENDIF

      lcStringFL=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01571))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                 '</head>'+m.loPDM.aSpace(21)+'<body class="quickfilelist">'+m.loPDM.aSpace(21)+;
                 '<table border="0" cellspacing="0">'+m.loPDM.aSpace(21)+;
                 m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

      IF lihFile>0 AND prCount > 0
         lcString=IIF(llOne,"",lcString+'<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21))

         ** seznam VCX knihoven
         =IIF(m.This.OL_Files=1,ASORT(laXXXs,1),.T.) && Order ? Yes/No
         FOR lii = 1 to prCount
             IF m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                llProcess=!(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(NullTermined(loRam.Name)))
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laXXXs(lii,4)
                laXXXs(lii,3)=FILE(lcPom) && Test, if file exists
*!*	                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,LOWER(ExtractFileFromFile(lcPom))+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laXXXs(lii,3),"",IIF(llProcess,loRam.GUID+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))

                lcCom=m.This.GetDescription(@lcPom)
                lcCom=IIF(EMPTY(m.lcCom),NullTermined(loRam.Comments),m.lcCom)
                
                lcSF=ExtractFileFromFile(lcPom)
                lcString=IIF(llOne,"",lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!laXXXs(lii,3),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="'+IIF(loRam.Exclude,m.loPDMs.aStrings(PDM_05170),m.loPDMs.aStrings(PDM_05171))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05113),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)))
                         
                IF llProcess
                   lcStringFL=lcStringFL+;
                              m.loPDM.aSpace(2)+'<tr><td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05113),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF
                         
             ENDIF
         ENDFOR
         lcString=IIF(llOne,"",lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
      ENDIF

      IF lihFile>0 AND prCount = 0 AND !llOne
         lcString=lcString+m.loPDMs.aStrings(PDM_04431)+m.loPDM.aSpace(21)
      ENDIF

      IF lihFile>0 AND !llOne
         =FWRITE(lihFile,lcString+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,1,0,0,lcPathX+lcFile,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_01571),_PDM_FG_None)
      ENDIF

      IF (lihFile>0 OR llOne AND prCount=1) AND prCount>0
         This.nLI2=m.This.nLI2+1 && Inkrement counter
         FOR lii = 1 TO prCount
             This.File="" && Reset name of file
             IF laXXXs(lii,3) AND m.loPDM.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                This.RamPJX=m.loRam
                lcPom=NullTermined(loRam.Name)
                IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))
                   STORE laXXXs(lii,4) TO m.This.File,lcFileX
                   llChange=m.loPDM.ICL_TestFile(lcFileX)
                   IF m.loPDM.Incremental=1 AND !llChange && Pokud je inkrementln generovn a nen zmna na souboru
                      LOOP && Pak sko na dal
                   ENDIF
*!*	                   m.This.FileName=LOWER(ExtractFileFromFile(lcFileX))
                   m.This.FileName=loRam.GUID
                   IF !INLIST(m.loPDMs.MKD(lcPath+m.This.FileName),0,1) && Zalo podadres pro VCX knihovnu
                      m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcPath+m.This.FileName))
                      LOOP
                   ELSE
                      m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))
                      STORE 3 TO This.nLI3 && Reset counter
                      This.oFileLevel.Reset(4)

                      m.This.nLI2=m.This.nLI2+1 && Inkrement counter
                      This.GenerateHTML_VCX(lcFileX, "Main.htm", ALLT(loRam.KEY))
                   ENDIF
                ENDIF
             ENDIF
         ENDFOR
         WAIT CLEAR
      ENDIF
      
      * Generovn VCX_List - jen uloen
      STORE m.loPDMs.FCreate(lcPath+This.HTMLList) TO lihFile
      IF lihFile>0
         =FWRITE(lihFile,lcStringFL+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+This.HTMLList))
      ENDIF
      
      This.oFileLevel=.NULL.
   ENDPROC


   PROCEDURE GetDescription(lcFile) && Get description of file
      * lcFile     - Umstn a nzev VCX souboru
      LOCAL m.loPDM,m.loPDMs,lcRet

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      lcAlias=SYS(2015)
      lcRet=""

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.loPDM.DataSessionID,m.lcFile,m.lcAlias," AGAIN SHARE NOUPDATE")>0
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNO),"%File%",m.lcFile))
         RETURN ""
      ENDIF

      SELE (m.lcAlias)
      LOCATE FOR PLATFORM="COMMENT " AND UNIQUEID="Class     "
      IF FOUND()
         lcRet=RESERVED7
      ENDIF

      IF USED(m.lcAlias)
         USE IN (m.lcAlias)
      ENDIF

      RETURN m.lcRet
   ENDPROC

   PROCEDURE GenerateHTML_VCX(lcFile,lcHTMLName,lcVCXName)
      * lcFile     - Umstn a nzev VCX souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      * lcVCXName  - Jen nzev VCX souboru

*set coverage to d:\temp\pdm1e_AM.log

      LOCAL lcString,lcAPRC,lcAOBJ,lcPom,liy,liz,;
            m.XX101,m.XX101P,m.XX101C,m.XX100R,m.Flags,m.OBJNAME,m.XX000,m.RESERVED8,m.RESERVED6,m.BaseClass,;
            m.RESERVED4,m.RESERVED5,m.Class,m.CLASSLOC,lcAPROPS,;
            lcClass,lcClassX,lcAlias,llHead,lcHTML,llOne,lcCSS,lcJS,loFileLevel,;
            m.loPDM,lihFile,lcFile_d,lcFile_h,lcFile_t,loAPRG,m.loPDMs,lcScript,lcPath,lcPathX,lcDIAMPCSS,;
            lcDIAMPJS,liCLS,lcDIAFCSS,lcDIAFJS,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,lcDIACCSS,lcDIACJS

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loAPRG=m.loPDM.oAPRG
      loAPRG.Reset()
      loAPRG.iSource=_ASC_VCX

      lcAlias=SYS(2015)
      llOne=m.loPDM.One

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.loPDM.DataSessionID,lcFile,lcAlias," AGAIN SHARE NOUPDATE")>0
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNO),"%File%",lcFile))
         RETURN _PDM_FileNO
      ENDIF

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
      This.HTMLOMMain=IIF(m.llOne,m.lcPathX+m.lcHTMLName,"")

      m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)

      m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)
      m.loPDM.GetPI_ENV("DIAC",lcPath,@m.lcDIACCSS,@m.lcDIACJS)

      lcFile_h=AppendShortFileFromFile(m.lcHTMLName,"_h")
      lcFile_d=AppendShortFileFromFile(m.lcHTMLName,"_d")
      lcFile_t=AppendShortFileFromFile(m.lcHTMLName,"_t")
      lcFile_dex=AppendShortFileFromFile(lcHTMLName,"_dEx")

      loFileLevel=This.oFileLevel

      IF m.This.HTMLPage=_GSC_Single
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,m.This.hFile
      ELSE
         lihFile=1
      ENDIF

      IF m.lihFile>0
         STORE "" TO lcClass,lcString,lcClassX
         m.XX000=0

         lcAPRC=m.loAPRG.APRC
         lcAOBJ=m.loAPRG.AOBJ
         lcAPROPS=m.loAPRG.APROPS

         * Musm projet VCX a vygenerovat objekty a vlastnosti a
         * pro kad objekt analyzovat zdrojov kd

         STORE 0 TO m.XX101P,m.XX101C

         SELE (m.lcAlias)
         SCAN FOR PLATFORM=="WINDOWS "
              * Jestli e je przdn parent, tak se jedn o (only form)/(formset)/(DataEnvironment)
              IF EMPTY(OBJNAME)
                 m.loPDMs.WriteToLogFile(STRTRAN(STRTRAN(m.loPDMs.GetString(IIF(EMPTY(PARENT),_PDM_msgClassInvalid,_PDM_msgObjectInvalid)),"%RECNO%",LTRIM(STR(RECNO(),11))),"%File%",m.lcFile))
                 LOOP && Pak sko na dal vtu
              ENDIF


              m.XX101=RECNO()
              m.XX100R=RECC(m.lcAOBJ)+1
              SCATTER MEMVAR MEMO
              m.RESERVED4=IIF(EMPTY(ExtractFileFromFile(m.RESERVED4)),"",m.RESERVED4)
              m.RESERVED5=IIF(EMPTY(ExtractFileFromFile(m.RESERVED5)),"",m.RESERVED5)
              
              IF EMPTY(PARENT) && Pozor, jde o definici objektu/tdy
                 STORE 0 TO m.XX101P,m.XX101C,m.Flags
                 INSERT INTO (lcAOBJ) FROM MEMVAR
                 STORE m.XX101 TO m.XX101P,m.XX101C

                 * NEPEHAZOVAT - nejdve se mus nast pole RESERVED3 a potom pole PROPETIES
                 * Analza novch vlastnost a metod (jen seznam)
                 =IIF(!EMPTY(m.RESERVED3),m.loAPRG.AnalyzeProps(m.XX101,m.XX101,"",@m.RESERVED3,@m.PROTECTED,1),.T.)

                 * Analza naplnnch vlastnost
                 =IIF(!EMPTY(m.PROPERTIES),m.loAPRG.AnalyzeProps(m.XX101,m.XX101,"",@m.PROPERTIES,"",0),.T.)
                 * NEPEHAZOVAT 

                 * Analza zdrojovch kd
                 =IIF(!EMPTY(m.Methods),m.loAPRG.Analyse(m.This,@m.Methods,m.XX101,m.XX101,""),.T.)
              ELSE
                 * Jinak jde o objekt
                 liy=AT(".",m.PARENT)
                 m.Objname=IIF(m.liy=0,"",SUBS(m.PARENT,liy+1)+".")+m.OBJNAME

                 m.Flags=IIF(m.RESERVED8="NOINIT",BITSET(0,9),0)
                 m.Flags=IIF(m.PROTECTED="TRUE",BITSET(m.Flags,0),m.Flags)
                 INSERT INTO (m.lcAOBJ) FROM MEMVAR

                 * Analza naplnnch vlastnost
                 =IIF(!EMPTY(m.PROPERTIES),m.loAPRG.AnalyzeProps(m.XX101C,m.XX101,m.ObjName,@m.PROPERTIES,"",0),.T.)

                 * Analza zdrojovch kd
                 =IIF(!EMPTY(m.Methods),m.loAPRG.Analyse(m.This,@m.Methods,m.XX101C,m.XX101,m.ObjName),.T.)
              ENDIF
              SELE (m.lcAlias)
         ENDSCAN

         SELE (m.lcAOBJ)
         COUNT TO liCLS FOR BINTOC(XX101P)==BINTOC(0) && Spotej poet td

         =m.loAPRG.RepairObjectHierarchy(m.This) && Oprav objektov strom

         ***************************************************************
         * Zpracovn objektov hierarchie
         ***************************************************************

         IF m.This.HTMLPage=_GSC_Single
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05175),"%name%",m.lcVCXName))+;
                     m.loPDMs.GetStyles("../../")+m.loPDM.GetSCCSS(lcPath)+;
                     m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                     m.loPDMs.AddExternalScript("../../"+m.loPDMs.ExternJS)+;
                     m.lcDIAMPJS+m.lcDIACJS+m.lcJS+'</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(m.lihFile,m.lcString)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,3,0,m.lcPathX+m.lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05175),"%name%",m.lcVCXName),_PDM_FG_Any)
            loAPRG.hFile=m.lihFile
         ENDIF

*set coverage to d:\temp\pdm1e_G.log

         loFileLevel.I1=This.nLI1
         loFileLevel.I2=This.nLI2
         loFileLevel.I3=4 && Pod stromem
         loFileLevel.nLevel=4

         loAPRG.HTMLName=m.lcFile_d && Zkladn nzev pro jednotliv HTML strnky
         =loAPRG.GenerateObject(m.This,0,0,"","",@m.lcClassX,RECC(m.lcAOBJ)=1)
*set coverage to 

         IF m.This.HTMLPage=_GSC_Single
            =FWRITE(m.lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
         ENDIF

         IF RECC(m.lcAOBJ)>0
            lcClass=m.loPDM.aSpace(2)+'<td><label class="OC_Tree" for="SEL_O">'+m.loPDMs.aStrings(PDM_02739)+'</label></td>'+m.loPDM.aSpace(21)
         ENDIF
         lcClass=m.lcClass+;
                 m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                 IIF(RECC(m.lcAOBJ)>1,m.loPDM.aSpace(3)+'<select class="OC_Tree" id="SEL_O">'+m.loPDM.aSpace(21)+m.lcClassX+m.loPDM.aSpace(21)+m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                                     m.loPDM.aSpace(3)+m.loPDM.StartS+;
                                     m.loPDM.aSpace(3)+'LoadForm("SEL_O")'+m.loPDM.aSpace(21)+;
                                     m.loPDM.aSpace(3)+m.loPDM.StopS,m.lcClassX)+m.loPDM.aSpace(21)+;
                 m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)

         IF m.This.HTMLPage=_GSC_Single
            =m.loPDMs.FClose(m.lihFile)
         ENDIF
         lcScript=""
         lcHTML=m.loAPRG.GenerateClassTree(m.This,@m.llHead,@m.lcScript)

      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_d))
      ENDIF

      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_VCX
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      SELE (m.lcAlias)
      LOCATE FOR PLATFORM="COMMENT " AND UNIQUEID="Class     "
      SCATTER NAME loPIPar.RamFile MEMO

      IF USED(m.lcAlias)
         USE IN (m.lcAlias)
      ENDIF

      STORE "" TO lcDIAF,lcDIAXF
      FOR lii=1 TO m.loPDM.iDIAF
          lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
          lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
      NEXT
      IF LEN(m.lcDIAF)>0 && Yes, DIAF for file exist
         lihFile=m.loPDMs.FCreate(lcPath+lcFile_dex)
         IF lihFile>0
            m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

            llEx=.T.
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcVCXName))+;
                     m.loPDMs.GetStyles("../../")+m.lcDIAFCSS+m.lcCSS+m.lcDIAFJS+m.lcJS+m.loPDM.aSpace(21)+;
                     IIF(m.loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                     '</head>'+m.loPDM.aSpace(21)+;
                     '<body>'+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAF+m.loPDM.aSpace(21)+;
                     m.loPDMs.GenerateBackReferenceHTML(m.This.File,"","","../../")+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAXF+m.loPDM.aSPace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     "</body></html>"

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,This.nLI2,2,0,lcPathX+lcFile_dex,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcVCXName),_PDM_FG_Any+_PDM_FG_DIAX)
         ELSE
            =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%name%",lcPath+lcFile_dex))
         ENDIF
      ENDIF

      STORE m.loPDMs.FCreate(m.lcPath+m.lcHTMLName) TO lihFile
      IF m.lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05178),"%name%",m.lcVCXName))+m.loPDMs.GetStyles("../../")+m.lcCSS+m.lcJS+;
                  m.loPDM.aSpace(21)+'</head>'+m.loPDM.aSpace(21)+;
                  IIF(m.llOne,"",'<frameset framespacing="0" frameborder="1" rows="100%" cols="333,*" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05178),"%name%",lcVCXName)+'">'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'<frame name="F1" src="../../MainMenu.htm?QUICKLIST='+This.OutDir+'/'+This.HTMLList+'" noresize="true" title="'+m.loPDMs.aStrings(PDM_05102)+'">'+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+'<frameset framespacing="0" frameborder="1" rows="120,*" cols="100%" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05178),"%name%",m.lcVCXName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F2" src="'+m.lcFile_h+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05174),"%name%",m.lcVCXName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F3" src="'+;
                          IIF(LEN(m.lcDIAF)>0,lcFile_dex+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",m.lcVCXName),;
                          IIF(m.This.HTMLPage=_GSC_Single,m.lcFile_d,m.loAPRG.FirstHTML)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05175),"%name%",m.lcVCXName))+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</frameset>'+m.loPDM.aSpace(21)+;
                  IIF(m.llOne,"",'</frameset>'+m.loPDM.aSpace(21))+;
                  '</html>'

         =FWRITE(m.lihFile,m.lcString)
         =m.loPDMs.FClose(m.lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,0,0,m.lcPathX+m.lcHTMLName,0,_PDM_EF_Frame,m.This.FileName,_PDM_FG_Any+_PDM_FG_VCX)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcHTMLName))
      ENDIF

      STORE m.loPDMs.FCreate(m.lcPath+m.lcFile_h) TO lihFile
      IF m.lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05174),"%name%",m.lcVCXName))+m.loPDMs.GetStyles("../../")+m.lcCSS+;
                  IIF(RECC(m.lcAOBJ)>1,m.loPDMs.AddExternalScript("../../"+m.loPDMs.ExternJS),'')+m.lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%" rowspan="2">'+'<h2>'+m.loPDMs.aStrings(PDM_01656)+' '+m.lcVCXName+'</h2></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  IIF(EMPTY(m.lcClass),m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td>&nbsp;</td>',lcClass)+IIF(RECC(m.lcAOBJ)>1,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+' onclick="'+IIF(m.This.HTMLPage=_GSC_Multi,[go_class_m('F3','SEL_O')],[go_class('F3',']+m.lcFile_d+[','SEL_O')])+[" alt="]+m.loPDMs.aStrings(PDM_02658)+[" /></td>],m.loPDM.aSpace(2)+'<td>&nbsp;</td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  IIF(m.liCls=0,'',;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td class="a_right">'+m.loPDM.aSpace(21)+;
                  IIF(liCls=1,'',;
                  m.loPDM.aSpace(3)+'<a href="'+m.lcFile_t+'" target="F3" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05181),"%name%",m.lcVCXName)+'">'+m.loPDMs.aStrings(PDM_02790)+'</a> '+m.loPDM.aSpace(21))+;
                  IIF(m.loPDM.iGOBJ>0 AND m.loPDM.GCT.Generate=1,m.loPDM.aSpace(3)+'<a href="../../GCT.htm" target="F3" title="'+m.loPDMs.aStrings(PDM_05182)+'">'+m.loPDMs.aStrings(PDM_02791)+'</a>'+m.loPDM.aSpace(21),"")+;
                  IIF(m.llEx,m.loPDM.aSpace(3)+'<a href="'+lcFile_dex+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcVCXName)+[">]+m.loPDMs.aStrings(PDM_05046)+'</a> '+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td>&nbsp;</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td colspan="4">('+m.lcFile+')</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(m.lihFile,m.lcString)
         =m.loPDMs.FClose(m.lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,1,0,lcPathX+lcFile_h,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05174),"%name%",m.lcVCXName),_PDM_FG_None)
      ELSE
        m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_h))
      ENDIF

      IF m.liCLS>1
         STORE m.loPDMs.FCreate(m.lcPath+m.lcFile_t) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05180),"%name%",m.lcVCXName))+;
                     m.loPDMs.GetStyles("../../")+m.loPDM.GetSCCSS(lcPath)+m.lcCSS+;
                     m.loPDMs.AddExternalScript("../../"+m.loPDMs.ExternJS)+m.lcJS+;
                     m.loPDM.StartS+;
                     m.loPDMs.AddScript("ResetE_Tab")+;
                     m.loPDM.StopS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     '<h3 style="'+loPDMs.s_pbf+'">'+m.loPDMs.aStrings(PDM_02790)+'</h3>'+m.loPDM.aSpace(21)+;
                     [<div id="DIVX_0" ondblclick="window.E_Tab='.';">]+m.loPDM.aSpace(21)+;
                     IIF(!m.llHead,'',;
                         m.loPDM.aSpace(1)+[<div class="TreeRowH" ondblclick="ExpandAllDIV('0',4);">]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+[<img class="imgEC" src="../../imgs/]+m.This.aEC(_EC_Cls,2)+[" id="IMGX_0" alt="]+m.loPDMs.aStrings(PDM_02797)+[" />]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'<span class="TreeRow">'+m.loPDMs.aStrings(PDM_02797)+'</span>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(1)+'</div>'+m.loPDM.aSpace(21))+;
                     m.lcHTML+;
                     '</div>'+m.loPDM.aSpace(21)+;
                     IIF(!llHead,'',;
                         m.loPDM.StartS+;
                         STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.loPDM.RME,"%ID%","DIVX_0"),"%XType%","Main"),"%Value%",IIF(m.This.aEC(_EC_Cls,1),"true","false")),"%Dir%","../../imgs/")+;
                         m.lcScript+;
                         m.loPDM.StopS)+m.loPDM.aSpace(21)+;
                     '</body>'+m.loPDM.aSpace(21)+;
                     '</html>'+m.loPDM.aSpace(21)


            =FWRITE(m.lihFile,m.lcString)
            =m.loPDMs.FClose(m.lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,4,0,lcPathX+lcFile_t,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05180),"%name%",m.lcVCXName),_PDM_FG_Any)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_t))
         ENDIF
      ELSE
         =m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,4,0,"",0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05180),"%name%",m.lcVCXName),_PDM_FG_Any)
      ENDIF
   ENDPROC


   PROCEDURE QuickAnalyse(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev VCX souboru
      * lcHTMLName - Zkladn nzev HTML souboru

      LOCAL lcAPRC,lcAOBJ,liy,;
            m.XX101,m.XX101P,m.XX101C,m.XX100R,m.Flags,m.OBJNAME,m.XX000,m.RESERVED8,m.RESERVED6,m.BaseClass,;
            m.RESERVED4,m.RESERVED5,m.Class,m.CLASSLOC,;
            lcAlias,m.loPDM,loAPRG,m.loPDMs,llOne,liXX000

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loAPRG=m.loPDM.oAPRG
      loAPRG.Reset()
      loAPRG.iSource=_ASC_VCX
      lcAlias=SYS(2015)

      * Nyn se pokus otevt VCX knihovnu jako tabulku
      IF m.loPDMs.OpenTable(m.loPDM.DataSessionID,m.lcFile,m.lcAlias," AGAIN SHARE NOUPDATE")>0
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNO),"%File%",m.lcFile))
         RETURN _PDM_FileNO
      ENDIF

      STORE 0 TO m.XX000,m.Flags
      lcAOBJ=m.loAPRG.AOBJ
      llOne=m.loPDM.One

      STORE 0 TO m.XX101P,m.XX101C
      * Musm projet VCX a vygenerovat tdy
      SELE (m.lcAlias)
      SCAN FOR PLATFORM=="WINDOWS " AND !EMPTY(OBJNAME)
           * Jestli e je przdn parent, tak se jedn o (only form)/(formset)/(DataEnvironment)
           m.XX101=RECNO()
           m.XX100R=RECC(m.lcAOBJ)+1
           SCATTER MEMVAR MEMO
             
           IF EMPTY(PARENT) && Pozor, jde o definici objektu/tdy
              =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valClassIP),"%name%",m.OBJNAME))
              STORE 0 TO m.XX101P,m.XX101C
              INSERT INTO (m.lcAOBJ) FROM MEMVAR
              STORE m.XX101 TO m.XX101P,m.XX101C

**stop yy
              * Add class info to global list
              liXX000=m.loPDMs.AddClassInfo(m.lcFile, m.OBJNAME, m.CLASS, IIF(EMPTY(CLASSLOC),"",FULLPATH(CLASSLOC,m.lcFile)), m.RESERVED7)

              * NEPEHAZOVAT - nejdve se mus nast pole RESERVED3 a potom pole PROPERTIES
              * Analza novch vlastnost a metod (jen seznam)
              =IIF(!EMPTY(m.RESERVED3),m.loAPRG.AnalyzeProps(m.XX101,m.XX101,"",@m.RESERVED3,@m.PROTECTED,1),.T.)

              * 
              SET COLLATE TO "MACHINE"
              SELECT (loAPRG.APROPS)
              SET KEY TO BINTOC(m.XX101)
              SCAN ALL
                   m.loPDMs.AddClassPEMInfo(liXX000, OBJNAME, RESERVED7) && Add class PEM info to global list
              ENDSCAN
              SET KEY TO

              SELECT (loAPRG.APRC)
              SET KEY TO BINTOC(m.XX101)
              SCAN ALL
                   m.loPDMs.AddClassPEMInfo(liXX000, OBJNAME, RESERVED7) && Add class PEM info to global list
              ENDSCAN
              SET KEY TO
              SET COLLATE TO (m.loPDMs.Collate)

              SELE (m.lcAlias)

              * Analza naplnnch vlastnost
              =IIF(!EMPTY(m.PROPERTIES),m.loAPRG.AnalyzeProps(m.XX101,m.XX101,"",@m.PROPERTIES,"",0),.T.)

              * Find memberdata property
              SET COLLATE TO "MACHINE"
              SELECT (loAPRG.APROPS)
              SET ORDER TO "I02"
              SET KEY TO BINTOC(m.XX101)+BINTOC(VAL(SYS(2007,"_memberdata")))
              GO TOP
              IF !EOF()
                 m.loPDMs.UpdateClassInfo_MD(liXX000,VALUE) 
              ENDIF
              SET ORDER TO "I01"
              SET KEY TO
              SET COLLATE TO (m.loPDMs.Collate)

              * Analza zdrojovch kd
              =IIF(!EMPTY(m.Methods),m.loAPRG.QuickAnalyse(m.This,@m.Methods,m.XX101,m.XX101,""),.T.)

              * Detekce hlavikovho souboru
              * Peve relativn cestu na absolutn a pidej zznam do projektu
              =IIF(!m.llOne AND !EMPTY(RESERVED8),;
                    m.loPDM.AddFileToProject("T",FULLPATH(RESERVED8,m.lcFile)),.T.)
   
           ELSE
              =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valObjectIP),"%name%",m.OBJNAME))
              * Jinak jde o objekt
              liy=AT(".",m.PARENT)
              m.Objname=IIF(m.liy=0,"",SUBS(m.PARENT,m.liy+1)+".")+m.OBJNAME
              INSERT INTO (m.lcAOBJ) FROM MEMVAR

              * Analza naplnnch vlastnost
              =IIF(!EMPTY(m.PROPERTIES),m.loAPRG.AnalyzeProps(m.XX101C,m.XX101,m.ObjName,@m.PROPERTIES,"",0),.T.)

              * Analza zdrojovch kd
              =IIF(!EMPTY(m.Methods),m.loAPRG.QuickAnalyse(m.This,@m.Methods,m.XX101C,m.XX101,m.ObjName),.T.)
           ENDIF
           SELE (m.lcAlias)
      ENDSCAN

      IF USED(m.lcAlias)
         USE IN (m.lcAlias)
      ENDIF

      loAPRG.HTMLName=AppendShortFileFromFile(m.lcHTMLName,"_d") && Zkladn nzev pro jednotliv HTML strnky
      =loAPRG.GenerateAnchors(m.This) && Vygeneruje HTML kotvy td
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE PI_QuickAnalyse(lcFile,lcHTMLName)
      * lcFile     - Umstn a nzev VCX souboru
      * lcHTMLName - Zkladn nzev HTML souboru
      LOCAL lii,lcAlias,m.loPDM,m.loPDMs,loPIPar

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcAlias=SYS(2015)

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.loPDM.DataSessionID,lcFile,lcAlias," AGAIN SHARE NOUPDATE")>0
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNO),"%File%",lcFile))
         RETURN _PDM_FileNO
      ENDIF

      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_VCX
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      SELE (m.lcAlias)
      LOCATE FOR PLATFORM="COMMENT " AND UNIQUEID="Class     "
      SCATTER NAME loPIPar.RamFile MEMO

      IF USED(m.lcAlias)
         USE IN (m.lcAlias)
      ENDIF

      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(lii,2))
      NEXT

      loPIPar.Type="DIAMP"
      FOR lii=1 TO m.loPDM.iDIAMP
          =m.loPDM.aDIAMP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAMP(lii,2))
      NEXT

      loPIPar.Type="DIAP"
      FOR lii=1 TO m.loPDM.iDIAP
          =m.loPDM.aDIAP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAP(lii,2))
      NEXT

      loPIPar.Type="DIAC"
      FOR lii=1 TO m.loPDM.iDIAC
          =m.loPDM.aDIAC(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAC(lii,2))
      NEXT

      IF USED(m.lcAlias)
         USE IN (m.lcAlias)
      ENDIF
      RETURN _PDM_OK
   ENDPROC


   * Nastav zkladn nastaven
   PROCEDURE SetDefSets()
      STORE 1 TO m.This.Generate,m.This.OL_Files,;
                 m.This.OL_Classes,m.This.OL_Objects,;
                 m.This.OL_Properties,m.This.OL_Methods
      
      m.This.HTMLPage=_GSC_Multi
      STORE _SC_Collapse TO m.This.EC_Method,m.This.EC_Cls,m.This.EC_Expr
      m.This.IncludeSC=_SC_Include
      m.This.IncludeDD=_DD_Include
      m.This.GLCSS=""
      m.This.GLJS=""
      m.This.FPL.SetDefSets()
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile)
      * lcFile - PDM File
      m.This.Generate=GetINIInt("VCX","Generate",m.This.Generate,@m.lcFile)
      m.This.OL_Files=GetINIInt("VCX","OL_Files",m.This.OL_Files,@m.lcFile)
      m.This.OL_Classes=GetINIInt("VCX","OL_Classes",m.This.OL_Classes,@m.lcFile)
      m.This.OL_Objects=GetINIInt("VCX","OL_Objects",m.This.OL_Objects,@m.lcFile)
      m.This.OL_Properties=GetINIInt("VCX","OL_Properties",m.This.OL_Properties,@m.lcFile)
      m.This.OL_Methods=GetINIInt("VCX","OL_Methods",m.This.OL_Methods,@m.lcFile)
      m.This.HTMLPage=GetINIInt("VCX","HTMLPage",m.This.HTMLPage,@m.lcFile)
      m.This.EC_Method=GetINIInt("VCX","EC_Method",m.This.EC_Method,@m.lcFile)
      m.This.EC_Cls=GetINIInt("VCX","EC_Cls",m.This.EC_Cls,@m.lcFile)
      m.This.EC_Expr=GetINIInt("VCX","EC_Expr",m.This.EC_Expr,@m.lcFile)
      m.This.IncludeSC=GetINIInt("VCX","IncludeSC",m.This.IncludeSC,@m.lcFile)
      m.This.IncludeDD=GetINIInt("VCX","IncludeDD",m.This.IncludeDD,@m.lcFile)
      m.This.GLCSS=GetINIString("VCX","GLCSS",m.This.GLCSS,32000,@m.lcFile)
      m.This.GLJS=GetINIString("VCX","GLJS",m.This.GLJS,32000,@m.lcFile)
      m.This.FPL.Open(lcFile,"VCX")
      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile)
      * lcFile - PDM File
      LOCAL lcCSS,lcJS,loPDM
      =WriteINIString("VCX","Generate",STR(m.This.Generate,1),@m.lcFile)
      =WriteINIString("VCX","OL_Files",STR(m.This.OL_Files,1),@m.lcFile)
      =WriteINIString("VCX","OL_Classes",STR(m.This.OL_Classes,1),@m.lcFile)
      =WriteINIString("VCX","OL_Objects",STR(m.This.OL_Objects,1),@m.lcFile)
      =WriteINIString("VCX","OL_Properties",STR(m.This.OL_Properties,1),@m.lcFile)
      =WriteINIString("VCX","OL_Methods",STR(m.This.OL_Methods,1),@m.lcFile)
      =WriteINIString("VCX","HTMLPage",LTRIM(STR(m.This.HTMLPage,1)),@m.lcFile)
      =WriteINIString("VCX","EC_Method",STR(m.This.EC_Method,1),@m.lcFile)
      =WriteINIString("VCX","EC_Cls",STR(m.This.EC_Cls,1),@m.lcFile)
      =WriteINIString("VCX","EC_Expr",STR(m.This.EC_Expr,1),@m.lcFile)
      =WriteINIString("VCX","IncludeSC",STR(m.This.IncludeSC,1),@m.lcFile)
      =WriteINIString("VCX","IncludeDD",STR(m.This.IncludeDD,1),@m.lcFile)

      loPDM=EVALUATE(This.PDM)
      lcCSS=This.GLCSS
      lcJS=This.GLJS
      =loPDM.FormalyzeGLCSS_JS(ExtractPathFromFile(m.lcFile),@lcCSS,@lcJS)
      =WriteINIString("VCX","GLCSS",m.lcCSS,@m.lcFile)
      =WriteINIString("VCX","GLJS",m.lcJS,@m.lcFile)

      m.This.FPL.Save(lcFile,"VCX")
      RETURN _PDM_OK
   ENDPROC

ENDDEFINE
